# HalfIntegers

[![PkgEval](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/H/HalfIntegers.svg)](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html)
[![CI](https://github.com/sostock/HalfIntegers.jl/workflows/CI/badge.svg)](https://github.com/sostock/HalfIntegers.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/sostock/HalfIntegers.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/sostock/HalfIntegers.jl)

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://sostock.github.io/HalfIntegers.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://sostock.github.io/HalfIntegers.jl/dev)

This package provides data types for half-integer numbers. Here, any number *n*/2 where *n*
is an integer is considered a half-integer – contrary to the
[common definition](https://en.wikipedia.org/wiki/Half-integer),
*n* does not have to be odd, i.e., the integers are a subset of the half-integers.

For example, the `HalfInt` type provided by this package can be used to represent numbers
*n*/2 where *n* is an `Int`. Likewise, there exist half-integer types for all of Julia’s
signed and unsigned integer types, e.g., `HalfInt8`, `HalfUInt128`, and `BigHalfInt` for
arbitrarily large half-integers. All half-integer types are subtypes of the abstract type
`HalfInteger`.

## Installation

HalfIntegers.jl is compatible with Julia ≥ 1.0.
It can be installed by typing
```
] add HalfIntegers
```
in the Julia REPL or via
```julia
using Pkg; Pkg.add("HalfIntegers")
```

## Basic usage

`HalfInteger`s can be created from any other number type by using constructors or `convert`:

```julia
julia> HalfInt(-2.5)
-5/2

julia> convert(HalfUInt16, 7//2)
7/2

julia> BigHalfInt(2)
2
```

Another way of creating an `HalfInteger` is the `half` function:

```julia
julia> half(11)
11/2

julia> half(HalfInt8, -3)
-3/2
```

`HalfInteger` types support all standard arithmetic operations. Furthermore, this package
defines the function `twice`. For any number *x*, the function `twice` returns the number
2*x*. For `HalfInteger` types, it returns an `Integer` type.

```julia
julia> twice(1.5)
3.0

julia> twice(HalfInt64(1.5))
3

julia> typeof(ans)
Int64
```

## The `Half{T<:Integer}` type

All concrete half-integer types provided by this package are actually just aliases for
`Half{T}` with a specific `T`:

```julia
julia> typeof(HalfInt64(1/2))
Half{Int64}
```

The type `Half{T}` accepts arbitrary `<:Integer` types as parameter. It can be used to
define half-integers based on other (non-standard) integers. For example, since `HalfInt`
etc. are based on standard integer arithmetic, they are subject to
[integer overflow](https://docs.julialang.org/en/v1/manual/integers-and-floating-point-numbers/#Overflow-behavior-1).
If you prefer checked arithmetic, you can use the
[SaferIntegers](https://github.com/JeffreySarnoff/SaferIntegers.jl)
package and use `Half{SafeInt}` instead of `HalfInt`.

## Alternatives to this package

- [FixedPointNumbers.jl](https://github.com/JuliaMath/FixedPointNumbers.jl) implements
  numbers with a fixed number of fraction bits. Thus, the `Fixed{Int,1}` type from
  `FixedPointNumbers` can be considered equivalent to the `HalfInt` type from this package.
  However, the types behave differently in some ways. For example, multiplying two
  `Fixed{T,f}` numbers results in another `Fixed{T,f}` number, whereas multiplying two
  `HalfInteger`s results in a floating-point number.

module HalfIntegers

export
    # Abstract types
    HalfInteger,

    # Concrete types
    BigHalfInt,
    Half,
    HalfInt,
    HalfInt8,
    HalfInt16,
    HalfInt32,
    HalfInt64,
    HalfInt128,
    HalfUInt,
    HalfUInt8,
    HalfUInt16,
    HalfUInt32,
    HalfUInt64,
    HalfUInt128,
    
    # Functions
    half,
    ishalfinteger,
    onehalf,
    twice

"""
    HalfInteger <: Real

Abstract supertype for half-integers. Here, every number ``n/2`` where ``n\\in\\mathbb{Z}``
is considered a half-integer, regardless of whether ``n`` is even or odd.
"""
abstract type HalfInteger <: Real end

HalfInteger(x::Real) = HalfInt(x)
HalfInteger(x::Integer) = Half{typeof(x)}(x)
HalfInteger(x::HalfInteger) = x
HalfInteger(x::Rational{T}) where T = Half{T}(x)
HalfInteger(x::BigFloat) = BigHalfInt(x)

(T::Type{<:AbstractFloat})(x::HalfInteger) = convert(T, float(x))
(T::Type{<:Integer})(x::HalfInteger) =
    isinteger(x) ? convert(T, twice(x) >> 1) : throw(InexactError(Symbol(T), T, x))
(::Type{Bool})(x::HalfInteger) = invoke(Bool, Tuple{Real}, x)
@static if VERSION ≥ v"1.5.0-DEV.820"
    function (::Type{Rational})(x::HalfInteger)
        tx = twice(x)
        if isinteger(x)
            Base.unsafe_rational(tx >> 1, one(tx))
        else
            Base.unsafe_rational(tx, twice(one(tx)))
        end
    end
    function (::Type{Rational{T}})(x::HalfInteger) where T
        tx = twice(x)
        if isinteger(x)
            Base.unsafe_rational(T, tx >> 1, one(tx))
        else
            Base.unsafe_rational(T, tx, twice(one(tx)))
        end
    end
else
    (T::Type{<:Rational})(x::HalfInteger) = (tx=twice(x); T(tx,twice(one(tx))))
end

Base.ArithmeticStyle(::Type{<:HalfInteger}) = Base.ArithmeticWraps()

for op in (:<, :≤, :(==))
    @eval Base.$op(x::HalfInteger, y::HalfInteger) = $op(twice(x), twice(y))
    @eval Base.$op(x::HalfInteger, y::Integer) = ((pt,py)=promote(twice(x),y); $op(pt, twice(py)))
    @eval Base.$op(x::Integer, y::HalfInteger) = ((px,pt)=promote(x,twice(y)); $op(twice(px), pt))
    @eval Base.$op(x::HalfInteger, y::Rational) = $op(twice(x)*denominator(y), twice(numerator(y)))
    @eval Base.$op(x::Rational, y::HalfInteger) = $op(twice(numerator(x)), twice(y)*denominator(x))
end

Base.:+(x::T, y::T) where T<:HalfInteger = half(twice(x)+twice(y))
Base.:+(x::HalfInteger) = half(+twice(x))
Base.:-(x::T, y::T) where T<:HalfInteger = half(twice(x)-twice(y))
Base.:-(x::HalfInteger) = half(-twice(x))

Base.:*(x::T, y::T) where T<:HalfInteger = float(x)*float(y)
Base.:*(x::HalfInteger, y::Integer) = half(twice(x)*y)
Base.:*(x::Integer, y::HalfInteger) = y*x

Base.:/(x::T, y::T) where T<:HalfInteger = twice(x)/twice(y)

Base.://(x::HalfInteger, y::HalfInteger) = twice(x)//twice(y)
Base.://(x::HalfInteger, y::Real) = twice(x)//twice(y)
Base.://(x::Real, y::HalfInteger) = twice(x)//twice(y)

Base.:^(x::Real, y::HalfInteger) = x^float(y)
Base.:^(::Irrational{:ℯ}, x::HalfInteger) = exp(x)

@static if VERSION < v"1.4.0-DEV.208"
    Base.div(x::T, y::T) where T<:HalfInteger = div(twice(x), twice(y))
else
    Base.div(x::T, y::T, r::RoundingMode) where T<:HalfInteger = div(twice(x), twice(y), r)
end
Base.fld(x::T, y::T) where T<:HalfInteger = fld(twice(x), twice(y)) # can be removed in Julia 2.0
Base.cld(x::T, y::T) where T<:HalfInteger = cld(twice(x), twice(y)) # can be removed in Julia 2.0
Base.rem(x::T, y::T) where T<:HalfInteger = half(rem(twice(x), twice(y)))
Base.mod(x::T, y::T) where T<:HalfInteger = half(mod(twice(x), twice(y)))

Base.fld1(x::T, y::T) where T<:HalfInteger = fld1(twice(x), twice(y))

const HalfIntegerOrInteger = Union{HalfInteger, Integer}

# Checked arithmetic
Base.checked_abs(x::HalfInteger) = half(Base.checked_abs(twice(x)))
Base.checked_neg(x::HalfInteger) = half(Base.checked_neg(twice(x)))

# These methods are only called if at least one of the arguments is a `HalfInteger`,
# otherwise the `Base.checked_$op(::Integer, ::Integer)` methods from `Base` are used
for op in (:checked_add, :checked_sub, :checked_mod, :checked_rem)
    @eval Base.$op(x::HalfIntegerOrInteger, y::HalfIntegerOrInteger) =
        half(Base.$op(checked_twice(x), checked_twice(y)))
end
for op in (:checked_cld, :checked_div, :checked_fld)
    @eval Base.$op(x::HalfIntegerOrInteger, y::HalfIntegerOrInteger) =
        Base.$op(checked_twice(x), checked_twice(y))
end

Base.checked_mul(x::HalfInteger, y::HalfInteger) = x*y # uses float arithmetic
Base.checked_mul(x::HalfInteger, y::Integer) = half(Base.checked_mul(twice(x), y))
Base.checked_mul(x::Integer, y::HalfInteger) = Base.checked_mul(y, x)

for f in (:add_with_overflow, :sub_with_overflow)
    @eval function Base.Checked.$f(x::HalfInteger, y::HalfInteger)
        r, flag = Base.Checked.$f(twice(x), twice(y))
        half(r), flag
    end
end

Base.Checked.mul_with_overflow(x::HalfInteger, y::HalfInteger) = (x*y, false) # uses float arithmetic
function Base.Checked.mul_with_overflow(x::HalfInteger, y::Integer)
    r, flag = Base.Checked.mul_with_overflow(twice(x), y)
    half(r), flag
end
Base.Checked.mul_with_overflow(x::Integer, y::HalfInteger) = Base.Checked.mul_with_overflow(y, x)

# `lcm`/`gcd`/`gcdx` are only extended to `HalfInteger`s if they are defined for `Rational`s
@static if VERSION ≥ v"1.4.0-DEV.699"
    Base.gcd(x::HalfInteger) = x
    Base.lcm(x::HalfInteger) = x

    Base.gcd(a::T, b::T) where T<:HalfInteger = half(gcd(twice(a), twice(b)))
    Base.lcm(a::T, b::T) where T<:HalfInteger = half(lcm(twice(a), twice(b)))

    function Base.gcdx(x::T, y::T) where T<:HalfInteger
        d, u, v = gcdx(twice(x), twice(y))
        half(d), u, v
    end
end

Base.ceil(T::Type{<:Integer}, x::HalfInteger)  = round(T, x, RoundUp)
Base.floor(T::Type{<:Integer}, x::HalfInteger) = round(T, x, RoundDown)
Base.trunc(T::Type{<:Integer}, x::HalfInteger) = round(T, x, RoundToZero)

Base.round(T::Type{<:Integer}, x::HalfInteger, r::RoundingMode=RoundNearest) =
    convert(T, twice(round(x, r)) >> 1)
Base.round(T::Type{<:Integer}, x::HalfInteger, ::typeof(RoundDown)) = convert(T, twice(x) >> 1)

Base.round(x::HalfInteger, ::typeof(RoundNearest)) =
    isinteger(x)             ? +x           :
    isone(mod1(twice(x), 4)) ? x-onehalf(x) : x+onehalf(x)
Base.round(x::HalfInteger, ::typeof(RoundNearestTiesAway)) =
    isinteger(x) ? +x           :
    x < zero(x)  ? x-onehalf(x) : x+onehalf(x)
Base.round(x::HalfInteger, ::typeof(RoundNearestTiesUp)) =
    isinteger(x) ? +x : x+onehalf(x)
Base.round(x::HalfInteger, ::typeof(RoundToZero)) =
    isinteger(x) ? +x           :
    x < zero(x)  ? x+onehalf(x) : x-onehalf(x)
Base.round(x::HalfInteger, ::typeof(RoundUp)) =
    round(x, RoundNearestTiesUp)
Base.round(x::HalfInteger, ::typeof(RoundDown)) =
    isinteger(x) ? +x : x-onehalf(x)

Base.big(x::HalfInteger) = BigHalfInt(x)

Base.float(x::HalfInteger) = twice(x)/2

Base.isfinite(x::HalfInteger) = isfinite(twice(x))

Base.isinteger(x::HalfInteger) = iseven(twice(x))

@static if VERSION ≥ v"1.6.0-DEV.999"
    Base.ispow2(x::HalfInteger) = ispow2(twice(x))
end

Base.show(io::IO, x::HalfInteger) =
    isinteger(x) ? print(io, twice(x) >> 1) : print(io, twice(x), "/2")

Base.sign(x::HalfInteger) = half(twice(sign(twice(x))))

Base.denominator(x::HalfInteger) = (t=twice(x); isinteger(x) ? one(t) : twice(one(t)))
Base.numerator(x::HalfInteger)   = (t=twice(x); isinteger(x) ? t >> 1 : t)

Base.sinpi(x::HalfInteger) = sinpihalf(twice(x))
Base.cospi(x::HalfInteger) = cospihalf(twice(x))

Base.sinc(x::HalfInteger) = sinchalf(twice(x))
Base.cosc(x::HalfInteger) = coschalf(twice(x))

# Compute sin(x*π/2)
function sinpihalf(x::Integer)
    xm4 = mod(x,4)
    T = float(typeof(x))
    if (xm4 == 0) | (xm4 == 2)
        x < 0 ? -zero(T) : +zero(T)
    elseif xm4 == 1
        +one(T)
    else
        -one(T)
    end
end
# Compute cos(x*π/2)
function cospihalf(x::Integer)
    xm4 = mod(x,4)
    T = float(typeof(x))
    if (xm4 == 1) | (xm4 == 3)
        +zero(T)
    elseif xm4 == 0
        +one(T)
    else
        -one(T)
    end
end

# Compute sinc(x/2)
function sinchalf(x::Integer)
    iszero(x) && return one(float(typeof(x)))
    iseven(x) && return zero(float(typeof(x)))
    d = inv(π*x)
    isone(mod(x % Int8, Int8(4))) ? 2*d : -2*d
end
# Compute cosc(x/2)
function coschalf(x::Integer)
    T = float(typeof(x))
    iszero(x) && return zero(T)
    xm4 = mod(x % Int8, Int8(4))
    x⁻¹ = inv(x)
    if xm4 == 0
        2*x⁻¹
    elseif xm4 == 1
        (-4/convert(T, π))*x⁻¹*x⁻¹
    elseif xm4 == 2
        -2*x⁻¹
    else
        (4/convert(T, π))*x⁻¹*x⁻¹
    end
end

@static if VERSION ≥ v"1.6.0-DEV.292"
    Base.sincospi(x::HalfInteger) = sincospihalf(twice(x))

    # Compute sincos(x*π/2)
    function sincospihalf(x::Integer)
        xm4 = mod(x,4)
        T = float(typeof(x))
        if xm4 == 0
            (x < 0 ? -zero(T) : +zero(T), +one(T))
        elseif xm4 == 1
            (+one(T), +zero(T))
        elseif xm4 == 2
            (x < 0 ? -zero(T) : +zero(T), -one(T))
        else
            (-one(T), +zero(T))
        end
    end
end

Base.all(::typeof(isinteger), r::AbstractUnitRange{<:HalfInteger}) = !any(!isinteger, r)
Base.all(::typeof(!isinteger), r::AbstractUnitRange{<:HalfInteger}) = !any(isinteger, r)

Base.any(::typeof(isinteger), r::AbstractUnitRange{<:HalfInteger}) =
    !isempty(r) & isinteger(first(r))
Base.any(::typeof(!isinteger), r::AbstractUnitRange{<:HalfInteger}) =
    !isempty(r) & !isinteger(first(r))


# Hashing


Base.decompose(x::HalfInteger) = twice(x), 0, 2

Base.hash(x::HalfInteger, h::UInt) = hashhalf(twice(x), h)

# Compute hash(half(x), h)
hashhalf(x::Integer, h::UInt) = invoke(hash, Tuple{Real,UInt}, half(x), h)

# Version for integers with ≤ 64 bits, adapted from hash(::Rational{<:Base.BitInteger64}, ::UInt)
function hashhalf(x::Base.BitInteger64, h::UInt)
    iseven(x) && return hash(x >> 1, h)
    if Base.uabs(x) < UInt64(maxintfloat(Float64))
        return hash(ldexp(Float64(x),-1),h)
    end
    @static if VERSION < v"1.10.0-DEV.1448"
        h = Base.hash_integer(1, h)
    end
    h = Base.hash_integer(-1, h)
    h = Base.hash_integer(x, h)
    return h
end


"""
    half([T<:HalfInteger,] x)

For an integer value `x`, return `x/2` as a half-integer of type `T`. If `T` is not given,
return an appropriate `HalfInteger` type. Throw an `InexactError` if `x` is not an integer.

!!! compat "HalfIntegers 1.1"
    `missing` as an argument requires at least HalfIntegers 1.1.

# Examples

```jldoctest
julia> half(3)
3/2

julia> half(-5.0)
-5/2

julia> half(HalfInt16, 8)
4
```
"""
half(x::Real) = half(HalfInteger, x)
half(::Type{HalfInteger}, x::Number) = half(HalfInteger, Integer(x))
half(::Type{HalfInteger}, x::Integer) = half(Half{typeof(x)}, x)

"""
    half([T<:Complex{<:HalfInteger},] x)

For a complex value `x` with integer real and imaginary parts, return `x/2` as a complex
number of type `T`. If `T` is not given, return an appropriate complex number type with
half-integer parts. Throw an `InexactError` if the real or the imaginary part of `x` are not
integer.

!!! compat "HalfIntegers 1.1"
    `missing` as an argument requires at least HalfIntegers 1.1.

# Examples

```jldoctest
julia> half(3 + 2im)
3/2 + 1*im

julia> half(Complex{HalfInt32}, 1.0 + 5.0im)
1/2 + 5/2*im
```
"""
half(x::Complex) = half(Complex, x)
half(::Type{Complex{T}}, x::Number) where T<:HalfInteger = Complex(half(T,real(x)), half(T,imag(x)))
half(::Type{Complex}, x::Number) = Complex(half(real(x)), half(imag(x)))

half(::Missing) = missing
@static if VERSION ≥ v"1.3"
    half(::Type{T}, x) where T>:Missing = half(Base.nonmissingtype_checked(T), x)
else
    half(::Type{T}, x) where T>:Missing = half(Base.nonmissingtype(T), x)
end
half(::Type{>:Missing}, ::Missing) = missing
half(::Type{T}, ::Missing) where T =
    throw(MissingException("cannot convert a missing value to type $T: use Union{$T, Missing} instead"))


"""
    twice(x)

Return `2x`. If `x` is a `HalfInteger`, return an appropriate integer type.

!!! compat "HalfIntegers 1.1"
    `missing` as an argument requires at least HalfIntegers 1.1.

# Examples

```jldoctest
julia> twice(2)
4

julia> twice(1.5)
3.0

julia> twice(HalfInt8(3/2))  # returns an Int8
3

julia> twice(HalfInt32(3.0) + HalfInt32(2.5)*im)  # returns a Complex{Int32}
6 + 5im
```
"""
twice(x) = x + x
twice(x::Complex) = Complex(twice(real(x)), twice(imag(x)))

@static if VERSION ≥ v"1.5.0-DEV.820"
    function twice(x::Rational)
        if iseven(x.den)
            Base.unsafe_rational(oftype(x.num+x.num, x.num), x.den >> 1)
        else
            Base.unsafe_rational(Base.checked_add(x.num, x.num), oftype(x.den >> 1, x.den))
        end
    end
    function twice(x::Rational{BigInt})
        if iseven(x.den)
            Base.unsafe_rational(x.num, x.den >> 1)
        else
            Base.unsafe_rational(twice(x.num), x.den)
        end
    end
else
    function twice(x::Rational)
        if iseven(x.den)
            Rational(oftype(x.num+x.num, x.num), x.den >> 1)
        else
            Rational(Base.checked_add(x.num, x.num), oftype(x.den >> 1, x.den))
        end
    end
    function twice(x::Rational{BigInt})
        if iseven(x.den)
            Rational(x.num, x.den >> 1)
        else
            Rational(twice(x.num), x.den)
        end
    end
end

"""
    twice(T<:Integer, x)
    twice(T<:Complex{<:Integer}, x)

Return `2x` as a number of type `T`.

!!! compat "HalfIntegers 1.1"
    `missing` as an argument requires at least HalfIntegers 1.1.

# Examples

```jldoctest
julia> twice(Int16, HalfInt(5/2))
5

julia> twice(Complex{BigInt}, HalfInt(5/2) + HalfInt(3)*im)
5 + 6im
```
"""
twice(T::Type{<:Integer}, x::Number) = convert(T, twice(x))::T
twice(T::Type{<:Integer}, x::Integer) = twice(convert(T, x)::T) # convert to T first to reduce probability of overflow
twice(::Type{Complex{T}}, x::Number) where T<:Integer = Complex(twice(T,real(x)), twice(T,imag(x)))

function twice(T::Type{<:Integer}, x::Rational)
    if x.den == 1
        twice(T, x.num)
    elseif x.den == 2
        convert(T, x.num)
    else
        throw(InexactError(nameof(T), T, twice(x)))
    end
end

@static if VERSION ≥ v"1.3"
    twice(::Type{T}, x) where T>:Missing = twice(Base.nonmissingtype_checked(T), x)
else
    twice(::Type{T}, x) where T>:Missing = twice(Base.nonmissingtype(T), x)
end
twice(::Type{>:Missing}, ::Missing) = missing
twice(::Type{T}, ::Missing) where T =
    throw(MissingException("cannot convert a missing value to type $T: use Union{$T, Missing} instead"))

"""
    checked_twice(x)

Calculate `2x`, checking for overflow. (not exported)

!!! compat "HalfIntegers 1.4"
    This function requires at least HalfIntegers 1.4.

# Examples

```jldoctest
julia> x = typemax(Int64)
9223372036854775807

julia> twice(x)
-2

julia> HalfIntegers.checked_twice(x)
ERROR: OverflowError: 9223372036854775807 + 9223372036854775807 overflowed for type Int64
Stacktrace:
[...]
```
"""
checked_twice(x) = _checked_twice(Base.ArithmeticStyle(x), x)
checked_twice(x::HalfInteger) = twice(x)

_checked_twice(::Base.ArithmeticStyle, x) = twice(x)
_checked_twice(::Base.ArithmeticWraps, x) = Base.checked_add(x, x)

"""
    onehalf(x)

Return the value 1/2 in the type of `x` (`x` can also specify the type itself).

!!! compat "HalfIntegers 1.1"
    `missing` as an argument requires at least HalfIntegers 1.1.

!!! compat "HalfIntegers 1.2"
    Some abstract types as arguments require at least HalfIntegers 1.2.

# Examples

```jldoctest
julia> onehalf(7//3)
1//2

julia> onehalf(HalfInt)
1/2
```
"""
onehalf(x::Union{Number,Missing}) = onehalf(typeof(x))

onehalf(T::Type{<:Number}) = convert(T, onehalf(HalfInteger))
onehalf(T::Type{<:HalfInteger}) = half(T, 1)
onehalf(T::Type{<:AbstractFloat}) = convert(T, 0.5)
@static if VERSION ≥ v"1.5.0-DEV.820"
    onehalf(::Type{Rational}) = Base.unsafe_rational(1, 2)
    onehalf(::Type{Rational{T}}) where T = Base.unsafe_rational(T, 1, 2)
else
    onehalf(T::Type{<:Rational}) = T(1, 2)
end
onehalf(::Type{Complex{T}}) where T = Complex{T}(onehalf(T), zero(T))
onehalf(::Type{Missing}) = missing

"""
    ishalfinteger(x)

Test whether `x` is numerically equal to some half-integer.

# Examples

```jldoctest
julia> ishalfinteger(3.5)
true

julia> ishalfinteger(2)
true

julia> ishalfinteger(1//3)
false
```
"""
ishalfinteger(x) = isinteger(twice(x))
ishalfinteger(x::Rational) = (denominator(x) == 1) | (denominator(x) == 2)
ishalfinteger(::HalfIntegerOrInteger) = true
ishalfinteger(::AbstractIrrational) = false
ishalfinteger(::Missing) = missing

@static if VERSION ≥ v"1.7.0-DEV.263"
    Base.range_start_stop_length(start::T, stop::T, len::Integer) where T<:HalfInteger =
        Base._linspace(float(T), start, stop, len)
else
    Base._range(start::T, ::Nothing, stop::T, len::Integer) where T<:HalfInteger =
        Base._linspace(float(T), start, stop, len)
end

Base._linspace(::Type{T}, start::HalfInteger, stop::HalfInteger, len::Integer) where T =
    LinRange{T}(start, stop, len)
Base._linspace(::Type{T}, start::HalfInteger, stop::HalfInteger, len::Integer) where T<:Base.IEEEFloat =
    Base._linspace(T, twice(start), twice(stop), len, 2)

Base.in(x::Real, r::AbstractUnitRange{<:HalfInteger}) = 
    ishalfinteger(x) & (first(r) ≤ x ≤ last(r)) & !(isinteger(x) ⊻ isinteger(first(r)))

function Base.intersect(r::AbstractUnitRange{<:HalfInteger},
                        s::AbstractUnitRange{<:HalfIntegerOrInteger})
    fir = max(first(r),first(s))
    las = min(last(r), last(s))
    las = isinteger(first(r)) ⊻ isinteger(first(s)) ? oftype(las, fir-one(fir)) : las
    fir:las
end
Base.intersect(r::AbstractUnitRange{<:Integer}, s::AbstractUnitRange{<:HalfInteger}) = s ∩ r

function Base.intersect(r::Union{AbstractUnitRange{<:HalfInteger}, StepRange{<:HalfInteger}},
                        s::Union{AbstractUnitRange{<:HalfIntegerOrInteger},
                                 StepRange{<:HalfIntegerOrInteger}})
    # All integers are promoted to a common type T to reduce the risk of overflow
    T = promote_type(typeof(twice(first(r))), typeof(twice(step(r))),
                     typeof(twice(first(s))), typeof(twice(step(s))))
    tr = twice(T,first(r)):twice(T,step(r)):twice(T,last(r))
    ts = twice(T,first(s)):twice(T,step(s)):twice(T,last(s))
    trange = tr ∩ ts
    half(first(trange)):half(step(trange)):half(last(trange))
end
Base.intersect(r::Union{AbstractUnitRange{<:Integer}, StepRange{<:Integer}},
               s::Union{AbstractUnitRange{<:HalfInteger}, StepRange{<:HalfInteger}}) = s ∩ r

"""
    Half{T<:Integer} <: HalfInteger

Type for half-integers ``n/2`` where ``n`` is of type `T`.

Aliases for `Half{T}` are defined for all standard `Signed` and `Unsigned` integer types, so
that, e.g., `HalfInt` can be used instead of `Half{Int}`:

| `T`       | Alias for `Half{T}`                |
| :-------- | :--------------------------------- |
| `Int`     | `HalfInt`                          |
| `Int8`    | `HalfInt8`                         |
| `Int16`   | `HalfInt16`                        |
| `Int32`   | `HalfInt32`                        |
| `Int64`   | `HalfInt64`                        |
| `Int128`  | `HalfInt128`                       |
| `BigInt`  | `BigHalfInt` (*not* `HalfBigInt`!) |
| `UInt`    | `HalfUInt`                         |
| `UInt8`   | `HalfUInt8`                        |
| `UInt16`  | `HalfUInt16`                       |
| `UInt32`  | `HalfUInt32`                       |
| `UInt64`  | `HalfUInt64`                       |
| `UInt128` | `HalfUInt128`                      |
"""
struct Half{T<:Integer} <: HalfInteger
    twice::T

    global half(::Type{Half{T}}, x::Number) where T<:Integer = new{T}(x)
end
Half{T}(x::Real) where T<:Integer = half(Half{T}, twice(T,x))
Half{T}(x::Half{T}) where T<:Integer = x

twice(x::Half) = x.twice

Base.promote_rule(::Type{Half{H}}, T::Type{<:Real}) where H<:Integer = promote_type(Rational{H}, T)
Base.promote_rule(::Type{Half{H}}, T::Type{<:Integer}) where H<:Integer = Half{promote_type(H, T)}
Base.promote_rule(::Type{Half{T}}, ::Type{Half{S}}) where {T<:Integer,S<:Integer} = Half{promote_type(T,S)}

function Base.parse(T::Type{<:Half}, s::AbstractString)
    result = tryparse(T, s)
    result === nothing && throw(ArgumentError("cannot parse $(repr(s)) as $T."))
    result
end

function Base.tryparse(::Type{Half{T}}, s::AbstractString) where T<:Integer
    matched = match(r"^\s*((?:\+|-|)\s*\d+)\s*(/\s*2|)\s*$", s)
    matched === nothing && return nothing
    num = tryparse(T, matched.captures[1])
    num === nothing && return nothing
    return isempty(matched.captures[2]) ? Half{T}(num) : half(num)
end

Base.hastypemax(::Type{Half{T}}) where T<:Integer = Base.hastypemax(T)
Base.typemax(::Type{Half{T}}) where T<:Integer = half(typemax(T))
Base.typemin(::Type{Half{T}}) where T<:Integer = half(typemin(T))

Base.widen(::Type{Half{T}}) where T<:Integer = Half{widen(T)}

const HalfInt = Half{Int}
const HalfInt8 = Half{Int8}
const HalfInt16 = Half{Int16}
const HalfInt32 = Half{Int32}
const HalfInt64 = Half{Int64}
const HalfInt128 = Half{Int128}
const BigHalfInt = Half{BigInt}
const HalfUInt = Half{UInt}
const HalfUInt8 = Half{UInt8}
const HalfUInt16 = Half{UInt16}
const HalfUInt32 = Half{UInt32}
const HalfUInt64 = Half{UInt64}
const HalfUInt128 = Half{UInt128}

Base.float(::Type{BigHalfInt}) = BigFloat

Base.one(::Type{Half{T}}) where T = half(twice(one(T)))

end # module

@testset "Checked arithmetic" begin

    using Base: checked_abs, checked_neg, checked_add, checked_sub, checked_mul,
                checked_cld, checked_div, checked_fld, checked_mod, checked_rem
    using Base.Checked: add_with_overflow, sub_with_overflow, mul_with_overflow
    using HalfIntegers: checked_twice

    @testset "Base.checked_abs" begin
        for T in halfinttypes
            @eval @test checked_abs($T(5//2)) ==ₜ $T(5//2)
            @eval @test checked_abs($T(-3//2)) ==ₜ $T(3//2)
            @eval @test_throws OverflowError checked_abs(typemin($T))
            @eval @test abs(typemin($T)) ==ₜ typemin($T) # unchecked `abs` overflows
        end
        for T in halfuinttypes
            @eval @test checked_abs($T(5//2)) ==ₜ $T(5//2)
        end
        @test checked_abs(BigHalfInt(-3//2)) ==ₜ BigHalfInt(3//2)
        @test checked_abs(BigHalfInt(5//2)) ==ₜ BigHalfInt(5//2)
    end

    @testset "Base.checked_neg" begin
        for T in halfinttypes
            @eval @test checked_neg(typemax($T)) ==ₜ typemin($T) + onehalf($T)
            @eval @test_throws OverflowError checked_neg(typemin($T))
            @eval @test -typemin($T) ==ₜ typemin($T) # unchecked `-` overflows
        end
        for T in halfuinttypes
            @eval @test checked_neg(zero($T)) ==ₜ zero($T)
            @eval @test_throws OverflowError checked_neg(onehalf($T))
            @eval @test -onehalf($T) ==ₜ typemax($T) # unchecked `-` overflows
        end
        @test checked_neg(BigHalfInt(-3//2)) ==ₜ BigHalfInt(3//2)
        @test checked_neg(BigHalfInt(5//2)) ==ₜ BigHalfInt(-5//2)
    end

    @testset "HalfIntegers.checked_twice" begin
        for T in (inttypes..., uinttypes...)
            @eval @test checked_twice($T(5)) ==ₜ $T(10)
            @eval @test_throws OverflowError checked_twice(typemax($T))
            @eval @test checked_twice(typemax(Half{$T})) ==ₜ typemax($T)
        end
        @test twice(typemax(Int)) ==ₜ -2 # unchecked `twice` overflows
        @test twice(typemax(UInt)) ==ₜ typemax(UInt) - one(UInt) # unchecked `twice` overflows
        @test checked_twice(BigInt(100)) ==ₜ BigInt(200)
        @test checked_twice(BigHalfInt(100)) ==ₜ BigInt(200)
        @test checked_twice(0.375) ==ₜ 0.75
        @test checked_twice(3//8) ==ₜ 3//4
    end

    @testset "Base.checked_add" begin
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test checked_add($T(5//2), $T(3//2)) ==ₜ $T(4)
            @eval @test_throws OverflowError checked_add(typemax($T), one($T))
            @eval @test typemax($T) + onehalf($T) == typemin($T) # unchecked `+` overflows
        end
        @test checked_add(BigHalfInt(5//2), BigHalfInt(-3//2)) ==ₜ BigHalfInt(1)
        # Mixed HalfInteger types
        @test_throws InexactError checked_add(HalfInt(-1), HalfUInt(3/2))
        @test_throws InexactError checked_add(HalfInt(-2), HalfUInt(3/2))
        @test_broken HalfInt(-1) + HalfUInt(3/2) ==ₜ HalfUInt(1/2) # This should work, since it matches the Integer behavior
        @test_broken HalfInt(-2) + HalfUInt(3/2) ==ₜ typemax(HalfUInt) # This should work, since it matches the Integer behavior
        # Mixed Integer/HalfInteger
        @test checked_add(HalfInt8(50), Int8(10)) ==ₜ HalfInt8(60)
        @test_throws OverflowError checked_add(HalfInt8(50), Int8(100))
        @test_throws OverflowError checked_add(HalfInt8(-50), Int8(100))
        @test HalfInt8(50) + Int8(100) ==ₜ HalfInt8(22) # (100 + 200) % Int8 == 44
        @test HalfInt8(-50) + Int8(100) ==ₜ HalfInt8(50) # (-100 + 200) % Int8 == 100
    end

    @testset "Base.checked_sub" begin
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test checked_sub($T(5//2), $T(3//2)) ==ₜ $T(1)
            @eval @test_throws OverflowError checked_sub(typemin($T), one($T))
            @eval @test typemin($T) - onehalf($T) == typemax($T) # unchecked `-` overflows
        end
        @test checked_sub(BigHalfInt(5//2), BigHalfInt(-3//2)) ==ₜ BigHalfInt(4)
        # Mixed HalfInteger types
        @test_throws InexactError checked_sub(HalfUInt(3/2), HalfInt(-1))
        @test_throws InexactError checked_sub(HalfInt(-1/2), HalfUInt(0))
        @test_broken HalfUInt(3/2) - HalfInt(-1) ==ₜ HalfUInt(5/2) # This should work, since it matches the Integer behavior
        @test_broken HalfInt(-1/2) - HalfUInt(0) ==ₜ typemax(HalfUInt) # This should work, since it matches the Integer behavior
        # Mixed Integer/HalfInteger
        @test checked_sub(HalfInt8(50), Int8(10)) ==ₜ HalfInt8(40)
        @test_throws OverflowError checked_sub(HalfInt8(50), Int8(100))
        @test_throws OverflowError checked_sub(HalfInt8(-50), Int8(100))
        @test HalfInt8(50) - Int8(100) ==ₜ HalfInt8(-50) # (100 - 200) % Int8 == -100
        @test HalfInt8(-50) - Int8(100) ==ₜ HalfInt8(-22) # (-100 - 200) % Int8 == -44
    end

    @testset "Base.checked_mul" begin
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test typemax($T) * one($T) ==ₜ float(typemax($T)) # `*(::HalfInteger, ::HalfInteger)` uses float arithmetic, so no overflow
            @eval @test checked_mul(typemax($T), one($T)) ==ₜ float(typemax($T))
        end
        @test checked_mul(BigHalfInt(7/2), BigHalfInt(3/2)) ==ₜ BigFloat(5.25)
        # Mixed HalfInteger types
        @test checked_mul(HalfInt8(7/2), HalfUInt16(3/2)) ==ₜ 5.25
        # Mixed HalfInteger/Integer
        @test Int8(100) * HalfInt8(1) == HalfInt8(-28) # (100*2) % Int8 == -56
        @test HalfInt8(50) * Int8(2) == HalfInt8(-28) # (100*2) % Int8 == -56
        @test_throws OverflowError checked_mul(Int8(100), HalfInt8(1))
        @test_throws OverflowError checked_mul(HalfInt8(50), Int8(2))
    end

    @testset "Base.$checked_op" for (op, checked_op) = ((:cld,:checked_cld), (:div,:checked_div), (:fld,:checked_fld))
        for T in inttypes
            @eval @test_throws DivideError $op(typemin(Half{$T}), Half{$T}(-1/2)) # op is already checked
            @eval @test_throws DivideError $checked_op(typemin(Half{$T}), Half{$T}(-1/2))
            @eval @test $checked_op(Half{$T}(6), Half{$T}(5/2)) ==ₜ $op(Half{$T}(6), Half{$T}(5/2))
            @eval @test $checked_op(Half{$T}(-6), Half{$T}(5/2)) ==ₜ $op(Half{$T}(-6), Half{$T}(5/2))
        end
        for T in uinttypes
            @eval @test $checked_op(Half{$T}(6), Half{$T}(5/2)) ==ₜ $op(Half{$T}(6), Half{$T}(5/2))
        end
        @eval @test $checked_op(BigHalfInt(6), BigHalfInt(5/2)) ==ₜ $op(BigHalfInt(6), BigHalfInt(5/2))
        @eval @test $checked_op(-BigHalfInt(6), BigHalfInt(5/2)) ==ₜ $op(-BigHalfInt(6), BigHalfInt(5/2))
        # Mixed HalfInteger/Integer
        for T in (inttypes..., uinttypes...)
            @eval @test $checked_op($T(6), Half{$T}(5/2)) ==ₜ $op($T(6), Half{$T}(5/2))
            @eval @test $checked_op(Half{$T}(15/2), $T(5)) ==ₜ $op(Half{$T}(15/2), $T(5))
            @eval @test_throws OverflowError $checked_op(typemax($T), Half{$T}(5/2))
            @eval @test_throws OverflowError $checked_op(Half{$T}(15/2), typemax($T))
            @eval @test_broken try; $op(typemax($T), Half{$T}(5/2)); catch e; e; end isa OverflowError
            @eval @test_broken try; $op(Half{$T}(15/2), typemax($T)); catch e; e; end isa OverflowError
        end
        @eval @test $checked_op(BigInt(6), BigHalfInt(5/2)) ==ₜ $op(BigInt(6), BigHalfInt(5/2))
        @eval @test $checked_op(-BigInt(6), BigHalfInt(5/2)) ==ₜ $op(-BigInt(6), BigHalfInt(5/2))
        @eval @test $checked_op(BigHalfInt(15/2), BigInt(5)) ==ₜ $op(BigHalfInt(15/2), BigInt(5))
        @eval @test $checked_op(-BigHalfInt(15/2), BigInt(5)) ==ₜ $op(-BigHalfInt(15/2), BigInt(5))
    end

    @testset "Base.$checked_op" for (op, checked_op) = ((:mod,:checked_mod), (:rem,:checked_rem))
        for T in (inttypes..., :BigInt)
            @eval @test $checked_op(Half{$T}(6), Half{$T}(5/2)) ==ₜ $op(Half{$T}(6), Half{$T}(5/2))
            @eval @test $checked_op(Half{$T}(-6), Half{$T}(5/2)) ==ₜ $op(Half{$T}(-6), Half{$T}(5/2))
        end
        for T in uinttypes
            @eval @test $checked_op(Half{$T}(6), Half{$T}(5/2)) ==ₜ $op(Half{$T}(6), Half{$T}(5/2))
        end
        # Mixed HalfInteger/Integer
        for T in (inttypes..., uinttypes...)
            @eval @test $checked_op($T(6), Half{$T}(5/2)) ==ₜ $op($T(6), Half{$T}(5/2))
            @eval @test $checked_op(Half{$T}(15/2), $T(5)) ==ₜ $op(Half{$T}(15/2), $T(5))
            @eval @test_throws OverflowError $checked_op(typemax($T), Half{$T}(5/2))
            @eval @test_throws OverflowError $checked_op(Half{$T}(15/2), typemax($T))
            @eval @test_broken try; $op(typemax($T), Half{$T}(5/2)); catch e; e; end isa OverflowError
            @eval @test_broken try; $op(Half{$T}(15/2), typemax($T)); catch e; e; end isa OverflowError
        end
        @eval @test $checked_op(BigInt(6), BigHalfInt(5/2)) ==ₜ $op(BigInt(6), BigHalfInt(5/2))
        @eval @test $checked_op(-BigInt(6), BigHalfInt(5/2)) ==ₜ $op(-BigInt(6), BigHalfInt(5/2))
        @eval @test $checked_op(BigHalfInt(15/2), BigInt(5)) ==ₜ $op(BigHalfInt(15/2), BigInt(5))
        @eval @test $checked_op(-BigHalfInt(15/2), BigInt(5)) ==ₜ $op(-BigHalfInt(15/2), BigInt(5))
    end

    @testset "Base.Checked.add_with_overflow" begin
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test add_with_overflow($T(5//2), $T(3//2)) ==ₜ ($T(4), false)
            @eval @test add_with_overflow(typemax($T), onehalf($T)) ==ₜ (typemin($T), true)
        end
        @test add_with_overflow(BigHalfInt(5//2), BigHalfInt(-3//2)) ==ₜ (BigHalfInt(1), false)
    end

    @testset "Base.Checked.sub_with_overflow" begin
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test sub_with_overflow($T(5//2), $T(3//2)) ==ₜ ($T(1), false)
            @eval @test sub_with_overflow(typemin($T), onehalf($T)) ==ₜ (typemax($T), true)
        end
        @test sub_with_overflow(BigHalfInt(5//2), BigHalfInt(-3//2)) ==ₜ (BigHalfInt(4), false)
    end

    @testset "Base.Checked.mul_with_overflow" begin
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test mul_with_overflow(typemax($T), one($T)) ==ₜ (float(typemax($T)), false)
        end
        @test mul_with_overflow(BigHalfInt(7/2), BigHalfInt(3/2)) ==ₜ (BigFloat(5.25), false)
        # Mixed HalfInteger types
        @test mul_with_overflow(HalfInt8(7/2), HalfUInt16(3/2)) ==ₜ (5.25, false)
        # Mixed HalfInteger/Integer
        @test mul_with_overflow(Int(100), HalfInt(3/2)) ==ₜ (HalfInt(150), false)
        @test mul_with_overflow(Int8(100), HalfInt8(3/2)) ==ₜ (HalfInt8(22), true)
        @test mul_with_overflow(HalfInt(101/2), Int(2)) ==ₜ (HalfInt(101), false)
        @test mul_with_overflow(HalfInt8(101/2), Int8(2)) ==ₜ (HalfInt8(-27), true)
    end

    @static if VERSION ≥ v"1.1"
        # In Julia < 1.1, zero(Half{T}) and one(Half{T}) do not work for
        # T ∈ [SafeInt8, SafeInt16, SafeUInt8, SafeUInt16] due to a bug in Julia, cf.
        # https://github.com/JuliaLang/julia/issues/32203

        using SaferIntegers

        safeinttypes  = (:SafeInt, :SafeInt8, :SafeInt16, :SafeInt32, :SafeInt64, :SafeInt128)
        safeuinttypes = (:SafeUInt, :SafeUInt8, :SafeUInt16, :SafeUInt32, :SafeUInt64, :SafeUInt128)

        @testset "SaferIntegers" begin
            @test_throws OverflowError Half{SafeInt8}(typemax(Int8))
            @test_throws OverflowError typemax(Half{SafeInt8}) + one(HalfInt8)
            @test_throws OverflowError typemax(Half{SafeInt8}) + one(Int8)
            @test_throws OverflowError typemin(Half{SafeInt8}) - one(HalfInt8)
            @test_throws OverflowError typemin(Half{SafeInt8}) - one(Int8)
            for T in safeinttypes
                @eval @test HalfInteger(one($T)) === one(Half{$T})
                @eval @test_throws OverflowError Half{$T}(typemax($T))
                @eval @test_throws OverflowError Half{$T}(typemin($T))
                @eval @test_throws OverflowError Half{$T}(typemax($T)//one($T))
                @eval @test_throws OverflowError Half{$T}(typemin($T)//one($T))
                @eval @test_throws OverflowError Half{$T}(complex(typemax($T)))
                @eval @test_throws OverflowError Half{$T}(complex(typemin($T)))
                @eval @test_throws OverflowError Half{$T}(complex(typemax($T)//one($T)))
                @eval @test_throws OverflowError Half{$T}(complex(typemin($T)//one($T)))
                @eval @test_throws OverflowError -typemin(Half{$T})
                @eval @test_throws OverflowError abs(typemin(Half{$T}))
                @eval @test_throws OverflowError flipsign(typemin(Half{$T}), -1)
                @eval @test_throws OverflowError typemax(Half{$T}) + onehalf(Half{$T})
                @eval @test_throws OverflowError typemin(Half{$T}) - onehalf(Half{$T})
                @eval @test_throws OverflowError twice(typemax($T))
                @eval @test_throws OverflowError twice(typemin($T))
                @eval @test_throws OverflowError round(typemax(Half{$T}))
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundNearest)
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundNearestTiesAway)
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundNearestTiesUp)
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundUp)
            end
            for T in safeuinttypes
                @eval @test HalfInteger(one($T)) === one(Half{$T})
                @eval @test_throws OverflowError Half{$T}(typemax($T))
                @eval @test_throws OverflowError Half{$T}(typemax($T)//one($T))
                @eval @test_throws OverflowError Half{$T}(complex(typemax($T)))
                @eval @test_throws OverflowError Half{$T}(complex(typemax($T)//one($T)))
                @eval @test_throws OverflowError -onehalf(Half{$T})
                @eval @test_throws OverflowError flipsign(onehalf(Half{$T}), -1)
                @eval @test_throws OverflowError typemax(Half{$T}) + onehalf(Half{$T})
                @eval @test_throws OverflowError typemin(Half{$T}) - onehalf(Half{$T})
                @eval @test_throws OverflowError twice(typemax($T))
                @eval @test_throws OverflowError round(typemax(Half{$T}))
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundNearest)
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundNearestTiesAway)
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundNearestTiesUp)
                @eval @test_throws OverflowError round(typemax(Half{$T}), RoundUp)
            end
        end
    end
end

import HalfIntegers

struct MyHalfInt <: HalfInteger
    val::HalfInt
end

MyHalfInt(x::MyHalfInt) = x

HalfIntegers.half(::Type{MyHalfInt}, x) = MyHalfInt(half(HalfInt, x))
HalfIntegers.twice(x::MyHalfInt) = twice(x.val)

struct One <: Integer end
Base.promote_rule(::Type{One}, ::Type{T}) where {T<:Number} = promote_type(Bool, T)
Base.Int(::One) = 1
Base.iseven(::One) = false
Base.one(::One) = One()
Base.sign(::One) = One()
Base.:+(x::One, y::One) = 2
Base.convert(::Type{One}, x::Int) = x == 1 ? One() : error("can't convert $x to One")

@testset "Custom types" begin
    @testset "Construction" begin
        @test MyHalfInt(2.5) isa MyHalfInt
        @test MyHalfInt(3) isa MyHalfInt
        @test MyHalfInt(3//2) isa MyHalfInt
        @test_throws InexactError MyHalfInt(2.6)
        @test half(MyHalfInt, 1) === MyHalfInt(1/2)
        @test onehalf(MyHalfInt) === MyHalfInt(1/2)
        @test one(MyHalfInt) === MyHalfInt(1)
        @test zero(MyHalfInt) === MyHalfInt(0)
    end

    @testset "Conversion" begin
        @test big(MyHalfInt(3//2)) isa BigHalfInt
        @test big(MyHalfInt(3//2)) == 3/2
        @test HalfInteger(MyHalfInt(5/2)) === MyHalfInt(5/2)
        @test HalfInt(MyHalfInt(5/2)) === HalfInt(5/2)
        @test complex(MyHalfInt(5/2)) === Complex(MyHalfInt(5/2), MyHalfInt(0))
        @test float(MyHalfInt(5/2)) === 2.5
        @test Rational(MyHalfInt(5/2)) === 5//2
        @test Float64(MyHalfInt(5/2)) === 2.5
        @test Bool(MyHalfInt(1)) === true
        @test UInt32(MyHalfInt(4)) === UInt32(4)
        @test_throws InexactError Integer(MyHalfInt(3/2))
        @test_throws InexactError Int(MyHalfInt(3/2))
        @test_throws InexactError UInt(MyHalfInt(-1))

        @test @inferred(half(One())) isa Half{One}
        @test @inferred(sign(half(One()))) == 1
        @test @inferred(numerator(half(One()))) == 1
        @test @inferred(denominator(half(One()))) == 2
        @test @inferred(Rational(half(One()))) == 1//2
        @test @inferred(Rational{Int}(half(One()))) == 1//2

        @test Half{One}(half(One())) === half(One())
        @test Half{One}(half(1)) === half(One())

        @test one(half(One())) == 1
        @test one(half(One())) * half(One()) == half(One())
    end

    @testset "Properties" begin
        @test isfinite(MyHalfInt(2))
        @test ishalfinteger(MyHalfInt(3/2))
        @test isinteger(MyHalfInt(3))
        @test !isinteger(MyHalfInt(3/2))
        @test iszero(MyHalfInt(0))
        @test !iszero(MyHalfInt(1/2))
        @test isone(MyHalfInt(1))
        @test !isone(MyHalfInt(1/2))
        @test numerator(MyHalfInt(3/2)) === 3
        @test denominator(MyHalfInt(3/2)) === 2
        @test numerator(MyHalfInt(4)) === 4
        @test denominator(MyHalfInt(4)) === 1
    end

    @testset "Comparison" begin
        @test MyHalfInt(2) == MyHalfInt(2)
        @test MyHalfInt(2) != MyHalfInt(5/2)
        @test MyHalfInt(2) < MyHalfInt(5/2)
        @test MyHalfInt(2) ≤ MyHalfInt(5/2)
    end

    @testset "Hashing" begin
        @test hash(MyHalfInt(1)) === hash(1)
        @test hash(MyHalfInt(1/2)) === hash(1//2)
    end

    @testset "Trigonometry" begin
        for x = [typemax(HalfInt), typemax(HalfInt)-HalfInt(1/2),
                 typemax(HalfInt)-HalfInt(1), typemax(HalfInt)-HalfInt(3/2),
                 typemin(HalfInt), typemin(HalfInt)+HalfInt(1/2),
                 typemin(HalfInt)+HalfInt(1), typemin(HalfInt)+HalfInt(3/2)]
            @test sinpi(MyHalfInt(x)) === sinpi(x)
            @test cospi(MyHalfInt(x)) === cospi(x)
            @static if VERSION ≥ v"1.6.0-DEV.292"
                @test sincospi(MyHalfInt(x)) === sincospi(x)
            end
        end
    end

    @testset "string" begin
        @test string(MyHalfInt(3/2)) === "3/2"
        @test string(MyHalfInt(-4)) === "-4"
    end

    @testset "Arithmetic (not customized)" begin
        @test +MyHalfInt(3/2) === HalfInt(3/2)
        @test -MyHalfInt(3/2) === HalfInt(-3/2)
        @test MyHalfInt(2) + MyHalfInt(3/2) === HalfInt(7/2)
        @test MyHalfInt(2) - MyHalfInt(3/2) === HalfInt(1/2)
        @test MyHalfInt(7/2) * MyHalfInt(2) === 7.0
        @test MyHalfInt(7/2) / MyHalfInt(2) === 1.75
        @test MyHalfInt(2) \ MyHalfInt(7/2) === 1.75
        @test MyHalfInt(7/2) // MyHalfInt(2) === 7//4
        @test div(MyHalfInt(7/2), MyHalfInt(3/2)) == 2
        @test fld(MyHalfInt(7/2), MyHalfInt(3/2)) == 2
        @test cld(MyHalfInt(7/2), MyHalfInt(3/2)) == 3
        @test rem(MyHalfInt(7/2), MyHalfInt(3/2)) === HalfInt(1/2)
        @test mod(MyHalfInt(7/2), MyHalfInt(3/2)) === HalfInt(1/2)
        @test fld1(MyHalfInt(7/2), MyHalfInt(3/2)) == 3
        @test mod1(MyHalfInt(7/2), MyHalfInt(3/2)) === HalfInt(1/2)
        @test 2^MyHalfInt(5/2) ≈ √32
        @test MyHalfInt(2)^4 ≈ 16
        @test abs(MyHalfInt(-7/2)) === HalfInt(7/2)
        @test abs2(MyHalfInt(-7/2)) === 12.25
        @test sign(MyHalfInt(0)) == 0
        @test sign(MyHalfInt(-1/2)) == -1
        @test sign(MyHalfInt(3)) == 1
        @test signbit(MyHalfInt(0)) === false
        @test signbit(MyHalfInt(3)) === false
        @test signbit(MyHalfInt(-1/2)) === true
        @test flipsign(MyHalfInt(3), -1) === HalfInt(-3)
        @test flipsign(MyHalfInt(5/2), 0) === HalfInt(5/2)
        @test flipsign(MyHalfInt(5/2), MyHalfInt(7/2)) === HalfInt(5/2)
        @test round(MyHalfInt(5/2)) === HalfInt(2)
        @test round(MyHalfInt(5/2), RoundNearest) === HalfInt(2)
        @test round(MyHalfInt(5/2), RoundNearestTiesAway) === HalfInt(3)
        @test round(MyHalfInt(5/2), RoundNearestTiesUp) === HalfInt(3)
        @test round(MyHalfInt(5/2), RoundToZero) === HalfInt(2)
        @test round(MyHalfInt(5/2), RoundDown) === HalfInt(2)
        @test round(MyHalfInt(5/2), RoundUp) === HalfInt(3)
        @test round(Int, MyHalfInt(5/2)) === 2
        @test round(Int, MyHalfInt(5/2), RoundNearest) === 2
        @test round(Int, MyHalfInt(5/2), RoundNearestTiesAway) === 3
        @test round(Int, MyHalfInt(5/2), RoundNearestTiesUp) === 3
        @test round(Int, MyHalfInt(5/2), RoundToZero) === 2
        @test round(Int, MyHalfInt(5/2), RoundDown) === 2
        @test round(Int, MyHalfInt(5/2), RoundUp) === 3
        @test ceil(MyHalfInt(7/2)) === HalfInt(4)
        @test floor(MyHalfInt(7/2)) === HalfInt(3)
        @test trunc(MyHalfInt(7/2)) === HalfInt(3)
        @test ceil(Int, MyHalfInt(7/2)) === 4
        @test floor(Int, MyHalfInt(7/2)) === 3
        @test trunc(Int, MyHalfInt(7/2)) === 3
    end

    Base.promote_rule(::Type{MyHalfInt}, T::Type{<:Real}) = promote_type(HalfInt, T)

    @testset "Promotion" begin
        @test MyHalfInt(2) == 2
        @test MyHalfInt(2) == 2//1
        @test MyHalfInt(2) == 2.0
        @test MyHalfInt(2) != nextfloat(2.0)
        @test MyHalfInt(3/2) < 2.6
        @test MyHalfInt(2)^MyHalfInt(4) ≈ 16
        @test MyHalfInt(2) + 3 === HalfInt(5)
    end

    @testset "Ranges" begin
        @testset "UnitRange" begin
            @test MyHalfInt(1/2):MyHalfInt(5) isa UnitRange{MyHalfInt}
            @test MyHalfInt(1/2):MyHalfInt(5) === MyHalfInt(1/2):MyHalfInt(9/2)
            @test first(MyHalfInt(1/2):MyHalfInt(5)) === MyHalfInt(1/2)
            @test last(MyHalfInt(1/2):MyHalfInt(5)) === MyHalfInt(9/2)
            @test length(MyHalfInt(1/2):MyHalfInt(5)) == 5
            @test isempty(MyHalfInt(1):MyHalfInt(1/2))
            @test 2.5 ∈ MyHalfInt(1/2):MyHalfInt(5)
            @test !any(isinteger, MyHalfInt(1/2):MyHalfInt(5))
        end

        @testset "StepRange" begin
            @test MyHalfInt(2):MyHalfInt(1/2):MyHalfInt(5) isa StepRange{MyHalfInt,MyHalfInt}
            @test MyHalfInt(2):MyHalfInt(2):MyHalfInt(5) === MyHalfInt(2):MyHalfInt(2):MyHalfInt(4)
            @test first(MyHalfInt(2):MyHalfInt(1/2):MyHalfInt(5)) === MyHalfInt(2)
            @test last(MyHalfInt(2):MyHalfInt(1/2):MyHalfInt(5)) === MyHalfInt(5)
            @test length(MyHalfInt(2):MyHalfInt(1/2):MyHalfInt(5)) == 7
            @test 2.5 ∈ MyHalfInt(2):MyHalfInt(1/2):MyHalfInt(5)
        end

        @test @inferred(intersect(MyHalfInt(1/2):MyHalfInt(2), MyHalfInt(3/2):MyHalfInt(3))) === MyHalfInt(3/2):MyHalfInt(3/2)
        @test isempty(intersect(MyHalfInt(1/2):MyHalfInt(2), MyHalfInt(1):MyHalfInt(3)))
        @test @inferred(intersect(MyHalfInt(3/2):MyHalfInt(3/2):MyHalfInt(15/2), MyHalfInt(2):MyHalfInt(1):MyHalfInt(9))) ==
            3:3:6
        @test @inferred(reverse(MyHalfInt(1/2):MyHalfInt(3/2))) == MyHalfInt(3/2):MyHalfInt(-1):MyHalfInt(1/2)
    end

    Base.:+(x::MyHalfInt) = x
    Base.:+(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(x.val + y.val)

    Base.:-(x::MyHalfInt) = MyHalfInt(-x.val)
    Base.:-(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(x.val - y.val)

    Base.mod(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(mod(x.val, y.val))
    Base.rem(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(rem(x.val, y.val))

    Base.:*(x::MyHalfInt, y::MyHalfInt) = twice(x)*twice(y)//4
    Base.:/(x::MyHalfInt, y::MyHalfInt) = twice(x)//twice(y)

    @testset "Arithmetic (customized)" begin
        @test +MyHalfInt(3/2) === MyHalfInt(3/2)
        @test -MyHalfInt(3/2) === MyHalfInt(-3/2)
        @test MyHalfInt(2) + MyHalfInt(3/2) === MyHalfInt(7/2)
        @test MyHalfInt(2) - MyHalfInt(3/2) === MyHalfInt(1/2)
        @test MyHalfInt(7/2) * MyHalfInt(2) === 7//1
        @test MyHalfInt(7/2) / MyHalfInt(2) === 7//4
        @test MyHalfInt(2) \ MyHalfInt(7/2) === 7//4
        @test MyHalfInt(7/2) // MyHalfInt(2) === 7//4
        @test div(MyHalfInt(7/2), MyHalfInt(3/2)) == 2
        @test fld(MyHalfInt(7/2), MyHalfInt(3/2)) == 2
        @test cld(MyHalfInt(7/2), MyHalfInt(3/2)) == 3
        @test rem(MyHalfInt(7/2), MyHalfInt(3/2)) === MyHalfInt(1/2)
        @test mod(MyHalfInt(7/2), MyHalfInt(3/2)) === MyHalfInt(1/2)
        @test fld1(MyHalfInt(7/2), MyHalfInt(3/2)) == 3
        @test mod1(MyHalfInt(7/2), MyHalfInt(3/2)) === MyHalfInt(1/2)
        @test 2^MyHalfInt(5/2) ≈ √32
        @test MyHalfInt(2)^4 ≈ 16
        @test abs(MyHalfInt(-7/2)) === MyHalfInt(7/2)
        @test abs2(MyHalfInt(-7/2)) === 49//4
        @test sign(MyHalfInt(0)) == 0
        @test sign(MyHalfInt(-1/2)) == -1
        @test sign(MyHalfInt(3)) == 1
        @test signbit(MyHalfInt(0)) === false
        @test signbit(MyHalfInt(3)) === false
        @test signbit(MyHalfInt(-1/2)) === true
        @test flipsign(MyHalfInt(3), -1) === MyHalfInt(-3)
        @test flipsign(MyHalfInt(5/2), 0) === MyHalfInt(5/2)
        @test flipsign(MyHalfInt(5/2), MyHalfInt(7/2)) === MyHalfInt(5/2)
        @test round(MyHalfInt(5/2)) === MyHalfInt(2)
        @test round(MyHalfInt(5/2), RoundNearest) === MyHalfInt(2)
        @test round(MyHalfInt(5/2), RoundNearestTiesAway) === MyHalfInt(3)
        @test round(MyHalfInt(5/2), RoundNearestTiesUp) === MyHalfInt(3)
        @test round(MyHalfInt(5/2), RoundToZero) === MyHalfInt(2)
        @test round(MyHalfInt(5/2), RoundDown) === MyHalfInt(2)
        @test round(MyHalfInt(5/2), RoundUp) === MyHalfInt(3)
        @test round(Int, MyHalfInt(5/2)) === 2
        @test round(Int, MyHalfInt(5/2), RoundNearest) === 2
        @test round(Int, MyHalfInt(5/2), RoundNearestTiesAway) === 3
        @test round(Int, MyHalfInt(5/2), RoundNearestTiesUp) === 3
        @test round(Int, MyHalfInt(5/2), RoundToZero) === 2
        @test round(Int, MyHalfInt(5/2), RoundDown) === 2
        @test round(Int, MyHalfInt(5/2), RoundUp) === 3
        @test ceil(MyHalfInt(7/2)) === MyHalfInt(4)
        @test floor(MyHalfInt(7/2)) === MyHalfInt(3)
        @test trunc(MyHalfInt(7/2)) === MyHalfInt(3)
        @test ceil(Int, MyHalfInt(7/2)) === 4
        @test floor(Int, MyHalfInt(7/2)) === 3
        @test trunc(Int, MyHalfInt(7/2)) === 3
    end
end

using Documenter
using HalfIntegers

DocMeta.setdocmeta!(HalfIntegers, :DocTestSetup, :(using HalfIntegers))

makedocs(
    sitename = "HalfIntegers.jl",
    format = Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true"),
    modules = [HalfIntegers],
    pages = [
             "Home" => "index.md",
             "Manual" => "manual.md",
             "API documentation" => "api.md"
            ]
)

deploydocs(
    repo = "github.com/sostock/HalfIntegers.jl.git"
)

const StepRangeOrStepRangeLen{T} = Union{StepRange{T}, StepRangeLen{T}}
@testset "Ranges" begin
    # @test range(half(1), half(2), length=3)[2]

    @testset "UnitRange" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test UnitRange{$T}(1//2, 5//1) isa UnitRange{$T}
            @eval @test UnitRange($T(1/2), $T(5)) isa UnitRange{$T}
            @eval @test $T(1/2):$T(5) isa UnitRange{$T}
            @eval @test $T(1/2):big(5) isa UnitRange{BigHalfInt}
            @eval @test first($T(1/2):$T(5)) == $T(1/2)
            @eval @test last($T(1/2):$T(5)) == $T(9/2)
            @eval @test length($T(1/2):$T(5)) == 5
            @eval @test length($T(1/2):$T(0)) == 0
            @eval @test length($T(1/2):$T(1/2)) == 1
            @eval @test length($T(1/2):$T(1)) == 1
            @eval @test $T(5/2) ∉ $T(1):$T(5)
            @eval @test $T(5/2) ∈ $T(1/2):$T(5)
            @eval @test $T(2) ∈ $T(1):$T(5)
            @eval @test $T(2) ∉ $T(1/2):$T(5)
            @eval @test 2.5 ∉ $T(1):$T(5)
            @eval @test 2.5 ∈ $T(1/2):$T(5)
            @eval @test 5//2 ∉ $T(1):$T(5)
            @eval @test 5//2 ∈ $T(1/2):$T(5)
            @eval @test 2 ∈ $T(1):$T(5)
            @eval @test 2 ∉ $T(1/2):$T(5)

            @eval @test any(isinteger, $T(1):$T(5))
            @eval @test !any(isinteger, $T(1):$T(0))
            @eval @test !any(isinteger, $T(1/2):$T(5))
            @eval @test !any(isinteger, $T(3/2):$T(0))
            @eval @test !any(!isinteger, $T(1):$T(5))
            @eval @test !any(!isinteger, $T(1):$T(0))
            @eval @test any(!isinteger, $T(1/2):$T(5))
            @eval @test !any(!isinteger, $T(3/2):$T(0))

            @eval @test all(isinteger, $T(1):$T(5))
            @eval @test all(isinteger, $T(1):$T(0))
            @eval @test !all(isinteger, $T(1/2):$T(5))
            @eval @test all(isinteger, $T(3/2):$T(0))
            @eval @test !all(!isinteger, $T(1):$T(5))
            @eval @test all(!isinteger, $T(1):$T(0))
            @eval @test all(!isinteger, $T(1/2):$T(5))
            @eval @test all(!isinteger, $T(3/2):$T(0))
        end
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test first($T(-1/2):$T(1)) == $T(-1/2)
            @eval @test last($T(-1/2):$T(1)) == $T(1/2)
            @eval @test length($T(-1/2):$T(1)) == 2
        end
    end

    @testset "StepRange" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test StepRange{$T,$T}($T(2), $T(1/2), $T(5)) isa StepRange{$T,$T}
            @eval @test StepRange{$T,Int8}($T(2), Int8(2), $T(9/2)) isa StepRange{$T,Int8}
            @eval @test StepRange($T(2), $T(1/2), $T(5)) isa StepRange{$T,$T}
            @eval @test StepRange($T(2), Int8(2), $T(9/2)) isa StepRange{$T,Int8}
            @eval @test StepRange($T(2), big(2), $T(9/2)) isa StepRange{$T,BigInt}

            @eval @test $T(2):$T(1/2):$T(5) isa StepRange{$T,$T}
            @eval @test $T(2):$T(2):$T(9/2) isa StepRange{$T,$T}
            @eval @test $T(2):big(2):$T(9/2) isa StepRange{BigHalfInt,BigInt}
            @eval @test big(2):2:$T(9/2) isa StepRange{BigHalfInt,Int}

            @eval @test $T(2):$T(2):$T(9/2) == $T(2):$T(2):$T(4)
            @eval @test first($T(2):$T(2):$T(9/2)) == 2
            @eval @test step($T(2):$T(2):$T(9/2)) == 2
            @eval @test last($T(2):$T(2):$T(9/2)) == 4
            @eval @test length($T(2):$T(2):$T(9/2)) == 2

            @eval @test first($T(2):$T(1/2):$T(5)) == 2
            @eval @test step($T(2):$T(1/2):$T(5)) == $T(1/2)
            @eval @test last($T(2):$T(1/2):$T(5)) == 5
            @eval @test length($T(2):$T(1/2):$T(5)) == 7

            @eval @test $T(5/2) ∈ $T(1/2):$T(2):$T(7)
            @eval @test $T(5/2) ∉ $T(1/2):$T(5/2):$T(7)
            @eval @test $T(2) ∈ $T(0):$T(1):$T(5/2)
            @eval @test $T(2) ∉ $T(1/2):$T(1):$T(5/2)
            @eval @test 2.5 ∈ $T(1/2):$T(2):$T(7)
            @eval @test 2.5 ∉ $T(1/2):$T(5/2):$T(7)
            @eval @test 5//2 ∈ $T(1/2):$T(2):$T(7)
            @eval @test 5//2 ∈ $T(1/2):2:$T(7)
            @eval @test 5//2 ∈ $T(1/2):2:7
            @eval @test 5//2 ∉ $T(1/2):$T(5/2):$T(7)
            @eval @test 2 ∈ $T(0):$T(1):$T(5/2)
            @eval @test 2 ∉ $T(1/2):$T(1):$T(5/2)
        end
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test $T(2):$T(-1):$T(1/2) == $T(2):$T(-1):$T(1)
            @eval @test first($T(2):$T(-1):$T(1/2)) == 2
            @eval @test step($T(2):$T(-1):$T(1/2)) == -1
            @eval @test last($T(2):$T(-1):$T(1/2)) == 1
            @eval @test length($T(2):$T(-1):$T(1/2)) == 2

            @eval @test $T(5/2) ∉ $T(1/2):$T(-1):$T(-1/2)
            @eval @test 2.5 ∉ $T(1/2):$T(-1):$T(-1/2)
            @eval @test 5//2 ∉ $T(1/2):$T(-1):$T(-1/2)
            @eval @test 5//2 ∉ $T(1/2):-1:$T(-1/2)
        end
    end

    @testset "StepRangeLen" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test StepRangeLen{$T,$T,$T}($T(2), $T(1/2), 4) isa StepRangeLen{$T,$T,$T}
            @eval @test StepRangeLen{$T,$T,$T}($T(2), $T(1/2), 4, 3) isa StepRangeLen{$T,$T,$T}
            @eval @test StepRangeLen{$T,$T,Int8}($T(9/2), Int8(2), 4) isa StepRangeLen{$T,$T,Int8}
            @eval @test StepRangeLen{$T,$T,Int8}($T(9/2), Int8(2), 4, 3) isa StepRangeLen{$T,$T,Int8}
            @eval @test StepRangeLen{$T,Int,Int}(8, 2, 4) isa StepRangeLen{$T,Int,Int}
            @eval @test StepRangeLen{$T,Int,Int}(8, 2, 4, 3) isa StepRangeLen{$T,Int,Int}
            @eval @test StepRangeLen{$T}($T(2), $T(1/2), 4) isa StepRangeLen{$T,$T,$T}
            @eval @test StepRangeLen{$T}($T(2), $T(1/2), 4, 3) isa StepRangeLen{$T,$T,$T}
            @eval @test StepRangeLen{$T}($T(9/2), Int8(2), 4) isa StepRangeLen{$T,$T,Int8}
            @eval @test StepRangeLen{$T}($T(9/2), Int8(2), 4, 3) isa StepRangeLen{$T,$T,Int8}
            @eval @test StepRangeLen{$T}(8, 2, 4) isa StepRangeLen{$T,Int,Int}
            @eval @test StepRangeLen{$T}(8, 2, 4, 3) isa StepRangeLen{$T,Int,Int}
            @eval @test_skip StepRangeLen($T(2), $T(1/2), 4) isa StepRangeLen{$T,$T,$T}
            @eval @test_skip StepRangeLen($T(2), $T(1/2), 4, 3) isa StepRangeLen{$T,$T,$T}
            @eval @test_skip StepRangeLen($T(9/2), Int8(2), 4) isa StepRangeLen{$T,$T,Int8}
            @eval @test_skip StepRangeLen($T(9/2), Int8(2), 4, 3) isa StepRangeLen{$T,$T,Int8}
            @eval @test StepRangeLen($T(9/2), big(2), 4) isa StepRangeLen{BigHalfInt,$T,BigInt}
            @eval @test StepRangeLen($T(9/2), big(2), 4, 3) isa StepRangeLen{BigHalfInt,$T,BigInt}

            @eval @test StepRangeLen{$T}($T(2), $T(1/2), 5) == $T[2, 5/2, 3, 7/2, 4]
            @eval @test first(StepRangeLen{$T}($T(2), $T(1/2), 5)) == $T(2)
            @eval @test step(StepRangeLen{$T}($T(2), $T(1/2), 5)) == $T(1/2)
            @eval @test last(StepRangeLen{$T}($T(2), $T(1/2), 5)) == $T(4)
            @eval @test length(StepRangeLen{$T}($T(2), $T(1/2), 5)) == 5

            @eval @test StepRangeLen{$T}($T(2), $T(1/2), 5, 3) == $T[1, 3/2, 2, 5/2, 3]
            @eval @test first(StepRangeLen{$T}($T(2), $T(1/2), 5, 3)) == $T(1)
            @eval @test step(StepRangeLen{$T}($T(2), $T(1/2), 5, 3)) == $T(1/2)
            @eval @test last(StepRangeLen{$T}($T(2), $T(1/2), 5, 3)) == $T(3)
            @eval @test length(StepRangeLen{$T}($T(2), $T(1/2), 5, 3)) == 5
        end
    end

    @testset "LinRange" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test LinRange{$T}(1/2, 3/2, 3) isa LinRange{$T}
            @eval @test LinRange($T(1/2), $T(3/2), 3) isa LinRange{float($T)}

            @eval @test LinRange{$T}(1/2, 3/2, 3) == $T[1/2, 1, 3/2]
            @eval @test first(LinRange{$T}(1/2, 3/2, 3)) == $T(1/2)
            @eval @test step(LinRange{$T}(1/2, 3/2, 3)) == 0.5
            @eval @test last(LinRange{$T}(1/2, 3/2, 3)) == $T(3/2)
            @eval @test length(LinRange{$T}(1/2, 3/2, 3)) == 3
        end
    end

    @testset "range" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test @inferred(range($T(1/2), stop=$T(5))) isa UnitRange{$T}
            @eval @test @inferred(range($T(1/2), stop=Int8(5))) isa UnitRange{$T}
            @eval @test @inferred(range(Int8(1), stop=$T(7/2))) isa UnitRange{$T}
            @eval @test @inferred(range($T(1/2), stop=big(5))) isa UnitRange{BigHalfInt}
            @eval @test @inferred(range(big(1), stop=$T(7/2))) isa UnitRange{BigHalfInt}
            @eval @test range($T(1/2), stop=$T(5)) == $T[1/2, 3/2, 5/2, 7/2, 9/2]
            @eval @test range($T(1/2), stop=Int8(5)) == $T[1/2, 3/2, 5/2, 7/2, 9/2]
            @eval @test range(Int8(1), stop=$T(7/2)) == $T[1, 2, 3]
            @eval @test range($T(1/2), stop=big(5)) == BigHalfInt[1/2, 3/2, 5/2, 7/2, 9/2]
            @eval @test range(big(1), stop=$T(7/2)) == BigHalfInt[1, 2, 3]

            if VERSION ≥ v"1.8.0-DEV"
                @eval @test @inferred(range($T(1/2), length=Int8(5))) isa StepRangeLen{$T,$T,$T}
            else
                @eval @test @inferred(range($T(1/2), length=Int8(5))) isa UnitRange{$T}
            end
            @eval @test range($T(1/2), length=Int8(5)) == $T[1/2, 3/2, 5/2, 7/2, 9/2]
            @static if VERSION ≥ v"1.7"
                if VERSION ≥ v"1.8.0-DEV"
                    @eval @test @inferred(range(stop=$T(11/2), length=Int8(5))) isa StepRangeLen{$T,$T,$T}
                else
                    @eval @test @inferred(range(stop=$T(11/2), length=Int8(5))) isa UnitRange{$T}
                end
                @eval @test range(stop=$T(11/2), length=Int8(5)) == $T[3/2, 5/2, 7/2, 9/2, 11/2]
            end

            @eval @test @inferred(range($T(2), step=$T(1/2), stop=$T(5))) isa StepRange{$T,$T}
            @eval @test @inferred(range($T(2), step=Int8(2), stop=$T(9/2))) isa StepRange{$T,Int8}
            @eval @test @inferred(range($T(2), step=big(2), stop=$T(9/2))) isa StepRange{BigHalfInt,BigInt}
            @eval @test @inferred(range(Int8(2), step=$T(1/2), stop=Int8(5))) isa StepRange{$T,$T}
            @eval @test range($T(2), step=$T(1/2), stop=$T(5)) == $T[2, 5/2, 3, 7/2, 4, 9/2, 5]
            @eval @test range($T(2), step=Int8(2), stop=$T(9/2)) == $T[2, 4]
            @eval @test range($T(2), step=big(2), stop=$T(9/2)) == BigHalfInt[2, 4]
            @eval @test range(Int8(2), step=$T(1/2), stop=Int8(5)) == $T[2, 5/2, 3, 7/2, 4, 9/2, 5]

            if T === :BigHalfInt
                @eval @test @inferred(range($T(1/2), stop=$T(9/2), length=5)) isa LinRange{BigFloat}
                @eval @test @inferred(range($T(2), stop=Int8(10), length=5)) isa LinRange{BigFloat}
                @eval @test range($T(1/2), stop=$T(9/2), length=5) == [0.5, 1.5, 2.5, 3.5, 4.5]
                @eval @test range($T(2), stop=Int8(10), length=5) == [2, 4, 6, 8, 10]
            else
                if @eval($T) <: Half{<:Unsigned} && sizeof(@eval $T) ≥ sizeof(Int)
                    @eval @test_broken @inferred(range($T(1/2), stop=$T(9/2), length=5)) isa StepRangeLen{Float64,Base.TwicePrecision{Float64},Base.TwicePrecision{Float64}}
                    @eval @test_broken range($T(1/2), stop=$T(9/2), length=5) == [0.5, 1.5, 2.5, 3.5, 4.5]
                else
                    @eval @test @inferred(range($T(1/2), stop=$T(9/2), length=5)) isa StepRangeLen{Float64,Base.TwicePrecision{Float64},Base.TwicePrecision{Float64}}
                    @eval @test range($T(1/2), stop=$T(9/2), length=5) == [0.5, 1.5, 2.5, 3.5, 4.5]
                end
                if @eval($T) <: Half{<:Unsigned} && sizeof(@eval $T) > sizeof(Int)
                    @eval @test_broken @inferred(range($T(2), stop=Int8(10), length=5)) isa StepRangeLen{Float64,Base.TwicePrecision{Float64},Base.TwicePrecision{Float64}}
                    @eval @test_broken range($T(2), stop=Int8(10), length=5) == [2, 4, 6, 8, 10]
                else
                    @eval @test @inferred(range($T(2), stop=Int8(10), length=5)) isa StepRangeLen{Float64,Base.TwicePrecision{Float64},Base.TwicePrecision{Float64}}
                    @eval @test range($T(2), stop=Int8(10), length=5) == [2, 4, 6, 8, 10]
                end
            end
            @eval @test @inferred(range(big(10), stop=$T(2), length=5)) isa LinRange{BigFloat}
            @eval @test range(big(10), stop=$T(2), length=5) == [10, 8, 6, 4, 2]

            @eval @test @inferred(range($T(2), step=$T(1/2), length=Int8(5))) isa StepRangeOrStepRangeLen{$T}
            @eval @test @inferred(range($T(1/2), step=Int8(2), length=Int8(5))) isa StepRangeOrStepRangeLen{$T}
            @eval @test range($T(2), step=$T(1/2), length=5) == $T[2, 5/2, 3, 7/2, 4]
            @eval @test range($T(1/2), step=Int8(2), length=5) == $T[1/2, 5/2, 9/2, 13/2, 17/2]
            @eval @test range($T(1/2), step=big(2), length=5) == BigHalfInt[1/2, 5/2, 9/2, 13/2, 17/2]
            if VERSION ≥ v"1.7.0-DEV.16" || T === :BigHalfInt
                @eval @test @inferred(range($T(1/2), step=big(2), length=Int8(5))) isa StepRangeOrStepRangeLen{BigHalfInt}
            else
                @eval @test_broken @inferred(range($T(1/2), step=big(2), length=Int8(5))) isa StepRangeOrStepRangeLen{BigHalfInt}
            end
            @static if VERSION ≥ v"1.7.0-DEV.16"
                @eval @test @inferred(range(Int8(2), step=$T(1/2), length=Int8(5))) isa StepRangeOrStepRangeLen{$T}
                @eval @test range(Int8(2), step=$T(1/2), length=Int8(5)) == $T[2, 5/2, 3, 7/2, 4]
            else
                @eval @test_broken @inferred(range(Int8(2), step=$T(1/2), length=5)) isa StepRange{$T,$T}
                @eval @test_broken range(Int8(2), step=$T(1/2), length=5) == $T[2, 5/2, 3, 7/2, 4]
            end
        end

        @static if VERSION ≥ v"1.7.0-DEV.263"
            for T in (inttypes..., uinttypes..., :BigInt)
                @eval @test @inferred(range(stop=Half{$T}(23/2), step=Int8(2), length=$T(5))) isa StepRangeOrStepRangeLen{Half{$T}}
                @eval @test range(stop=Half{$T}(23/2), step=Int8(2), length=$T(5)) == Half{$T}[7/2, 11/2, 15/2, 19/2, 23/2]
                @eval @test @inferred(range(stop=Half{$T}(23/2), step=big(2), length=5)) isa StepRangeOrStepRangeLen{BigHalfInt}
                @eval @test range(stop=Half{$T}(23/2), step=big(2), length=5) == BigHalfInt[7/2, 11/2, 15/2, 19/2, 23/2]
            end
            for T in (inttypes..., :BigInt)
                @eval @test @inferred(range(stop=Half{$T}(2), step=Half{$T}(1/2), length=$T(6))) isa StepRangeOrStepRangeLen{Half{$T}}
                @eval @test @inferred(range(stop=Int8(2), step=Half{$T}(1/2), length=Int8(6))) isa StepRangeOrStepRangeLen{Half{$T}}
                @eval @test range(stop=Half{$T}(2), step=Half{$T}(1/2), length=$T(6)) == Half{$T}[-1/2, 0, 1/2, 1, 3/2, 2]
                @eval @test range(stop=Int8(2), step=Half{$T}(1/2), length=Int8(6)) == Half{$T}[-1/2, 0, 1/2, 1, 3/2, 2]
            end
        end
    end

    @testset "reverse" begin
        for T in (halfinttypes..., :BigHalfInt)
            # There is currently a discussion on how to treat Unsigned types:
            # * https://github.com/JuliaLang/julia/issues/29576
            # * https://github.com/JuliaLang/julia/pull/29842
            @eval @test @inferred(reverse($T(1/2):$T(9/2))) isa StepRange{$T}
            @eval @test @inferred(reverse($T(9/2):$T(-1):$T(1/2))) isa StepRange{$T}
            @eval @test reverse($T(1/2):$T(9/2)) == $T(9/2):$T(-1):$T(1/2)
            @eval @test reverse($T(9/2):$T(-1):$T(1/2)) == $T(1/2):$T(1):$T(9/2)
            @eval @test reverse($T(1/2):$T(1/2):$T(3)) == $T(3):$T(-1/2):$T(1/2)
            @eval @test reverse($T(-1/2):$T(2):$T(3/2)) == $T(3/2):$T(-2):$T(-1/2)
            @eval @test isempty(reverse($T(3/2):$T(1/2)))
            @eval @test isempty(reverse($T(3/2):$T(1):$T(1/2)))
            @eval @test isempty(reverse($T(3/2):$T(1/2):$T(1)))
            @eval @test isempty(reverse($T(7/2):$T(-2):$T(11/2)))
        end
    end

    @testset "intersect" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test @inferred(($T(1):$T(3)) ∩ ($T(1/2):$T(3))) isa UnitRange{$T}
            @eval @test @inferred((big(1):big(3)) ∩ ($T(1/2):$T(3))) isa UnitRange{BigHalfInt}
            @eval @test @inferred(($T(1/2):$T(3)) ∩ (big(1):big(3))) isa UnitRange{BigHalfInt}
            @eval @test @inferred(($T(3/2):$T(1):$T(5)) ∩ ($T(1):$T(3))) isa StepRange{$T}
            @eval @test @inferred(($T(3/2):$T(1):$T(5)) ∩ (big(1):big(3))) isa StepRange{BigHalfInt}
            @eval @test @inferred((big(1):big(3)) ∩ ($T(3/2):$T(1):$T(5))) isa StepRange{BigHalfInt}
            @eval @test @inferred((big(1):big(3):big(7)) ∩ ($T(3/2):$T(5))) isa StepRange{BigHalfInt}
            @eval @test @inferred(($T(3/2):$T(5)) ∩ (big(1):big(3):big(7))) isa StepRange{BigHalfInt}
            @eval @test @inferred(($T(3/2):$T(1/2):$T(5)) ∩ ($T(1):$T(3):$T(5))) isa StepRange{$T}
            @eval @test @inferred((big(-1):big(3):big(5)) ∩ ($T(3/2):$T(1/2):$T(5))) isa StepRange{BigHalfInt}
            @eval @test @inferred(($T(3/2):$T(1/2):$T(5)) ∩ (big(-1):big(3):big(5))) isa StepRange{BigHalfInt}
            @eval @test isempty(($T(1):$T(3)) ∩ ($T(1/2):$T(3)))
            @eval @test ($T(1/2):$T(2)) ∩ ($T(3/2):$T(3)) == $T(3/2):$T(3/2)
            @eval @test isempty(($T(1/2):$T(2)) ∩ (1:2))
            @eval @test isempty((1:2) ∩ ($T(1/2):$T(2)))
            @eval @test ($T(2):$T(5)) ∩ (1:3) == 2:3
            @eval @test (1:3) ∩ ($T(2):$T(5)) == 2:3
            @eval @test ($T(2):$T(1):$T(5)) ∩ (1:3) == 2:1:3
            @eval @test (1:3) ∩ ($T(2):$T(1):$T(5)) == 2:1:3
            @eval @test isempty(($T(3/2):$T(1):$T(5)) ∩ (1:3))
            @eval @test isempty((1:3) ∩ ($T(3/2):$T(1):$T(5)))
            @eval @test ($T(2):$T(1/2):$T(5)) ∩ (1:3) == 2:1:3
            @eval @test (1:3) ∩ ($T(2):$T(1/2):$T(5)) == 2:1:3
            @eval @test ($T(3/2):$T(1/2):$T(5)) ∩ (1:3) == 2:1:3
            @eval @test (1:3) ∩ ($T(3/2):$T(1/2):$T(5)) == 2:1:3
            @eval @test ($T(2):$T(1):$T(5)) ∩ ($T(1):$T(3)) == $T(2):$T(1):$T(3)
            @eval @test ($T(1):$T(3)) ∩ ($T(2):$T(1):$T(5)) == $T(2):$T(1):$T(3)
            @eval @test isempty(($T(3/2):$T(1):$T(5)) ∩ ($T(1):$T(3)))
            @eval @test isempty(($T(1):$T(3)) ∩ ($T(3/2):$T(1):$T(5)))
            @eval @test ($T(2):$T(1/2):$T(5)) ∩ ($T(1):$T(3)) == $T(2):$T(1):$T(3)
            @eval @test ($T(1):$T(3)) ∩ ($T(2):$T(1/2):$T(5)) == $T(2):$T(1):$T(3)
            @eval @test ($T(3/2):$T(1/2):$T(5)) ∩ ($T(1):$T(3)) == $T(2):$T(1):$T(3)
            @eval @test ($T(1):$T(3)) ∩ ($T(3/2):$T(1/2):$T(5)) == $T(2):$T(1):$T(3)
            @eval @test ($T(3/2):$T(1):$T(6)) ∩ ($T(1):$T(3/2):$T(6)) == $T(5/2):$T(3):$T(11/2)
        end
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test ($T(3/2):$T(1/2):$T(5)) ∩ (-1:3:5) == 2:3:5
            @eval @test (-1:3:5) ∩ ($T(3/2):$T(1/2):$T(5)) == 2:3:5
            @eval @test ($T(2):$T(1):$T(5)) ∩ (-1:3:5) == 2:3:5
            @eval @test (-1:3:5) ∩ ($T(2):$T(1):$T(5)) == 2:3:5
            @eval @test isempty(($T(3/2):$T(1):$T(5)) ∩ (-1:3:5))
            @eval @test isempty((-1:3:5) ∩ ($T(3/2):$T(1):$T(5)))
            @eval @test isempty(($T(3/2):$T(1):$T(5)) ∩ ($T(-1):$T(3):$T(5)))
            @eval @test isempty(($T(-1):$T(3):$T(5)) ∩ ($T(3/2):$T(1):$T(5)))
            @eval @test ($T(3/2):$T(1):$T(5)) ∩ ($T(-1):$T(3/2):$T(5)) == $T(7/2):$T(3):$T(7/2)
            # These tests should in theory also work for Unsigned types, but due to some
            # bugs with ranges of Unsigned integers, they currently don’t (see below)
            @eval @test ($T(5/2):$T(3/2):$T(7)) ∩ ($T(1):$T(8)) == $T(4):$T(3):$T(7)
            @eval @test ($T(1):$T(8)) ∩ ($T(5/2):$T(3/2):$T(7)) == $T(4):$T(3):$T(7)
            @eval @test isempty((1:3:7) ∩ ($T(3/2):$T(5)))
            @eval @test isempty(($T(3/2):$T(5)) ∩ (1:3:7))
            @eval @test (1:3:7) ∩ ($T(3):$T(5)) == 4:3:4
            @eval @test ($T(3):$T(5)) ∩ (1:3:7) == 4:3:4
        end
        # Ranges of UInts are currently broken, cf. e.g.
        # * https://github.com/JuliaLang/julia/issues/29576
        # * https://github.com/JuliaLang/julia/issues/29801
        # * https://github.com/JuliaLang/julia/issues/29810
        # These (or other) bugs related to ranges of Unsigned integers prevent some of the
        # following tests from passing
        for T in halfuinttypes
            @eval @test_broken ($T(5/2):$T(3/2):$T(7)) ∩ ($T(1):$T(8)) == $T(4):$T(3):$T(7)
            @eval @test_broken ($T(1):$T(8)) ∩ ($T(5/2):$T(3/2):$T(7)) == $T(4):$T(3):$T(7)
        end
        for T in (:HalfUInt8, :HalfUInt16)
            @eval @test isempty((1:3:7) ∩ ($T(3/2):$T(5)))
            @eval @test isempty(($T(3/2):$T(5)) ∩ (1:3:7))
            @eval @test (1:3:7) ∩ ($T(3):$T(5)) == 4:3:4
            @eval @test ($T(3):$T(5)) ∩ (1:3:7) == 4:3:4
        end
        @static if Sys.WORD_SIZE == 64
            @test isempty((1:3:7) ∩ (HalfUInt32(3/2):HalfUInt32(5)))
            @test isempty((HalfUInt32(3/2):HalfUInt32(5)) ∩ (1:3:7))
            @test (1:3:7) ∩ (HalfUInt32(3):HalfUInt32(5)) == 4:3:4
            @test (HalfUInt32(3):HalfUInt32(5)) ∩ (1:3:7) == 4:3:4
        else
            @test_broken isempty((1:3:7) ∩ (HalfUInt32(3/2):HalfUInt32(5)))
            @test_broken isempty((HalfUInt32(3/2):HalfUInt32(5)) ∩ (1:3:7))
            @test_broken (1:3:7) ∩ (HalfUInt32(3):HalfUInt32(5)) == 4:3:4
            @test_broken (HalfUInt32(3):HalfUInt32(5)) ∩ (1:3:7) == 4:3:4
        end
        for T in (:HalfUInt64, :HalfUInt128)
            @eval @test_broken isempty((1:3:7) ∩ ($T(3/2):$T(5)))
            @eval @test_broken isempty(($T(3/2):$T(5)) ∩ (1:3:7))
            @eval @test_broken (1:3:7) ∩ ($T(3):$T(5)) == 4:3:4
            @eval @test_broken ($T(3):$T(5)) ∩ (1:3:7) == 4:3:4
        end
    end
end

using HalfIntegers, Test

inttypes  = (:Int8, :Int16, :Int32, :Int64, :Int128)
uinttypes = (:UInt8, :UInt16, :UInt32, :UInt64, :UInt128)
halfinttypes  = (:HalfInt8, :HalfInt16, :HalfInt32, :HalfInt64, :HalfInt128)
halfuinttypes = (:HalfUInt8, :HalfUInt16, :HalfUInt32, :HalfUInt64, :HalfUInt128)

==ₜ(x, y) = x === y
==ₜ(x::T, y::T) where T<:Union{BigInt,BigFloat,BigHalfInt,Rational{BigInt},Complex{BigInt},Complex{BigFloat},Complex{BigHalfInt},Complex{Rational{BigInt}}} = x == y
==ₜ(x::AbstractArray, y::AbstractArray) = (x == y) && (typeof(x) == typeof(y))
==ₜ(x::Tuple, y::Tuple) = all(x .==ₜ y)

@test isempty(Test.detect_ambiguities(HalfIntegers, Base, Core))

@testset "Aliases" begin
    @test HalfInt === Half{Int}
    @test HalfInt8 === Half{Int8}
    @test HalfInt16 === Half{Int16}
    @test HalfInt32 === Half{Int32}
    @test HalfInt64 === Half{Int64}
    @test HalfInt128 === Half{Int128}
    @test BigHalfInt === Half{BigInt}
    @test HalfUInt === Half{UInt}
    @test HalfUInt8 === Half{UInt8}
    @test HalfUInt16 === Half{UInt16}
    @test HalfUInt32 === Half{UInt32}
    @test HalfUInt64 === Half{UInt64}
    @test HalfUInt128 === Half{UInt128}
end

@testset "Constructors" begin
    for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
        @eval @test $T <: HalfInteger
        @eval @test $T(2.5) isa $T
        @eval @test $T(3) isa $T
        @eval @test $T(true) isa $T
        @eval @test $T(31//2) isa $T
        @eval @test $T(1.5 + 0.0im) isa $T
        @eval @test $T(2 + 0im) isa $T
        @eval @test $T(HalfInt(5/2)) isa $T
        @eval @test $T($T(5/2)) isa $T
        @eval @test_throws InexactError $T(2.6)
        @eval @test_throws InexactError $T(nextfloat(2.5))
        @eval @test_throws InexactError $T(7//3)
        @eval @test_throws InexactError $T(2im)
        @eval @test_throws InexactError $T(2.0im)
        @eval @test_throws InexactError $T(big(2im))
        @eval @test_throws InexactError $T(big(2.0im))
        @eval @test_throws InexactError $T(π)
        @eval @test HalfInteger($T(5/2)) isa $T
        @eval @test HalfInteger($T(5/2)) ==ₜ $T(5/2)
        @eval @test big($T) === BigHalfInt
    end
    for T in halfuinttypes
        @eval @test_throws InexactError $T(-0.5)
        @eval @test_throws InexactError $T(-2)
        @eval @test_throws InexactError $T(-31//2)
        @eval @test_throws InexactError $T(-1+0im)
        @eval @test_throws InexactError $T(HalfInt(-2))
    end
    @test HalfInt32(HalfInt64(-11/2)) === HalfInt32(-11/2)
    @test HalfUInt8(BigHalfInt(3/2)) === HalfUInt8(3/2)
    @test HalfInteger(2.5) isa HalfInteger
    @test HalfInteger(1.5 + 0.0im) isa HalfInteger
    @test HalfInteger(2 + 0im) isa HalfInteger
    for T in (inttypes..., uinttypes..., :BigInt)
        @eval @test HalfInteger($T(3)) ==ₜ Half{$T}(3)
        @eval @test HalfInteger($T(3) + $T(0)im) ==ₜ Half{$T}(3)
        @eval @test_throws InexactError HalfInteger($T(3) + $T(1)im)
        @eval @test HalfInteger($T(31)//$T(2)) ==ₜ Half{$T}(31//2)
        @eval @test HalfInteger($T(31)//$T(2) + $T(0)//$T(1)*im) ==ₜ Half{$T}(31//2)
        @eval @test_throws InexactError HalfInteger($T(31)//$T(2) + $T(1)//$T(1)*im)
    end
    @test HalfInteger(big(2.5)) ==ₜ BigHalfInt(5/2)
    @test HalfInteger(big(2.5 + 0.0im)) ==ₜ BigHalfInt(5/2)
    @test_throws InexactError HalfInteger(2.0im)
    @test_throws InexactError HalfInteger(big(2.0im))
    @test_throws MethodError Half(2)
end

@testset "Conversion" begin
    @testset "big" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test big($T(5/2)) ==ₜ BigHalfInt(5/2)
            @eval @test big(Complex{$T}(5/2 + 3im)) ==ₜ Complex{BigHalfInt}(5/2 + 3im)
        end
    end

    @testset "complex" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test complex($T(5/2)) ==ₜ Complex{$T}(5/2)
            @eval @test complex(Complex{$T}(5/2 + 3im)) ==ₜ Complex{$T}(5/2 + 3im)
        end
    end

    @testset "float" begin
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test float($T) === Float64
            @eval @test float($T(3/2)) === 1.5
            @eval @test float(Complex{$T}) === Complex{Float64}
            @eval @test float(Complex{$T}(3/2 + 5im)) === 1.5 + 5.0im
        end
        @test float(BigHalfInt) === BigFloat
        @test float(BigHalfInt(-5/2)) ==ₜ BigFloat(-2.5)
        @test float(Complex{BigHalfInt}) === Complex{BigFloat}
        @test float(Complex{BigHalfInt}(-5/2 + 3im)) ==ₜ Complex{BigFloat}(-2.5 + 3.0im)
    end

    @testset "Concrete types" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            # AbstractFloat
            for F in (:Float16, :Float32, :Float64, :BigFloat)
                @eval @test $F($T(13/2)) ==ₜ $F(6.5)
                @eval @test Complex{$F}($T(13/2)) ==ₜ Complex{$F}(6.5)
            end
            for I in (inttypes..., uinttypes..., :BigInt)
                # Integer
                @eval @test $I($T(2)) ==ₜ $I(2)
                @eval @test_throws InexactError $I($T(1/2))
                # Rational
                @eval @test Rational{$I}($T(7/2)) ==ₜ Rational{$I}(7//2)
                @eval @test Rational{$I}($T(3)) ==ₜ Rational{$I}(3//1)
                # Complex
                @eval @test Complex{$I}($T(5)) ==ₜ Complex{$I}(5)
                @eval @test Complex{Rational{$I}}($T(5)) ==ₜ Complex{Rational{$I}}(5)
            end
            # Bool
            @eval @test Bool($T(1)) === true
            @eval @test Bool($T(0)) === false
            @eval @test_throws InexactError Bool($T(1/2))
            @eval @test_throws InexactError Bool($T(2))
            # Complex
            @eval @test Complex($T(3/2)) ==ₜ Complex{$T}(3/2)
            for H in (halfinttypes..., :BigHalfInt)
                @eval @test Complex{$H}($T(3/2)) ==ₜ Complex{$H}($H(3/2))
            end
        end
        for T in (halfinttypes..., :BigHalfInt)
            for S in (inttypes..., :BigInt)
                # Integer
                @eval @test $S($T(-2)) ==ₜ $S(-2)
                # Rational
                @eval @test Rational{$S}($T(-11/2)) ==ₜ Rational{$S}(-11//2)
            end
            for U in (uinttypes..., :Bool)
                # Integer
                @eval @test_throws InexactError $U($T(-1))
                # Rational
                @eval @test_throws InexactError Rational{$U}($T(-1))
            end
        end
        # Rational
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test Rational(Half{$T}(11/2)) ==ₜ Rational{$T}(11//2)
            @eval @test Rational(Half{$T}(5)) ==ₜ Rational{$T}(5//1)
        end
    end

    @testset "Abstract types" begin
        for T in (inttypes..., uinttypes...)
            @eval @test AbstractFloat(Half{$T}(3/2)) === 1.5
            @eval @test Integer(Half{$T}(3)) === $T(3)
            @eval @test_throws InexactError Integer(Half{$T}(3/2))
            @eval @test Signed(Half{$T}(3)) === Signed($T(3))
            @eval @test_throws InexactError Signed(Half{$T}(3/2))
            @eval @test Unsigned(Half{$T}(3)) === Unsigned($T(3))
            @eval @test_throws InexactError Unsigned(Half{$T}(3/2))
        end
        for T in halfinttypes
            @eval @test_throws InexactError Unsigned($T(-3))
        end
        @test AbstractFloat(BigHalfInt(5/2)) ==ₜ BigFloat(2.5)
        @test Integer(BigHalfInt(3)) ==ₜ BigInt(3)
        @test_throws InexactError Integer(BigHalfInt(3/2))
        @test Signed(BigHalfInt(3)) ==ₜ BigInt(3)
        @test_throws InexactError Signed(BigHalfInt(3/2))
    end
end

@testset "half" begin
    @testset "Real" begin
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test half($T(5)) ==ₜ Half{$T}(5/2)
        end
        @test half(Float16(5)) === HalfInt(5/2)
        @test half(Float32(5)) === HalfInt(5/2)
        @test half(Float64(5)) === HalfInt(5/2)
        @test half(BigFloat(5)) ==ₜ BigHalfInt(5/2)
        @test half(5//1) === HalfInt(5/2)
        @test half(UInt8(5)//UInt8(1)) === HalfUInt8(5/2)
        @test half(big(5//1)) ==ₜ BigHalfInt(5/2)
        @test_throws InexactError half(5.1)
        @test_throws InexactError half(big(5.1))
        @test_throws InexactError half(5//2)
        @test_throws InexactError half(big(5//2))
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            for S in (:Int, :UInt8, :BigInt, :Float64, :BigFloat, :(Rational{Int}), :(Rational{BigInt}),
                      :(Complex{Int}), :(Complex{BigInt}), :(Complex{Float64}), :(Complex{BigFloat}))
                @eval @test half($T, $S(5)) ==ₜ $T(5/2)
            end
            @eval @test_throws InexactError half($T, 5.1)
            @eval @test_throws InexactError half($T, big(5.1))
            @eval @test_throws InexactError half($T, 5//2)
            @eval @test_throws InexactError half($T, big(5//2))
            @eval @test_throws InexactError half($T, 5+1im)
            @eval @test_throws InexactError half($T, big(5+1im))
            @eval @test_throws InexactError half($T, 5.5+0.0im)
            @eval @test_throws InexactError half($T, big(5.0+0.5im))
        end
    end

    @testset "Complex" begin
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test half(Complex{$T}(5, 4)) ==ₜ Complex{Half{$T}}(5/2, 2)
        end
        @test half(Complex{Float16}(5, 4)) === Complex{HalfInt}(5/2, 2)
        @test half(Complex{Float32}(5, 4)) === Complex{HalfInt}(5/2, 2)
        @test half(Complex{Float64}(5, 4)) === Complex{HalfInt}(5/2, 2)
        @test half(Complex{BigFloat}(5, 4)) ==ₜ Complex{BigHalfInt}(5/2, 2)
        @test half(Complex{Rational{Int}}(5, 4)) === Complex{HalfInt}(5/2, 2)
        @test half(Complex{Rational{UInt8}}(5, 4)) === Complex{HalfUInt8}(5/2, 2)
        @test half(Complex{Rational{BigInt}}(5, 4)) ==ₜ Complex{BigHalfInt}(5/2, 2)
        @test_throws InexactError half(Complex{Float64}(5.5, 1.0))
        @test_throws InexactError half(Complex{BigFloat}(5.5, 1.0))
        @test_throws InexactError half(Complex{Rational{Int}}(5//2, 1//2))
        @test_throws InexactError half(Complex{Rational{BigInt}}(5//2, 1//2))

        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            for S in (:Int, :UInt8, :BigInt, :Float64, :BigFloat, :(Rational{Int}), :(Rational{BigInt}))
                @eval @test half(Complex{$T}, $S(5)) ==ₜ Complex{$T}(5/2, 0)
                @eval @test half(Complex{$T}, Complex{$S}(5, 4)) ==ₜ Complex{$T}(5/2, 2)
            end
            @eval @test_throws InexactError half(Complex{$T}, 5.1)
            @eval @test_throws InexactError half(Complex{$T}, big(5.1))
            @eval @test_throws InexactError half(Complex{$T}, 5//2)
            @eval @test_throws InexactError half(Complex{$T}, big(5//2))
            @eval @test_throws InexactError half(Complex{$T}, 5.5+0.0im)
            @eval @test_throws InexactError half(Complex{$T}, big(5.0+0.5im))
        end
    end
end

@testset "twice" begin
    @testset "Real" begin
        for T in (inttypes..., uinttypes...)
            @eval @test_throws OverflowError twice(Rational{$T}(typemax($T),one($T)))
        end
        for T in inttypes
            @eval @test_throws OverflowError twice(Rational{$T}(typemin($T),one($T)))
        end
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test @inferred(twice(Half{$T}(2))) ==ₜ $T(4)
            @eval @test twice(Half{$T}(3/2)) ==ₜ $T(3)
            @eval @test @inferred(twice($T(3))) ==ₜ $T(6)
            @eval @test @inferred(twice(Rational{$T}(3,8))) ==ₜ Rational{$T}(3,4)
            @eval @test twice(Rational{$T}(5,2)) ==ₜ Rational{$T}(5,1)
            @eval @test twice(Rational{$T}(7,1)) ==ₜ Rational{$T}(14,1)
            @eval @test twice(Rational{$T}(1,0)) ==ₜ Rational{$T}(1,0)
            @eval @test @inferred(twice($T, HalfInt(3))) ==ₜ $T(6)
            @eval @test @inferred(twice($T, HalfInt(3/2))) ==ₜ $T(3)
            @eval @test @inferred(twice($T, 3)) ==ₜ $T(6)
            @eval @test @inferred(twice($T, Float16(2.5))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, Float32(2.5))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, Float64(2.5))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, BigFloat(2.5))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, 17//2)) ==ₜ $T(17)
            @eval @test @inferred(twice($T, complex(HalfInt(3)))) ==ₜ $T(6)
            @eval @test @inferred(twice($T, complex(HalfInt(3/2)))) ==ₜ $T(3)
            @eval @test @inferred(twice($T, complex(3))) ==ₜ $T(6)
            @eval @test @inferred(twice($T, complex(Float16(2.5)))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, complex(Float32(2.5)))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, complex(Float64(2.5)))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, complex(BigFloat(2.5)))) ==ₜ $T(5)
            @eval @test @inferred(twice($T, complex(17//2))) ==ₜ $T(17)
            @eval @test_throws InexactError twice($T, Float16(2.3))
            @eval @test_throws InexactError twice($T, Float32(2.3))
            @eval @test_throws InexactError twice($T, Float64(2.3))
            @eval @test_throws InexactError twice($T, BigFloat(2.3))
            @eval @test_throws InexactError twice($T, Inf)
            @eval @test_throws InexactError twice($T, -Inf)
            @eval @test_throws InexactError twice($T, NaN)
            @eval @test_throws InexactError twice($T, 1//5)
            @eval @test_throws InexactError twice($T, 1//0)
            @eval @test_throws InexactError twice($T, Complex{HalfInt}(3, 1))
            @eval @test_throws InexactError twice($T, Complex{HalfInt}(0, 3/2))
            @eval @test_throws InexactError twice($T, Complex{Int}(3, 1))
            @eval @test_throws InexactError twice($T, Complex{Float16}(2.0, 0.5))
            @eval @test_throws InexactError twice($T, Complex{Float32}(2.0, 0.5))
            @eval @test_throws InexactError twice($T, Complex{Float64}(2.0, 0.5))
            @eval @test_throws InexactError twice($T, Complex{BigFloat}(2.0, 0.5))
            @eval @test_throws InexactError twice($T, Complex{Rational{Int}}(17//2, 15//2))
        end
        @test twice(Float16(2.3)) === Float16(4.6)
        @test twice(Float32(2.3)) === Float32(4.6)
        @test twice(Float64(2.3)) === Float64(4.6)
        @test twice(BigFloat(2.3)) ==ₜ BigFloat(4.6)
        @test twice(Inf) === Inf
        @test twice(-Inf) === -Inf
        @test twice(NaN) === NaN
    end

    @testset "Complex" begin
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test twice(Complex{Half{$T}}(2, 3/2)) ==ₜ Complex{$T}(4, 3)
            @eval @test twice(Complex{$T}(3, 2)) ==ₜ Complex{$T}(6, 4)
            @eval @test twice(Complex{$T}, HalfInt(3)) ==ₜ Complex{$T}(6,0)
            @eval @test twice(Complex{$T}, HalfInt(3/2)) ==ₜ Complex{$T}(3,0)
            @eval @test twice(Complex{$T}, 3) ==ₜ Complex{$T}(6,0)
            @eval @test twice(Complex{$T}, Float16(2.5)) ==ₜ Complex{$T}(5,0)
            @eval @test twice(Complex{$T}, Float32(2.5)) ==ₜ Complex{$T}(5,0)
            @eval @test twice(Complex{$T}, Float64(2.5)) ==ₜ Complex{$T}(5,0)
            @eval @test twice(Complex{$T}, BigFloat(2.5)) ==ₜ Complex{$T}(5,0)
            @eval @test twice(Complex{$T}, 17//2) ==ₜ Complex{$T}(17,0)
            @eval @test twice(Complex{$T}, Complex{HalfInt}(3, 7/2)) ==ₜ Complex{$T}(6,7)
            @eval @test twice(Complex{$T}, Complex{Int}(3,2)) ==ₜ Complex{$T}(6,4)
            @eval @test twice(Complex{$T}, Complex{Float16}(2.5, 1.0)) ==ₜ Complex{$T}(5,2)
            @eval @test twice(Complex{$T}, Complex{Float32}(2.5, 1.0)) ==ₜ Complex{$T}(5,2)
            @eval @test twice(Complex{$T}, Complex{Float64}(2.5, 1.0)) ==ₜ Complex{$T}(5,2)
            @eval @test twice(Complex{$T}, Complex{BigFloat}(2.5, 1.0)) ==ₜ Complex{$T}(5,2)
            @eval @test twice(Complex{$T}, Complex{Rational{Int}}(17//2, 3//1)) ==ₜ Complex{$T}(17,6)
            @eval @test_throws InexactError twice(Complex{$T}, Float16(2.3))
            @eval @test_throws InexactError twice(Complex{$T}, Float32(2.3))
            @eval @test_throws InexactError twice(Complex{$T}, Float64(2.3))
            @eval @test_throws InexactError twice(Complex{$T}, BigFloat(2.3))
            @eval @test_throws InexactError twice(Complex{$T}, 1//5)
            @eval @test_throws InexactError twice(Complex{$T}, Complex{Float16}(2.0, 0.6))
            @eval @test_throws InexactError twice(Complex{$T}, Complex{Float32}(2.0, 0.6))
            @eval @test_throws InexactError twice(Complex{$T}, Complex{Float64}(2.0, 0.6))
            @eval @test_throws InexactError twice(Complex{$T}, Complex{BigFloat}(2.0, 0.6))
            @eval @test_throws InexactError twice(Complex{$T}, Complex{Rational{Int}}(17//2, 15//4))
        end
        @test twice(Complex{Float16}(2.0, 2.3)) === Complex{Float16}(4.0, 4.6)
        @test twice(Complex{Float32}(2.0, 2.3)) === Complex{Float32}(4.0, 4.6)
        @test twice(Complex{Float64}(2.0, 2.3)) === Complex{Float64}(4.0, 4.6)
        @test twice(Complex{BigFloat}(2.0, 2.3)) ==ₜ Complex{BigFloat}(4.0, 4.6)
        @test twice(Complex{Rational{Int}}(2//3, 3//8)) === Complex{Rational{Int}}(4//3, 3//4)
    end
end

@testset "onehalf" begin
    @test onehalf(Number) === onehalf(HalfInt)
    @test onehalf(Complex) === onehalf(Complex{HalfInt})
    for T in (:Real, :HalfInteger, halfinttypes..., halfuinttypes..., :BigHalfInt, :(Half{Integer}),
              :AbstractFloat, :Float16, :Float32, :Float64, :BigFloat,
              :Rational, :(Rational{Int}), :(Rational{UInt8}), :(Rational{BigInt}), :(Rational{Integer}))
        @eval @test onehalf($T) ==ₜ $T(HalfInt(1/2))
        @eval @test onehalf(Complex{$T}) ==ₜ Complex{$T}(HalfInt(1/2), 0)
    end
end

@testset "Properties" begin
    @testset "isfinite" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test isfinite($T(3))
            @eval @test isfinite($T(5/2))
        end
    end

    @testset "ishalfinteger" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test ishalfinteger($T(3))
            @eval @test ishalfinteger($T(5/2))
        end
        @test ishalfinteger(5)
        @test ishalfinteger(big(-5))
        @test ishalfinteger(5//2)
        @test ishalfinteger(-3//2)
        @test !ishalfinteger(4//3)
        @test ishalfinteger(2.0)
        @test ishalfinteger(-7.5)
        @test !ishalfinteger(2.3)
        @test !ishalfinteger(π)
        @test !ishalfinteger(ℯ)
        @test !ishalfinteger(im)
    end

    @testset "isinteger" begin
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test isinteger($T(3))
            @eval @test isinteger($T(-3))
            @eval @test !isinteger($T(5/2))
            @eval @test !isinteger($T(-5/2))
        end
        for T in halfuinttypes
            @eval @test isinteger($T(3))
            @eval @test !isinteger($T(5/2))
        end
    end

    @static if VERSION ≥ v"1.6.0-DEV.999"
        @testset "ispow2" begin
            for T in (halfinttypes..., :BigHalfInt)
                @eval @test ispow2($T(1/2))
                @eval @test ispow2($T(1))
                @eval @test ispow2($T(4))
                @eval @test !ispow2($T(0))
                @eval @test !ispow2($T(3/2))
                @eval @test !ispow2($T(-1/2))
                @eval @test !ispow2($T(-1))
                @eval @test !ispow2($T(-4))
            end
            for T in halfuinttypes
                @eval @test ispow2($T(1/2))
                @eval @test ispow2($T(1))
                @eval @test ispow2($T(4))
                @eval @test !ispow2($T(0))
                @eval @test !ispow2($T(3/2))
            end
        end
    end

    @testset "typemin/typemax" begin
        for T in (inttypes..., uinttypes...)
            @eval @test typemin(Half{$T}) === half(Half{$T}, typemin($T))
            @eval @test typemax(Half{$T}) === half(Half{$T}, typemax($T))
            @eval @test Base.hastypemax(Half{$T})
        end
        @test !Base.hastypemax(BigHalfInt)
    end

    @testset "one/zero/isone/iszero" begin
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test one($T) ==ₜ $T(1)
            @eval @test zero($T) ==ₜ $T(0)
            @eval @test iszero($T(0))
            @eval @test !iszero($T(1))
            @eval @test !iszero($T(-1))
            @eval @test !iszero($T(1/2))
            @eval @test !iszero($T(-1/2))
            @eval @test isone($T(1))
            @eval @test !isone($T(-1))
            @eval @test !isone($T(0))
            @eval @test !isone($T(1/2))
            @eval @test !isone($T(-1/2))
        end
        for T in halfuinttypes
            @eval @test one($T) === $T(1)
            @eval @test zero($T) === $T(0)
            @eval @test isone($T(1))
            @eval @test !isone($T(0))
            @eval @test !isone($T(1/2))
            @eval @test iszero($T(0))
            @eval @test !iszero($T(1))
            @eval @test !iszero($T(1/2))
        end
    end

    @testset "numerator/denominator" begin
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test @inferred(numerator(Half{$T}(7/2))) ==ₜ $T(7)
            @eval @test numerator(Half{$T}(3)) ==ₜ $T(3)
            @eval @test @inferred(denominator(Half{$T}(7/2))) ==ₜ $T(2)
            @eval @test denominator(Half{$T}(3)) ==ₜ $T(1)
        end
    end
end

@testset "Comparison" begin
    @testset "<" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            for S in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                @eval @test $S(3/2) < $T(5/2)
                @eval @test $S(3/2) < $T(2)
                @eval @test !($S(3/2) < $T(3/2))
                @eval @test !($S(3/2) < $T(1))
            end
            for S in (halfinttypes..., :BigHalfInt)
                @eval @test $S(-3/2) < $T(1/2)
            end
            @eval @test $T(3/2) < 1.6
            @eval @test $T(3/2) < 2
            @eval @test $T(3/2) < big(1.6)
            @eval @test $T(3/2) < big(2)
            @eval @test $T(3/2) < 31//20
            @eval @test $T(3/2) < Inf
            @eval @test $T(3/2) < 1//0
            @eval @test $T(3/2) > -Inf
            @eval @test $T(3/2) > -1//0
            @eval @test !($T(3/2) < 1)
            @eval @test !($T(3/2) < 29//20)
            @eval @test !($T(0) < -0.0)
            @eval @test !($T(0) > -0.0)
        end
        for T in (halfinttypes..., :BigHalfInt)
            for S in (halfinttypes..., :BigHalfInt)
                @eval @test $T(-5/2) < $S(-2)
                @eval @test !($T(-5/2) < $S(-5/2))
                @eval @test !($T(-5/2) < $S(-3))
            end
        end
    end

    @testset "<=" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            for S in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                @eval @test $S(3/2) <= $T(5/2)
                @eval @test $S(3/2) <= $T(2)
                @eval @test $S(3/2) <= $T(3/2)
                @eval @test !($S(3/2) <= $T(1))
            end
            for S in (halfinttypes..., :BigHalfInt)
                @eval @test $S(-3/2) <= $T(1/2)
            end
            @eval @test $T(3/2) <= 1.6
            @eval @test $T(3/2) <= 2
            @eval @test $T(3/2) <= big(1.6)
            @eval @test $T(3/2) <= big(2)
            @eval @test $T(3/2) <= 31//20
            @eval @test $T(3/2) <= 1.5
            @eval @test $T(3/2) <= big(1.5)
            @eval @test $T(3/2) <= 3//2
            @eval @test $T(3/2) <= Inf
            @eval @test $T(3/2) <= 1//0
            @eval @test $T(3/2) >= -Inf
            @eval @test $T(3/2) >= -1//0
            @eval @test !($T(3/2) <= 1)
            @eval @test !($T(3/2) <= 29//20)
            @eval @test $T(0) <= -0.0
            @eval @test $T(0) >= -0.0
        end
        for T in (halfinttypes..., :BigHalfInt)
            for S in (halfinttypes..., :BigHalfInt)
                @eval @test $T(-5/2) <= $S(-2)
                @eval @test $T(-5/2) <= $S(-5/2)
                @eval @test !($T(-5/2) <= $S(-3))
            end
        end
    end

    @testset "==" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            for S in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                @eval @test $S(3/2) == $T(3/2)
                @eval @test $S(2) == $T(2)
                @eval @test $S(3/2) != $T(2)
            end
            for S in (halfinttypes..., :BigHalfInt)
                @eval @test $S(-3/2) != $T(3/2)
            end
            @eval @test $T(2) == 2
            @eval @test $T(2) == big(2)
            @eval @test $T(3/2) == 1.5
            @eval @test $T(3/2) == big(1.5)
            @eval @test $T(3/2) != big(1.6)
            @eval @test $T(3/2) == 3//2
            @eval @test $T(3/2) != Inf
            @eval @test $T(3/2) != 1//0
            @eval @test $T(3/2) != -Inf
            @eval @test $T(3/2) != -1//0
            @eval @test $T(3/2) != 29//20
            @eval @test $T(0) == -0.0
        end
        for T in (halfinttypes..., :BigHalfInt)
            for S in (halfinttypes..., :BigHalfInt)
                @eval @test $T(-5/2) != $S(-2)
                @eval @test $T(-5/2) == $S(-5/2)
            end
        end
    end
end

@testset "Arithmetic" begin
    @testset "Addition/subtraction" begin
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test +$T(5/2) ==ₜ $T(5/2)
            @eval @test -$T(5/2) ==ₜ $T(-5/2)
            @eval @test $T(1/2) + $T(2) ==ₜ $T(5/2)
            @eval @test $T(1/2) - $T(2) ==ₜ $T(-3/2)
        end
        for T in halfinttypes
            @eval @test $T(3/2) + (-2) == -1/2
            @eval @test $T(3/2) - (-2) == 7/2
            @eval @test 1.5 + $T(-2) == -1/2
            @eval @test 1.5 - $T(-2) == 7/2
        end
        for T in halfuinttypes
            @eval @test +$T(2) === $T(2)
            @eval @test $T(1/2) + $T(2) === $T(5/2)
            @eval @test $T(5/2) - $T(2) === $T(1/2)
            @eval @test $T(3/2) + (1) == 5/2
            @eval @test $T(3/2) - (1) == 1/2
            @eval @test (3/2) + $T(1) == 5/2
            @eval @test (3/2) - $T(1) == 1/2
        end
        @test BigHalfInt(1/2) + 2 ==ₜ BigHalfInt(5/2)
        @test BigHalfInt(1/2) - 2 ==ₜ BigHalfInt(-3/2)
        @test 0.5 + BigHalfInt(2) ==ₜ BigFloat(2.5)
        @test 0.5 - BigHalfInt(2) ==ₜ BigFloat(-1.5)
        @test HalfInt8(3/2) + HalfInt64(1/2) === HalfInt64(2)
        @test HalfInt8(3/2) - HalfInt64(1/2) === HalfInt64(1)
        @test HalfInt32(5/2) + 3 === HalfInt(11/2)
        @test 2.5 + HalfInt16(3) === 5.5
    end

    @testset "Multiplication" begin
        @test typemax(HalfInt8)*typemax(HalfInt8) === 16_129/4
        for T in (halfinttypes..., halfuinttypes...)
            @eval @test $T(3/2) * $T(5/2) === 3.75
            @eval @test $T(3/2) * $T(2) === 3.0
            @eval @test $T(3/2) * 2 isa HalfInteger
            @eval @test $T(3/2) * 2 == HalfInt(3)
            @eval @test $T(3/2) * BigInt(2) ==ₜ BigHalfInt(3)
            @eval @test $T(3/2) * Float16(2.5) === Float16(3.75)
            @eval @test $T(3/2) * Float32(2.5) === Float32(3.75)
            @eval @test $T(3/2) * Float64(2.5) === Float64(3.75)
            @eval @test $T(3/2) * BigFloat(2.5) ==ₜ BigFloat(3.75)
            @eval @test $T(3/2) * (5//2) isa Rational
            @eval @test $T(3/2) * (5//2) == 15//4
            @eval @test $T(3/2) * Rational{BigInt}(5//2) ==ₜ Rational{BigInt}(15//4)
            @eval @test 2 * $T(3/2) isa HalfInteger
            @eval @test 2 * $T(3/2) == HalfInt(3)
            @eval @test BigInt(2) * $T(3/2) ==ₜ BigHalfInt(3)
            @eval @test Float16(2.5) * $T(3/2) === Float16(3.75)
            @eval @test Float32(2.5) * $T(3/2) === Float32(3.75)
            @eval @test Float64(2.5) * $T(3/2) === Float64(3.75)
            @eval @test BigFloat(2.5) * $T(3/2) ==ₜ BigFloat(3.75)
            @eval @test (5//2) * $T(3/2) isa Rational
            @eval @test (5//2) * $T(3/2) == 15//4
            @eval @test Rational{BigInt}(5//2) * $T(3/2) ==ₜ Rational{BigInt}(15//4)
        end
        @test HalfInt16(3/2) * HalfUInt128(5/2) == 3.75
        @test BigHalfInt(3/2) * BigHalfInt(5/2) ==ₜ BigFloat(3.75)
        @test BigHalfInt(3/2) * BigHalfInt(2) ==ₜ BigFloat(3.0)
        @test BigHalfInt(3/2) * 2 ==ₜ BigHalfInt(3)
        @test BigHalfInt(3/2) * BigInt(2) ==ₜ BigHalfInt(3)
        @test BigHalfInt(3/2) * Float16(2.5) ==ₜ BigFloat(3.75)
        @test BigHalfInt(3/2) * Float32(2.5) ==ₜ BigFloat(3.75)
        @test BigHalfInt(3/2) * Float64(2.5) ==ₜ BigFloat(3.75)
        @test BigHalfInt(3/2) * BigFloat(2.5) ==ₜ BigFloat(3.75)
        @test BigHalfInt(3/2) * (5//2) == Rational{BigInt}(15//4)
        @test 2* BigHalfInt(3/2) ==ₜ BigHalfInt(3)
        @test BigInt(2) * BigHalfInt(3/2) ==ₜ BigHalfInt(3)
        @test Float16(2.5) * BigHalfInt(3/2) ==ₜ BigFloat(3.75)
        @test Float32(2.5) * BigHalfInt(3/2) ==ₜ BigFloat(3.75)
        @test Float64(2.5) * BigHalfInt(3/2) ==ₜ BigFloat(3.75)
        @test BigFloat(2.5) * BigHalfInt(3/2) ==ₜ BigFloat(3.75)
        @test (5//2) * BigHalfInt(3/2) ==ₜ Rational{BigInt}(15//4)
    end

    @testset "Division" begin
        @testset "/" begin
            for T in (halfinttypes..., halfuinttypes...)
                @eval @test $T(3/2) / $T(2) === 0.75
                @eval @test $T(3/2) / 2 === 0.75
                @eval @test $T(3/2) / BigInt(2) ==ₜ BigFloat(0.75)
                @eval @test $T(3/2) / Float16(2.0) === Float16(0.75)
                @eval @test $T(3/2) / Float32(2.0) === Float32(0.75)
                @eval @test $T(3/2) / Float64(2.0) === Float64(0.75)
                @eval @test $T(3/2) / BigFloat(2.0) ==ₜ BigFloat(0.75)
                @eval @test $T(3/2) / (2//3) isa Rational
                @eval @test $T(3/2) / (2//3) == 9//4
                @eval @test 3 / $T(2) === 1.5
                @eval @test BigInt(3) / $T(2) ==ₜ BigFloat(1.5)
                @eval @test Float16(3.0) / $T(2) === Float16(1.5)
                @eval @test Float32(3.0) / $T(2) === Float32(1.5)
                @eval @test Float64(3.0) / $T(2) === Float64(1.5)
                @eval @test BigFloat(3.0) / $T(2) ==ₜ BigFloat(1.5)
                @eval @test (2//3) / $T(5/2) isa Rational
                @eval @test (2//3) / $T(5/2) == 4//15
            end
            @test HalfInt128(3/2) / HalfInt16(3/2) == 1.0
            @test BigHalfInt(3/2) / BigHalfInt(2) ==ₜ BigFloat(0.75)
            @test BigHalfInt(3/2) / 2 ==ₜ BigFloat(0.75)
            @test BigHalfInt(3/2) / BigInt(2) ==ₜ BigFloat(0.75)
            @test BigHalfInt(3/2) / Float16(2.0) ==ₜ BigFloat(0.75)
            @test BigHalfInt(3/2) / Float32(2.0) ==ₜ BigFloat(0.75)
            @test BigHalfInt(3/2) / Float64(2.0) ==ₜ BigFloat(0.75)
            @test BigHalfInt(3/2) / BigFloat(2.0) ==ₜ BigFloat(0.75)
            @test BigHalfInt(3/2) / (4//3) ==ₜ Rational{BigInt}(9//8)
            @test 2 / BigHalfInt(2) ==ₜ BigFloat(1.0)
            @test BigInt(2) / BigHalfInt(2) ==ₜ BigFloat(1.0)
            @test Float16(2.0) / BigHalfInt(2) ==ₜ BigFloat(1.0)
            @test Float32(2.0) / BigHalfInt(2) ==ₜ BigFloat(1.0)
            @test Float64(2.0) / BigHalfInt(2) ==ₜ BigFloat(1.0)
            @test BigFloat(2.0) / BigHalfInt(2) ==ₜ BigFloat(1.0)
            @test (4//3) / BigHalfInt(3/2) ==ₜ Rational{BigInt}(8//9)
        end

        @testset "\\" begin
            for T in (halfinttypes..., halfuinttypes...)
                @eval @test $T(2) \ $T(3/2) === 0.75
                @eval @test 2 \ $T(3/2) === 0.75
                @eval @test BigInt(2) \ $T(3/2) ==ₜ BigFloat(0.75)
                @eval @test Float16(2.0) \ $T(3/2) === Float16(0.75)
                @eval @test Float32(2.0) \ $T(3/2) === Float32(0.75)
                @eval @test Float64(2.0) \ $T(3/2) === Float64(0.75)
                @eval @test BigFloat(2.0) \ $T(3/2) ==ₜ BigFloat(0.75)
                @eval @test (2//3) \ $T(3/2) isa Rational
                @eval @test (2//3) \ $T(3/2) == 9//4
                @eval @test $T(2) \ 3 === 1.5
                @eval @test $T(2) \ BigInt(3) ==ₜ BigFloat(1.5)
                @eval @test $T(2) \ Float16(3.0) === Float16(1.5)
                @eval @test $T(2) \ Float32(3.0) === Float32(1.5)
                @eval @test $T(2) \ Float64(3.0) === Float64(1.5)
                @eval @test $T(2) \ BigFloat(3.0) ==ₜ BigFloat(1.5)
                @eval @test $T(5/2) \ (2//3) isa Rational
                @eval @test $T(5/2) \ (2//3) == 4//15
            end
            @test HalfInt16(3/2) \ HalfInt128(3/2) == 1.0
            @test BigHalfInt(2) \ BigHalfInt(3/2) ==ₜ BigFloat(0.75)
            @test 2 \ BigHalfInt(3/2) ==ₜ BigFloat(0.75)
            @test BigInt(2) \ BigHalfInt(3/2) ==ₜ BigFloat(0.75)
            @test Float16(2.0) \ BigHalfInt(3/2) ==ₜ BigFloat(0.75)
            @test Float32(2.0) \ BigHalfInt(3/2) ==ₜ BigFloat(0.75)
            @test Float64(2.0) \ BigHalfInt(3/2) ==ₜ BigFloat(0.75)
            @test BigFloat(2.0) \ BigHalfInt(3/2) ==ₜ BigFloat(0.75)
            @test (4//3) \ BigHalfInt(3/2) ==ₜ Rational{BigInt}(9//8)
            @test BigHalfInt(2) \ 2 ==ₜ BigFloat(1.0)
            @test BigHalfInt(2) \ BigInt(2) ==ₜ BigFloat(1.0)
            @test BigHalfInt(2) \ Float16(2.0) ==ₜ BigFloat(1.0)
            @test BigHalfInt(2) \ Float32(2.0) ==ₜ BigFloat(1.0)
            @test BigHalfInt(2) \ Float64(2.0) ==ₜ BigFloat(1.0)
            @test BigHalfInt(2) \ BigFloat(2.0) ==ₜ BigFloat(1.0)
            @test BigHalfInt(3/2) \ (4//3) ==ₜ Rational{BigInt}(8//9)
        end

        @testset "//" begin
            for T in (halfinttypes..., halfuinttypes...)
                @eval @test $T(7/2) // $T(5/2) isa Rational
                @eval @test $T(7/2) // $T(5/2) == 7//5
                @eval @test $T(3/2) // 2 isa Rational
                @eval @test $T(3/2) // 2 == 3//4
                @eval @test $T(3/2) // BigInt(2) ==ₜ Rational{BigInt}(3//4)
                @eval @test $T(3/2) // (2//3) isa Rational
                @eval @test $T(3/2) // (2//3) == 9//4
                @eval @test 2 // $T(3/2) isa Rational
                @eval @test 2 // $T(3/2) == 4//3
                @eval @test BigInt(2) // $T(3/2) ==ₜ Rational{BigInt}(4//3)
                @eval @test (2//3) // $T(3/2) isa Rational
                @eval @test (2//3) // $T(3/2) == 4//9
            end
            @test HalfInt128(3/2) // HalfInt16(3/2) == 1//1
            @test BigHalfInt(3/2) // BigHalfInt(2) ==ₜ Rational{BigInt}(3//4)
            @test BigHalfInt(3/2) // 2 ==ₜ Rational{BigInt}(3//4)
            @test BigHalfInt(3/2) // BigInt(2) ==ₜ Rational{BigInt}(3//4)
            @test BigHalfInt(3/2) // (4//3) ==ₜ Rational{BigInt}(9//8)
            @test 2 // BigHalfInt(2) ==ₜ Rational{BigInt}(1//1)
            @test BigInt(2) // BigHalfInt(2) ==ₜ Rational{BigInt}(1//1)
            @test (4//3) // BigHalfInt(3/2) ==ₜ Rational{BigInt}(8//9)

            # Extra tests for ambiguity resolution with Base
            for T in (halfinttypes..., halfuinttypes..., BigHalfInt)
                @eval @test [1]//$T(2) ==ₜ [1//$T(2)]
                @eval @test Complex(2,0)//$T(2) ==ₜ Complex(2//$T(2),0//1)
                @eval @test $T(2)//Complex(2,0) ==ₜ Complex($T(2)//2,0//1)
            end
        end

        @testset "div/rem/mod" begin
            for f in (:div, :fld, :cld, :rem, :mod, :fld1, :mod1)
                for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                    @eval @test @inferred($f($T(7/2), $T(3/2))) == $f(7//2, 3//2)
                    @eval @test @inferred($f($T(7/2), $T(1/2))) == $f(7//2, 1//2)
                    @eval @test @inferred($f($T(9/2), 3)) == $f(9//2, 3)
                    @eval @test @inferred($f($T(7/2), big(-2))) == $f(7//2, -2)
                    @eval @test @inferred($f(4, $T(3/2))) == $f(4, 3//2)
                    @eval @test @inferred($f(big(-7), $T(5/2))) == $f(-7, 5//2)
                end
                @eval @test @inferred($f(HalfInt32(7/2), HalfInt128(3/2))) == $f(7//2, 3//2)
                @eval @test @inferred($f(HalfInt8(7/2), HalfInt64(1/2))) == $f(7//2, 1//2)
                @eval @test @inferred($f(HalfInt16(9/2), HalfInt32(3))) == $f(9//2, 3)
                @eval @test @inferred($f(HalfInt64(7/2), HalfInt128(-2))) == $f(7//2, -2)
                @eval @test @inferred($f(HalfInt16(4), HalfInt8(3/2))) == $f(4, 3//2)
                @eval @test @inferred($f(HalfInt64(-7), HalfInt32(5/2))) == $f(-7, 5//2)
            end
            for f in (:div, :fld, :cld, :fld1)
                @eval @test @inferred($f(BigHalfInt(7/2), BigHalfInt(3/2))) isa BigInt
                @eval @test @inferred($f(BigHalfInt(9/2), 3)) isa BigInt
                @eval @test @inferred($f(BigHalfInt(9/2), big(3))) isa BigInt
                @eval @test @inferred($f(HalfInt(9/2), big(3))) isa BigInt
                @eval @test @inferred($f(big(4), BigHalfInt(3/2))) isa BigInt
                @eval @test @inferred($f(big(4), HalfInt(3/2))) isa BigInt
            end
            for f in (:rem, :mod, :mod1)
                @eval @test @inferred($f(BigHalfInt(7/2), BigHalfInt(3/2))) isa BigHalfInt
                @eval @test @inferred($f(BigHalfInt(9/2), 3)) isa BigHalfInt
                @eval @test @inferred($f(BigHalfInt(9/2), big(3))) isa BigHalfInt
                @eval @test @inferred($f(HalfInt(9/2), big(3))) isa BigHalfInt
                @eval @test @inferred($f(big(4), BigHalfInt(3/2))) isa BigHalfInt
                @eval @test @inferred($f(big(4), HalfInt(3/2))) isa BigHalfInt
            end
        end
        for r in (:RoundToZero, :RoundUp, :RoundDown)
            for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                if T in halfuinttypes && r == :RoundUp
                    # cf. https://github.com/JuliaLang/julia/issues/34325
                    @eval @test_skip @inferred(rem($T(7/2), $T(3/2), $r)) == rem(7//2, 3//2, $r)
                    @eval @test_skip @inferred(rem($T(7/2), $T(1/2), $r)) == rem(7//2, 1//2, $r)
                    @eval @test_skip @inferred(rem($T(9/2), 3, $r)) == rem(9//2, 3, $r)
                    @eval @test_skip @inferred(rem($T(7/2), big(-2), $r)) == rem(7//2, -2, $r)
                    @eval @test_skip @inferred(rem(4, $T(3/2), $r)) == rem(4, 3//2, $r)
                    @eval @test_skip @inferred(rem(big(-7), $T(5/2), $r)) == rem(-7, 5//2, $r)
                else
                    @eval @test @inferred(rem($T(7/2), $T(3/2), $r)) == rem(7//2, 3//2, $r)
                    @eval @test @inferred(rem($T(7/2), $T(1/2), $r)) == rem(7//2, 1//2, $r)
                    @eval @test @inferred(rem($T(9/2), 3, $r)) == rem(9//2, 3, $r)
                    @eval @test @inferred(rem($T(7/2), big(-2), $r)) == rem(7//2, -2, $r)
                    @eval @test @inferred(rem(4, $T(3/2), $r)) == rem(4, 3//2, $r)
                    @eval @test @inferred(rem(big(-7), $T(5/2), $r)) == rem(-7, 5//2, $r)
                end
            end
            @eval @test @inferred(rem(HalfInt32(7/2), HalfInt128(3/2), $r)) == rem(7//2, 3//2, $r)
            @eval @test @inferred(rem(HalfInt8(7/2), HalfInt64(1/2), $r)) == rem(7//2, 1//2, $r)
            @eval @test @inferred(rem(HalfInt16(9/2), HalfInt32(3), $r)) == rem(9//2, 3, $r)
            @eval @test @inferred(rem(HalfInt64(7/2), HalfInt128(-2), $r)) == rem(7//2, -2, $r)
            @eval @test @inferred(rem(HalfInt16(4), HalfInt8(3/2), $r)) == rem(4, 3//2, $r)
            @eval @test @inferred(rem(HalfInt64(-7), HalfInt32(5/2), $r)) == rem(-7, 5//2, $r)
            @eval @test @inferred(rem(BigHalfInt(7/2), BigHalfInt(3/2), $r)) isa BigHalfInt
            @eval @test @inferred(rem(BigHalfInt(9/2), 3, $r)) isa BigHalfInt
            @eval @test @inferred(rem(BigHalfInt(9/2), big(3), $r)) isa BigHalfInt
            @eval @test @inferred(rem(HalfInt(9/2), big(3), $r)) isa BigHalfInt
            @eval @test @inferred(rem(big(4), BigHalfInt(3/2), $r)) isa BigHalfInt
            @eval @test @inferred(rem(big(4), HalfInt(3/2), $r)) isa BigHalfInt
        end
        @static if VERSION ≥ v"1.4.0-DEV.208"
            for r in (:RoundNearest, :RoundNearestTiesAway, :RoundNearestTiesUp, :RoundToZero, :RoundUp, :RoundDown)
                for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                    @eval @test @inferred(div($T(7/2), $T(3/2), $r)) == div(7//2, 3//2, $r)
                    @eval @test @inferred(div($T(7/2), $T(1/2), $r)) == div(7//2, 1//2, $r)
                    @eval @test @inferred(div($T(9/2), 3, $r)) == div(9//2, 3, $r)
                    @eval @test @inferred(div($T(7/2), big(-2), $r)) == div(7//2, -2, $r)
                    @eval @test @inferred(div(4, $T(3/2), $r)) == div(4, 3//2, $r)
                    @eval @test @inferred(div(big(-7), $T(5/2), $r)) == div(-7, 5//2, $r)
                end
                @eval @test @inferred(div(HalfInt32(7/2), HalfInt128(3/2), $r)) == div(7//2, 3//2, $r)
                @eval @test @inferred(div(HalfInt8(7/2), HalfInt64(1/2), $r)) == div(7//2, 1//2, $r)
                @eval @test @inferred(div(HalfInt16(9/2), HalfInt32(3), $r)) == div(9//2, 3, $r)
                @eval @test @inferred(div(HalfInt64(7/2), HalfInt128(-2), $r)) == div(7//2, -2, $r)
                @eval @test @inferred(div(HalfInt16(4), HalfInt8(3/2), $r)) == div(4, 3//2, $r)
                @eval @test @inferred(div(HalfInt64(-7), HalfInt32(5/2), $r)) == div(-7, 5//2, $r)
                @eval @test @inferred(div(BigHalfInt(7/2), BigHalfInt(3/2), $r)) isa BigInt
                @eval @test @inferred(div(BigHalfInt(9/2), 3, $r)) isa BigInt
                @eval @test @inferred(div(BigHalfInt(9/2), big(3), $r)) isa BigInt
                @eval @test @inferred(div(HalfInt(9/2), big(3), $r)) isa BigInt
                @eval @test @inferred(div(big(4), BigHalfInt(3/2), $r)) isa BigInt
                @eval @test @inferred(div(big(4), HalfInt(3/2), $r)) isa BigInt
            end
            for r in (:RoundToZero, :RoundUp, :RoundDown)
                for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                    if T in halfuinttypes && r == :RoundUp
                        # cf. https://github.com/JuliaLang/julia/issues/34325
                        @eval @test_skip @inferred(divrem($T(7/2), $T(3/2), $r)) == divrem(7//2, 3//2, $r)
                        @eval @test_skip @inferred(divrem($T(7/2), $T(1/2), $r)) == divrem(7//2, 1//2, $r)
                        @eval @test_skip @inferred(divrem($T(9/2), 3, $r)) == divrem(9//2, 3, $r)
                        @eval @test_skip @inferred(divrem($T(7/2), big(-2), $r)) == divrem(7//2, -2, $r)
                        @eval @test_skip @inferred(divrem(4, $T(3/2), $r)) == divrem(4, 3//2, $r)
                        @eval @test_skip @inferred(divrem(big(-7), $T(5/2), $r)) == divrem(-7, 5//2, $r)
                    else
                        @eval @test @inferred(divrem($T(7/2), $T(3/2), $r)) == divrem(7//2, 3//2, $r)
                        @eval @test @inferred(divrem($T(7/2), $T(1/2), $r)) == divrem(7//2, 1//2, $r)
                        @eval @test @inferred(divrem($T(9/2), 3, $r)) == divrem(9//2, 3, $r)
                        @eval @test @inferred(divrem($T(7/2), big(-2), $r)) == divrem(7//2, -2, $r)
                        @eval @test @inferred(divrem(4, $T(3/2), $r)) == divrem(4, 3//2, $r)
                        @eval @test @inferred(divrem(big(-7), $T(5/2), $r)) == divrem(-7, 5//2, $r)
                    end
                end
                @eval @test @inferred(divrem(HalfInt32(7/2), HalfInt128(3/2), $r)) == divrem(7//2, 3//2, $r)
                @eval @test @inferred(divrem(HalfInt8(7/2), HalfInt64(1/2), $r)) == divrem(7//2, 1//2, $r)
                @eval @test @inferred(divrem(HalfInt16(9/2), HalfInt32(3), $r)) == divrem(9//2, 3, $r)
                @eval @test @inferred(divrem(HalfInt64(7/2), HalfInt128(-2), $r)) == divrem(7//2, -2, $r)
                @eval @test @inferred(divrem(HalfInt16(4), HalfInt8(3/2), $r)) == divrem(4, 3//2, $r)
                @eval @test @inferred(divrem(HalfInt64(-7), HalfInt32(5/2), $r)) == divrem(-7, 5//2, $r)
                @eval @test @inferred(divrem(BigHalfInt(7/2), BigHalfInt(3/2), $r)) isa Tuple{BigInt,BigHalfInt}
                @eval @test @inferred(divrem(BigHalfInt(9/2), 3, $r)) isa Tuple{BigInt,BigHalfInt}
                @eval @test @inferred(divrem(BigHalfInt(9/2), big(3), $r)) isa Tuple{BigInt,BigHalfInt}
                @eval @test @inferred(divrem(HalfInt(9/2), big(3), $r)) isa Tuple{BigInt,BigHalfInt}
                @eval @test @inferred(divrem(big(4), BigHalfInt(3/2), $r)) isa Tuple{BigInt,BigHalfInt}
                @eval @test @inferred(divrem(big(4), HalfInt(3/2), $r)) isa Tuple{BigInt,BigHalfInt}
            end
        end
        @static if VERSION ≥ v"1.5.0-DEV.471"
            for (f,bigreturntype) in ((:rem, :BigHalfInt), (:divrem, :(Tuple{BigInt,BigHalfInt})))
                for T in (halfinttypes..., :BigHalfInt)
                    @eval @test @inferred($f($T(7/2), $T(3/2), RoundNearest)) == $f(7//2, 3//2, RoundNearest)
                    @eval @test @inferred($f($T(7/2), $T(1/2), RoundNearest)) == $f(7//2, 1//2, RoundNearest)
                    @eval @test @inferred($f($T(9/2), 3, RoundNearest)) == $f(9//2, 3, RoundNearest)
                    @eval @test @inferred($f($T(7/2), big(-2), RoundNearest)) == $f(7//2, -2, RoundNearest)
                    @eval @test @inferred($f(4, $T(3/2), RoundNearest)) == $f(4, 3//2, RoundNearest)
                    @eval @test @inferred($f(big(-7), $T(5/2), RoundNearest)) == $f(-7, 5//2, RoundNearest)
                end
                for T in halfuinttypes
                    # cf. https://github.com/JuliaLang/julia/issues/34325
                    @eval @test_skip @inferred($f($T(7/2), $T(3/2), RoundNearest)) == $f(7//2, 3//2, RoundNearest)
                    @eval @test_skip @inferred($f($T(7/2), $T(1/2), RoundNearest)) == $f(7//2, 1//2, RoundNearest)
                    @eval @test_skip @inferred($f($T(9/2), 3, RoundNearest)) == $f(9//2, 3, RoundNearest)
                    @eval @test_skip @inferred($f($T(7/2), big(-2), RoundNearest)) == $f(7//2, -2, RoundNearest)
                    @eval @test_skip @inferred($f(4, $T(3/2), RoundNearest)) == $f(4, 3//2, RoundNearest)
                    @eval @test_skip @inferred($f(big(-7), $T(5/2), RoundNearest)) == $f(-7, 5//2, RoundNearest)
                end
                @eval @test @inferred($f(HalfInt32(7/2), HalfInt128(3/2), RoundNearest)) == $f(7//2, 3//2, RoundNearest)
                @eval @test @inferred($f(HalfInt8(7/2), HalfInt64(1/2), RoundNearest)) == $f(7//2, 1//2, RoundNearest)
                @eval @test @inferred($f(HalfInt16(9/2), HalfInt32(3), RoundNearest)) == $f(9//2, 3, RoundNearest)
                @eval @test @inferred($f(HalfInt64(7/2), HalfInt128(-2), RoundNearest)) == $f(7//2, -2, RoundNearest)
                @eval @test @inferred($f(HalfInt16(4), HalfInt8(3/2), RoundNearest)) == $f(4, 3//2, RoundNearest)
                @eval @test @inferred($f(HalfInt64(-7), HalfInt32(5/2), RoundNearest)) == $f(-7, 5//2, RoundNearest)
                @eval @test @inferred($f(BigHalfInt(7/2), BigHalfInt(3/2), RoundNearest)) isa $bigreturntype
                @eval @test @inferred($f(BigHalfInt(9/2), 3, RoundNearest)) isa $bigreturntype
                @eval @test @inferred($f(BigHalfInt(9/2), big(3), RoundNearest)) isa $bigreturntype
                @eval @test @inferred($f(HalfInt(9/2), big(3), RoundNearest)) isa $bigreturntype
                @eval @test @inferred($f(big(4), BigHalfInt(3/2), RoundNearest)) isa $bigreturntype
                @eval @test @inferred($f(big(4), HalfInt(3/2), RoundNearest)) isa $bigreturntype
            end
        end
    end

    @testset "Exponentiation" begin
        # Half-integer exponent
        for T in halfinttypes
            @eval @test 2^$T(5/2) ≈ √32
            @eval @test 2^$T(4) ≈ 16
            @eval @test big(2)^$T(5/2) isa BigFloat
            @eval @test big(2)^$T(5/2) ≈ √32
            @eval @test big(2)^$T(4) ≈ 16
            @eval @test 2.0^$T(5/2) ≈ √32
            @eval @test 2.0^$T(-3/2) ≈ 1/√8
            @eval @test 2.0^$T(4) ≈ 16
            @eval @test 2.0^$T(-3) ≈ 1/8
            @eval @test big(2.0)^$T(5/2) isa BigFloat
            @eval @test big(2.0)^$T(5/2) ≈ √32
            @eval @test big(2.0)^$T(-3/2) ≈ 1/√8
            @eval @test big(2.0)^$T(4) ≈ 16
            @eval @test big(2.0)^$T(-3) ≈ 1/8
            @eval @test exp($T(5/2)) ≈ exp(2.5)
            @eval @test exp($T(5/2)*im) ≈ exp(2.5*im)
            @eval @test ℯ^$T(5/2) == exp($T(5/2))
            @eval @test ℯ^($T(5/2)*im) == exp($T(5/2)*im)
        end
        for T in halfuinttypes
            @eval @test 2^$T(5/2) ≈ √32
            @eval @test 2^$T(4) ≈ 16
            @eval @test 2.0^$T(5/2) ≈ √32
            @eval @test 2.0^$T(4) ≈ 16
            @eval @test exp($T(5/2)) ≈ exp(2.5)
            @eval @test exp($T(5/2)*im) ≈ exp(2.5*im)
            @eval @test ℯ^$T(5/2) == exp($T(5/2))
            @eval @test ℯ^($T(5/2)*im) == exp($T(5/2)*im)
        end
        @test 2^BigHalfInt(5/2) isa BigFloat
        @test 2^BigHalfInt(5/2) ≈ √32
        @test 2^BigHalfInt(4) ≈ 16
        @test big(2)^BigHalfInt(5/2) isa BigFloat
        @test big(2)^BigHalfInt(5/2) ≈ √32
        @test big(2)^BigHalfInt(4) ≈ 16
        @test 2.0^BigHalfInt(5/2) isa BigFloat
        @test 2.0^BigHalfInt(5/2) ≈ √32
        @test 2.0^BigHalfInt(-3/2) ≈ 1/√8
        @test 2.0^BigHalfInt(4) ≈ 16
        @test 2.0^BigHalfInt(-3) ≈ 1/8
        @test big(2.0)^BigHalfInt(5/2) isa BigFloat
        @test big(2.0)^BigHalfInt(5/2) ≈ √32
        @test big(2.0)^BigHalfInt(-3/2) ≈ 1/√8
        @test big(2.0)^BigHalfInt(4) ≈ 16
        @test big(2.0)^BigHalfInt(-3) ≈ 1/8
        @test exp(BigHalfInt(5/2)) isa BigFloat
        @test exp(BigHalfInt(5/2)*im) isa Complex{BigFloat}
        @test exp(BigHalfInt(5/2)) ≈ exp(big(2.5))
        @test exp(BigHalfInt(5/2)*im) ≈ exp(big(2.5)*im)
        @test ℯ^BigHalfInt(5/2) ==ₜ exp(BigHalfInt(5/2))
        @test ℯ^(BigHalfInt(5/2)*im) ==ₜ exp(BigHalfInt(5/2)*im)
        # Half-integer base
        for T in halfinttypes
            @eval @test $T(2)^4 ≈ 16
            @eval @test $T(-2)^4 ≈ 16
            @eval @test $T(3/2)^3 ≈ 27/8
            @eval @test $T(-3/2)^3 ≈ -27/8
            @eval @test $T(2)^4.0 ≈ 16
            @eval @test $T(2)^3.0 ≈ 8
            @eval @test $T(-2)^4.0 ≈ 16
            @eval @test $T(-2)^3.0 ≈ -8
            @eval @test $T(3/2)^4.0 ≈ 81/16
            @eval @test $T(3/2)^3.0 ≈ 27/8
            @eval @test $T(-3/2)^4.0 ≈ 81/16
            @eval @test $T(-3/2)^3.0 ≈ -27/8
            @eval @test complex($T(2))^1.5 ≈ √8
            @eval @test complex($T(-2))^1.5 ≈ -√8*im
            @eval @test complex($T(-2))^2.5 ≈ √32*im
        end
        for T in halfuinttypes
            @eval @test $T(2)^4 ≈ 16
            @eval @test $T(3/2)^3 ≈ 27/8
            @eval @test $T(2)^4.0 ≈ 16
            @eval @test $T(3/2)^1.5 ≈ √(27/8)
        end
        @test @inferred(BigHalfInt(2)^4) isa BigFloat
        @test @inferred(BigHalfInt(2)^4.0) isa BigFloat
        @test @inferred(complex(BigHalfInt(2))^4.0) isa Complex{BigFloat}
        @test BigHalfInt(2)^4 ≈ 16
        @test BigHalfInt(-2)^4 ≈ 16
        @test BigHalfInt(3/2)^3 ≈ 27/8
        @test BigHalfInt(-3/2)^3 ≈ -27/8
        @test BigHalfInt(2)^4.0 ≈ 16
        @test BigHalfInt(2)^3.0 ≈ 8
        @test BigHalfInt(-2)^4.0 ≈ 16
        @test BigHalfInt(-2)^3.0 ≈ -8
        @test BigHalfInt(3/2)^4.0 ≈ 81/16
        @test BigHalfInt(3/2)^3.0 ≈ 27/8
        @test BigHalfInt(-3/2)^4.0 ≈ 81/16
        @test BigHalfInt(-3/2)^3.0 ≈ -27/8
        @test complex(BigHalfInt(2))^1.5 ≈ √8
        @test complex(BigHalfInt(-2))^1.5 ≈ -√8*im
        @test complex(BigHalfInt(-2))^2.5 ≈ √32*im
        # Half-integer base and exponent
        for T in halfinttypes
            @eval @test $T(2)^$T(4) ≈ 16
            @eval @test $T(2)^$T(-4) ≈ 1/16
            @eval @test $T(-2)^$T(4) ≈ 16
            @eval @test $T(-2)^$T(-4) ≈ 1/16
            @eval @test $T(3/2)^$T(3) ≈ 27/8
            @eval @test $T(3/2)^$T(-3) ≈ 8/27
            @eval @test $T(-3/2)^$T(3) ≈ -27/8
            @eval @test $T(-3/2)^$T(-3) ≈ -8/27
            @eval @test complex($T(2))^$T(3/2) ≈ √8
            @eval @test complex($T(-2))^$T(3/2) ≈ -√8*im
            @eval @test complex($T(-2))^$T(5/2) ≈ √32*im
        end
        for T in halfuinttypes
            @eval @test $T(2)^$T(4) ≈ 16
            @eval @test $T(3/2)^$T(3) ≈ 27/8
            @eval @test $T(3/2)^$T(3/2) ≈ √(27/8)
        end
        @test @inferred(BigHalfInt(2)^BigHalfInt(4)) isa BigFloat
        @test @inferred(BigHalfInt(2)^HalfInt(4)) isa BigFloat
        @test @inferred(complex(BigHalfInt(2))^BigHalfInt(4)) isa Complex{BigFloat}
        @test @inferred(complex(BigHalfInt(2))^HalfInt(4)) isa Complex{BigFloat}
        @test BigHalfInt(2)^HalfInt(4) ≈ 16
        @test BigHalfInt(2)^HalfInt(3) ≈ 8
        @test BigHalfInt(-2)^HalfInt(4) ≈ 16
        @test BigHalfInt(-2)^HalfInt(3) ≈ -8
        @test BigHalfInt(3/2)^HalfInt(4) ≈ 81/16
        @test BigHalfInt(3/2)^HalfInt(3) ≈ 27/8
        @test BigHalfInt(-3/2)^HalfInt(4) ≈ 81/16
        @test BigHalfInt(-3/2)^HalfInt(3) ≈ -27/8
        @test BigHalfInt(2)^BigHalfInt(4) ≈ 16
        @test BigHalfInt(2)^BigHalfInt(3) ≈ 8
        @test BigHalfInt(-2)^BigHalfInt(4) ≈ 16
        @test BigHalfInt(-2)^BigHalfInt(3) ≈ -8
        @test BigHalfInt(3/2)^BigHalfInt(4) ≈ 81/16
        @test BigHalfInt(3/2)^BigHalfInt(3) ≈ 27/8
        @test BigHalfInt(-3/2)^BigHalfInt(4) ≈ 81/16
        @test BigHalfInt(-3/2)^BigHalfInt(3) ≈ -27/8
        @test complex(BigHalfInt(2))^BigHalfInt(3/2) ≈ √8
        @test complex(BigHalfInt(-2))^BigHalfInt(3/2) ≈ -√8*im
        @test complex(BigHalfInt(-2))^BigHalfInt(5/2) ≈ √32*im
        @test complex(BigHalfInt(2))^HalfInt(3/2) ≈ √8
        @test complex(BigHalfInt(-2))^HalfInt(3/2) ≈ -√8*im
        @test complex(BigHalfInt(-2))^HalfInt(5/2) ≈ √32*im
    end

    @static if VERSION ≥ v"1.4.0-DEV.699"
        @testset "lcm/gcd/gcdx" begin
            @testset "Scalar-argument gcd/lcm" begin
                for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                    # One argument
                    @eval @test gcd($T(3/2)) ==ₜ $T(3/2)
                    @eval @test lcm($T(3/2)) ==ₜ $T(3/2)

                    # Two arguments
                    @eval @test lcm($T(1), $T(1/2)) ==ₜ $T(1)
                    @eval @test lcm($T(1), $T(3/2)) ==ₜ $T(3)
                    @eval @test lcm($T(2), $T(3/2)) ==ₜ $T(6)
                    @eval @test lcm($T(3/2), $T(3/2)) ==ₜ $T(3/2)
                    @eval @test lcm($T(5/2), $T(3/2)) ==ₜ $T(15/2)
                    @eval @test lcm(1, $T(1/2)) == 1
                    @eval @test lcm(1//1, $T(3/2)) == 3
                    @eval @test lcm(big(2), $T(3/2)) ==ₜ BigHalfInt(6)
                    @eval @test lcm($T(1/2), 1) == 1
                    @eval @test lcm($T(3/2), 1//1) == 3
                    @eval @test lcm($T(3/2), big(2)) ==ₜ BigHalfInt(6)
                    @eval @test lcm($T(3/2), BigHalfInt(1)) ==ₜ BigHalfInt(3)
                    @eval @test lcm(BigHalfInt(3/2), $T(2)) ==ₜ BigHalfInt(6)
                    @eval @test gcd($T(1), $T(3/2)) ==ₜ $T(1/2)
                    @eval @test gcd($T(2), $T(3/2)) ==ₜ $T(1/2)
                    @eval @test gcd($T(3), $T(3/2)) ==ₜ $T(3/2)
                    @eval @test gcd($T(3), $T(9/2)) ==ₜ $T(3/2)
                    @eval @test gcd($T(3/2), $T(3/2)) ==ₜ $T(3/2)
                    @eval @test gcd(1, $T(3/2)) == 1/2
                    @eval @test gcd(2//1, $T(3/2)) == 1/2
                    @eval @test gcd(big(3), $T(3/2)) ==ₜ BigHalfInt(3/2)
                    @eval @test gcd($T(3/2), 2) == 1/2
                    @eval @test gcd($T(3/2), 3//1) == 3/2
                    @eval @test gcd($T(9/2), big(3)) ==ₜ BigHalfInt(3/2)
                    @eval @test gcd($T(3/2), BigHalfInt(2)) ==ₜ BigHalfInt(1/2)
                    @eval @test gcd(BigHalfInt(3/2), $T(1)) ==ₜ BigHalfInt(1/2)

                    # Three arguments
                    @eval @test lcm($T(2), $T(3/2), $T(2)) ==ₜ $T(6)
                    @eval @test lcm($T(2), $T(3/2), $T(3/2)) ==ₜ $T(6)
                    @eval @test lcm($T(2), $T(3/2), $T(3)) ==ₜ $T(6)
                    @eval @test lcm($T(2), $T(3/2), $T(6)) ==ₜ $T(6)
                    @eval @test lcm($T(3/2), 2, $T(3)) == 6
                    @eval @test lcm($T(3/2), 2, 3//1) == 6
                    @eval @test lcm(2, $T(3/2), $T(3)) == 6
                    @eval @test lcm(2, $T(3/2), 3) == 6
                    @eval @test lcm(2//1, 3, $T(3/2)) == 6
                    @eval @test lcm($T(3/2), $T(3), BigHalfInt(2)) ==ₜ BigHalfInt(6)
                    @eval @test lcm(BigHalfInt(3/2), $T(2), $T(3)) ==ₜ BigHalfInt(6)
                    @eval @test gcd($T(3), $T(9/2), $T(1)) ==ₜ $T(1/2)
                    @eval @test gcd(3, 6, $T(9/2)) == 3/2
                    @eval @test gcd($T(9/2), 3//1, $T(3/2)) == 3/2
                    @eval @test gcd($T(9/2), $T(6), BigHalfInt(3)) ==ₜ BigHalfInt(3/2)
                    @eval @test gcd(BigHalfInt(9/2), $T(3), $T(3/2)) ==ₜ BigHalfInt(3/2)

                    # Four arguments
                    @eval @test lcm($T(2), $T(3/2), $T(2), $T(3)) ==ₜ $T(6)
                    @eval @test lcm($T(2), $T(3/2), $T(6), $T(3/2)) ==ₜ $T(6)
                    @eval @test lcm($T(3/2), 2, 3, $T(1/2)) == 6
                    @eval @test lcm(2//1, 3, $T(6), $T(1/2)) == 6
                    @eval @test lcm(2, 3, 6//1, $T(1/2)) == 6
                    @eval @test lcm($T(3/2), $T(3), $T(1/2), BigHalfInt(2)) ==ₜ BigHalfInt(6)
                    @eval @test lcm(BigHalfInt(3/2), $T(2), $T(3), $T(1/2)) ==ₜ BigHalfInt(6)
                    @eval @test gcd($T(3), $T(9/2), $T(3), $T(9/2)) ==ₜ $T(3/2)
                    @eval @test gcd(3, 6, $T(3/2), $T(9/2)) == 3/2
                    @eval @test gcd(3//1, 6, 2, $T(9/2)) == 1/2
                    @eval @test gcd($T(9/2), big(3), $T(3/2), $T(4)) == 1/2
                    @eval @test gcd($T(9/2), $T(6), $T(5), BigHalfInt(3)) ==ₜ BigHalfInt(1/2)
                    @eval @test gcd(BigHalfInt(9/2), $T(3), $T(3/2), $T(9)) ==ₜ BigHalfInt(3/2)
                end
                for T in (halfinttypes..., :BigHalfInt)
                    @eval @test gcd($T(-5/2), $T(3/2)) ==ₜ $T(1/2)
                end
            end

            @testset "gcd/lcm for arrays" begin
                @test lcm([HalfInt(2), HalfInt(3/2)]) === HalfInt(6)
                @test lcm([HalfInt(2), HalfInt(3/2), HalfInt(3)]) === HalfInt(6)
                @test lcm([HalfInt(3/2), 2, 3//2]) === 6//1
                @test gcd([HalfInt(3), HalfInt(9/2)]) === HalfInt(3/2)
                @test gcd([3, 9//2, HalfInt(1)]) === 1//2
                @test gcd([HalfInt(9/2), HalfInt(6), HalfInt(5), HalfInt(3)]) === HalfInt(1/2)
                @test gcd([5, 2, HalfInt(1/2)]) === HalfInt(1/2)
            end

            @testset "gcdx" begin
                for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
                    @eval @test ((d,u,v) = gcdx($T(1), $T(3/2)); u*$T(1) + v*$T(3/2) == d == 1/2)
                    @eval @test ((d,u,v) = gcdx($T(2), $T(3/2)); u*$T(2) + v*$T(3/2) == d == 1/2)
                    @eval @test ((d,u,v) = gcdx($T(3), $T(3/2)); u*$T(3) + v*$T(3/2) == d == 3/2)
                    @eval @test ((d,u,v) = gcdx($T(3), $T(9/2)); u*$T(3) + v*$T(9/2) == d == 3/2)
                    @eval @test ((d,u,v) = gcdx($T(3/2), $T(3/2)); u*$T(3/2) + v*$T(3/2) == d == 3/2)
                    @eval @test ((d,u,v) = gcdx(1, $T(3/2)); u*1 + v*$T(3/2) == d == 1/2)
                    @eval @test ((d,u,v) = gcdx(2, $T(3/2)); u*2 + v*$T(3/2) == d == 1/2)
                    @eval @test ((d,u,v) = gcdx($T(3/2), 3); u*$T(3/2) + v*3 == d == 3/2)
                    @eval @test ((d,u,v) = gcdx($T(9/2), 3); u*$T(9/2) + v*3 == d == 3/2)
                end
                for T in (halfinttypes..., :BigHalfInt)
                    @eval @test ((d,u,v) = gcdx($T(-5/2), $T(3/2)); u*$T(-5/2) + v*$T(3/2) == d == 1/2)
                    # For `UInt`s, the Bézout coefficients might be near their typemax, so the
                    # identity cannot be tested for `Rational`s since they check for overflow.
                    # Therefore, `gcdx` with one `HalfInteger` and one `Rational` argument is only
                    # tested for signed integers.
                    @eval @test ((d,u,v) = gcdx(3//2, $T(2)); u*(3//2) + v*$T(2) == d == 1/2)
                    @eval @test ((d,u,v) = gcdx($T(9/2), 3//1); u*$T(9/2) + v*(3//1) == d == 3/2)
                end
                @test gcdx(BigHalfInt(1), BigHalfInt(3/2)) isa Tuple{BigHalfInt,BigInt,BigInt}
                @test gcdx(1, BigHalfInt(3/2)) isa Tuple{BigHalfInt,BigInt,BigInt}
                @test gcdx(BigHalfInt(3/2), 1) isa Tuple{BigHalfInt,BigInt,BigInt}
                @test gcdx(1//1, BigHalfInt(3/2)) isa Tuple{Rational{BigInt},BigInt,BigInt}
                @test gcdx(BigHalfInt(3/2), 1//1) isa Tuple{Rational{BigInt},BigInt,BigInt}
            end
        end
    end

    @testset "abs" begin
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test abs($T(0)) ==ₜ $T(0)
            @eval @test abs($T(1)) ==ₜ $T(1)
            @eval @test abs($T(11/2)) ==ₜ $T(11/2)
            @eval @test abs($T(-1/2)) ==ₜ $T(1/2)
            @eval @test abs($T(-3)) ==ₜ $T(3)
        end
        for T in halfuinttypes
            @eval @test abs($T(0)) === $T(0)
            @eval @test abs($T(1)) === $T(1)
            @eval @test abs($T(11/2)) === $T(11/2)
        end
    end

    @testset "abs2" begin
        for T in halfinttypes
            @eval @test abs2($T(0)) === 0.0
            @eval @test abs2($T(1)) === 1.0
            @eval @test abs2($T(11/2)) === 30.25
            @eval @test abs2($T(-1/2)) === 0.25
            @eval @test abs2($T(-3)) === 9.0
        end
        for T in halfuinttypes
            @eval @test abs2($T(0)) === 0.0
            @eval @test abs2($T(1)) === 1.0
            @eval @test abs2($T(11/2)) === 30.25
        end
        @test abs2(BigHalfInt(0)) ==ₜ BigFloat(0.0)
        @test abs2(BigHalfInt(1)) ==ₜ BigFloat(1.0)
        @test abs2(BigHalfInt(11/2)) ==ₜ BigFloat(30.25)
        @test abs2(BigHalfInt(-1/2)) ==ₜ BigFloat(0.25)
        @test abs2(BigHalfInt(-3)) ==ₜ BigFloat(9.0)
    end

    @testset "sign" begin
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test sign($T(0)) ==ₜ $T(0)
            @eval @test sign($T(1)) ==ₜ $T(1)
            @eval @test sign($T(11/2)) ==ₜ $T(1)
            @eval @test sign($T(-1/2)) ==ₜ $T(-1)
            @eval @test sign($T(-3)) ==ₜ $T(-1)
        end
        for T in halfuinttypes
            @eval @test sign($T(0)) ==ₜ $T(0)
            @eval @test sign($T(1)) ==ₜ $T(1)
            @eval @test sign($T(11/2)) ==ₜ $T(1)
        end
    end

    @testset "signbit" begin
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test signbit($T(0)) === false
            @eval @test signbit($T(1)) === false
            @eval @test signbit($T(11/2)) === false
            @eval @test signbit($T(-1/2)) === true
            @eval @test signbit($T(-3)) === true
        end
        for T in halfuinttypes
            @eval @test signbit($T(0)) === false
            @eval @test signbit($T(1)) === false
            @eval @test signbit($T(11/2)) === false
        end
    end

    @testset "flipsign" begin
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test flipsign($T(0), $T(-3/2)) ==ₜ $T(0)
            @eval @test flipsign($T(0), 4) ==ₜ $T(0)
            @eval @test flipsign($T(11/2), $T(-7/2)) ==ₜ $T(-11/2)
            @eval @test flipsign($T(11/2), 5.0) ==ₜ $T(11/2)
            @eval @test flipsign($T(-1/2), $T(3/2)) ==ₜ $T(-1/2)
            @eval @test flipsign($T(-1/2), -1//3) ==ₜ $T(1/2)
        end
        for T in halfuinttypes
            @eval @test flipsign($T(0), $T(3/2)) ==ₜ $T(0)
            @eval @test flipsign($T(0), -5) ==ₜ $T(0)
            @eval @test flipsign($T(11/2), 1//3) ==ₜ $T(11/2)
            @eval @test flipsign($T(11/2), 0.0) ==ₜ $T(11/2)
        end
    end

    @testset "Complex" begin
        for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test $T(9/2)*im ==ₜ Complex{$T}(0, 9/2)
            @eval @test big(3) + $T(9/2)*im ==ₜ Complex{BigHalfInt}(3, 9/2)
        end
    end
end

@testset "Promotion" begin
    for T in (halfinttypes..., halfuinttypes...)
        @eval @test promote_type($T, BigInt) === BigHalfInt
        @eval @test promote_type($T, Float16) === Float16
        @eval @test promote_type($T, Float32) === Float32
        @eval @test promote_type($T, Float64) === Float64
        @eval @test promote_type($T, BigFloat) === BigFloat
        @eval @test promote_type($T, Rational{BigInt}) === Rational{BigInt}
        @eval @test promote_type($T, Complex{BigInt}) === Complex{BigHalfInt}
        @eval @test promote_type($T, Complex{Float16}) === Complex{Float16}
        @eval @test promote_type($T, Complex{Float32}) === Complex{Float32}
        @eval @test promote_type($T, Complex{Float64}) === Complex{Float64}
        @eval @test promote_type($T, Complex{BigFloat}) === Complex{BigFloat}
        @eval @test promote_type($T, Complex{Rational{BigInt}}) === Complex{Rational{BigInt}}
        @eval @test promote_type(Complex{$T}, $T) === Complex{$T}
        @eval @test promote_type(Complex{$T}, BigInt) === Complex{BigHalfInt}
        @eval @test promote_type(Complex{$T}, Float16) === Complex{Float16}
        @eval @test promote_type(Complex{$T}, Float32) === Complex{Float32}
        @eval @test promote_type(Complex{$T}, Float64) === Complex{Float64}
        @eval @test promote_type(Complex{$T}, BigFloat) === Complex{BigFloat}
        @eval @test promote_type(Complex{$T}, Rational{BigInt}) === Complex{Rational{BigInt}}
    end
    @test promote_type(HalfInt32, HalfInt16) === HalfInt32
    @test promote_type(HalfUInt, BigHalfInt) === BigHalfInt
    @test promote_type(HalfUInt, HalfInt) === HalfUInt
    @test promote_type(Rational{Int16}, HalfUInt64) === Rational{UInt64}
    @test promote_type(Complex{HalfInt64}, BigHalfInt) === Complex{BigHalfInt}
    @test promote_type(Complex{HalfUInt8}, HalfInt32) === Complex{HalfInt32}
end

@testset "Rounding" begin
    @testset "round" begin
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test round(Half{$T}(3))   ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(5/2)) ==ₜ Half{$T}(2)
            @eval @test round(Half{$T}(7/2)) ==ₜ Half{$T}(4)
            @eval @test round(Half{$T}(3),   RoundNearest) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(5/2), RoundNearest) ==ₜ Half{$T}(2)
            @eval @test round(Half{$T}(7/2), RoundNearest) ==ₜ Half{$T}(4)
            @eval @test round(Half{$T}(3),   RoundNearestTiesAway) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(5/2), RoundNearestTiesAway) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(7/2), RoundNearestTiesAway) ==ₜ Half{$T}(4)
            @eval @test round(Half{$T}(3),   RoundNearestTiesUp) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(5/2), RoundNearestTiesUp) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(7/2), RoundNearestTiesUp) ==ₜ Half{$T}(4)
            @eval @test round(Half{$T}(3),   RoundToZero) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(5/2), RoundToZero) ==ₜ Half{$T}(2)
            @eval @test round(Half{$T}(7/2), RoundToZero) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(3),   RoundDown) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(5/2), RoundDown) ==ₜ Half{$T}(2)
            @eval @test round(Half{$T}(7/2), RoundDown) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(3),   RoundUp) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(5/2), RoundUp) ==ₜ Half{$T}(3)
            @eval @test round(Half{$T}(7/2), RoundUp) ==ₜ Half{$T}(4)
            @eval @test round(Integer, Half{$T}(3))   ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(5/2)) ==ₜ $T(2)
            @eval @test round(Integer, Half{$T}(7/2)) ==ₜ $T(4)
            @eval @test round(Integer, Half{$T}(3),   RoundNearest) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(5/2), RoundNearest) ==ₜ $T(2)
            @eval @test round(Integer, Half{$T}(7/2), RoundNearest) ==ₜ $T(4)
            @eval @test round(Integer, Half{$T}(3),   RoundNearestTiesAway) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(5/2), RoundNearestTiesAway) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(7/2), RoundNearestTiesAway) ==ₜ $T(4)
            @eval @test round(Integer, Half{$T}(3),   RoundNearestTiesUp) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(5/2), RoundNearestTiesUp) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(7/2), RoundNearestTiesUp) ==ₜ $T(4)
            @eval @test round(Integer, Half{$T}(3),   RoundToZero) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(5/2), RoundToZero) ==ₜ $T(2)
            @eval @test round(Integer, Half{$T}(7/2), RoundToZero) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(3),   RoundDown) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(5/2), RoundDown) ==ₜ $T(2)
            @eval @test round(Integer, Half{$T}(7/2), RoundDown) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(3),   RoundUp) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(5/2), RoundUp) ==ₜ $T(3)
            @eval @test round(Integer, Half{$T}(7/2), RoundUp) ==ₜ $T(4)
            for S in (inttypes..., uinttypes..., :BigInt)
                @eval @test round($S, Half{$T}(3))   ==ₜ $S(3)
                @eval @test round($S, Half{$T}(5/2)) ==ₜ $S(2)
                @eval @test round($S, Half{$T}(7/2)) ==ₜ $S(4)
                @eval @test round($S, Half{$T}(3),   RoundNearest) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(5/2), RoundNearest) ==ₜ $S(2)
                @eval @test round($S, Half{$T}(7/2), RoundNearest) ==ₜ $S(4)
                @eval @test round($S, Half{$T}(3),   RoundNearestTiesAway) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(5/2), RoundNearestTiesAway) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(7/2), RoundNearestTiesAway) ==ₜ $S(4)
                @eval @test round($S, Half{$T}(3),   RoundNearestTiesUp) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(5/2), RoundNearestTiesUp) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(7/2), RoundNearestTiesUp) ==ₜ $S(4)
                @eval @test round($S, Half{$T}(3),   RoundToZero) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(5/2), RoundToZero) ==ₜ $S(2)
                @eval @test round($S, Half{$T}(7/2), RoundToZero) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(3),   RoundDown) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(5/2), RoundDown) ==ₜ $S(2)
                @eval @test round($S, Half{$T}(7/2), RoundDown) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(3),   RoundUp) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(5/2), RoundUp) ==ₜ $S(3)
                @eval @test round($S, Half{$T}(7/2), RoundUp) ==ₜ $S(4)
            end
        end
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test round($T(-7))   == -7
            @eval @test round($T(-3/2)) == -2
            @eval @test round($T(-9/2)) == -4
            @eval @test round($T(-7),   RoundNearest) == -7
            @eval @test round($T(-3/2), RoundNearest) == -2
            @eval @test round($T(-9/2), RoundNearest) == -4
            @eval @test round($T(-7),   RoundNearestTiesAway) == -7
            @eval @test round($T(-3/2), RoundNearestTiesAway) == -2
            @eval @test round($T(-9/2), RoundNearestTiesAway) == -5
            @eval @test round($T(-7),   RoundNearestTiesUp) == -7
            @eval @test round($T(-3/2), RoundNearestTiesUp) == -1
            @eval @test round($T(-9/2), RoundNearestTiesUp) == -4
            @eval @test round($T(-7),   RoundToZero) == -7
            @eval @test round($T(-3/2), RoundToZero) == -1
            @eval @test round($T(-9/2), RoundToZero) == -4
            @eval @test round($T(-7),   RoundDown) == -7
            @eval @test round($T(-3/2), RoundDown) == -2
            @eval @test round($T(-9/2), RoundDown) == -5
            @eval @test round($T(-7),   RoundUp) == -7
            @eval @test round($T(-3/2), RoundUp) == -1
            @eval @test round($T(-9/2), RoundUp) == -4
            for S in (:Integer, inttypes..., :BigInt)
                @eval @test round($S, $T(-7))   == -7
                @eval @test round($S, $T(-3/2)) == -2
                @eval @test round($S, $T(-9/2)) == -4
                @eval @test round($S, $T(-7),   RoundNearest) == -7
                @eval @test round($S, $T(-3/2), RoundNearest) == -2
                @eval @test round($S, $T(-9/2), RoundNearest) == -4
                @eval @test round($S, $T(-7),   RoundNearestTiesAway) == -7
                @eval @test round($S, $T(-3/2), RoundNearestTiesAway) == -2
                @eval @test round($S, $T(-9/2), RoundNearestTiesAway) == -5
                @eval @test round($S, $T(-7),   RoundNearestTiesUp) == -7
                @eval @test round($S, $T(-3/2), RoundNearestTiesUp) == -1
                @eval @test round($S, $T(-9/2), RoundNearestTiesUp) == -4
                @eval @test round($S, $T(-7),   RoundToZero) == -7
                @eval @test round($S, $T(-3/2), RoundToZero) == -1
                @eval @test round($S, $T(-9/2), RoundToZero) == -4
                @eval @test round($S, $T(-7),   RoundDown) == -7
                @eval @test round($S, $T(-3/2), RoundDown) == -2
                @eval @test round($S, $T(-9/2), RoundDown) == -5
                @eval @test round($S, $T(-7),   RoundUp) == -7
                @eval @test round($S, $T(-3/2), RoundUp) == -1
                @eval @test round($S, $T(-9/2), RoundUp) == -4
            end
            for S in uinttypes
                @eval @test_throws InexactError round($S, $T(-7))
                @eval @test_throws InexactError round($S, $T(-3/2))
                @eval @test_throws InexactError round($S, $T(-9/2))
                @eval @test_throws InexactError round($S, $T(-7),   RoundNearest)
                @eval @test_throws InexactError round($S, $T(-3/2), RoundNearest)
                @eval @test_throws InexactError round($S, $T(-9/2), RoundNearest)
                @eval @test_throws InexactError round($S, $T(-7),   RoundNearestTiesAway)
                @eval @test_throws InexactError round($S, $T(-3/2), RoundNearestTiesAway)
                @eval @test_throws InexactError round($S, $T(-9/2), RoundNearestTiesAway)
                @eval @test_throws InexactError round($S, $T(-7),   RoundNearestTiesUp)
                @eval @test_throws InexactError round($S, $T(-3/2), RoundNearestTiesUp)
                @eval @test_throws InexactError round($S, $T(-9/2), RoundNearestTiesUp)
                @eval @test_throws InexactError round($S, $T(-7),   RoundToZero)
                @eval @test_throws InexactError round($S, $T(-3/2), RoundToZero)
                @eval @test_throws InexactError round($S, $T(-9/2), RoundToZero)
                @eval @test_throws InexactError round($S, $T(-7),   RoundDown)
                @eval @test_throws InexactError round($S, $T(-3/2), RoundDown)
                @eval @test_throws InexactError round($S, $T(-9/2), RoundDown)
                @eval @test_throws InexactError round($S, $T(-7),   RoundUp)
                @eval @test_throws InexactError round($S, $T(-3/2), RoundUp)
                @eval @test_throws InexactError round($S, $T(-9/2), RoundUp)
            end
        end
    end

    @testset "ceil/floor/trunc" begin
        for T in (inttypes..., uinttypes..., :BigInt)
            @eval @test ceil(Half{$T}(3))   ==ₜ Half{$T}(3)
            @eval @test ceil(Half{$T}(5/2)) ==ₜ Half{$T}(3)
            @eval @test ceil(Half{$T}(7/2)) ==ₜ Half{$T}(4)
            @eval @test floor(Half{$T}(3))   ==ₜ Half{$T}(3)
            @eval @test floor(Half{$T}(5/2)) ==ₜ Half{$T}(2)
            @eval @test floor(Half{$T}(7/2)) ==ₜ Half{$T}(3)
            @eval @test trunc(Half{$T}(3))   ==ₜ Half{$T}(3)
            @eval @test trunc(Half{$T}(5/2)) ==ₜ Half{$T}(2)
            @eval @test trunc(Half{$T}(7/2)) ==ₜ Half{$T}(3)
            @eval @test ceil(Integer, Half{$T}(3))   ==ₜ $T(3)
            @eval @test ceil(Integer, Half{$T}(5/2)) ==ₜ $T(3)
            @eval @test ceil(Integer, Half{$T}(7/2)) ==ₜ $T(4)
            @eval @test floor(Integer, Half{$T}(3))   ==ₜ $T(3)
            @eval @test floor(Integer, Half{$T}(5/2)) ==ₜ $T(2)
            @eval @test floor(Integer, Half{$T}(7/2)) ==ₜ $T(3)
            @eval @test trunc(Integer, Half{$T}(3))   ==ₜ $T(3)
            @eval @test trunc(Integer, Half{$T}(5/2)) ==ₜ $T(2)
            @eval @test trunc(Integer, Half{$T}(7/2)) ==ₜ $T(3)
            for S in (inttypes..., uinttypes..., :BigInt)
                @eval @test ceil($S, Half{$T}(3))   ==ₜ $S(3)
                @eval @test ceil($S, Half{$T}(5/2)) ==ₜ $S(3)
                @eval @test ceil($S, Half{$T}(7/2)) ==ₜ $S(4)
                @eval @test floor($S, Half{$T}(3))   ==ₜ $S(3)
                @eval @test floor($S, Half{$T}(5/2)) ==ₜ $S(2)
                @eval @test floor($S, Half{$T}(7/2)) ==ₜ $S(3)
                @eval @test trunc($S, Half{$T}(3))   ==ₜ $S(3)
                @eval @test trunc($S, Half{$T}(5/2)) ==ₜ $S(2)
                @eval @test trunc($S, Half{$T}(7/2)) ==ₜ $S(3)
            end
        end
        for T in (halfinttypes..., :BigHalfInt)
            @eval @test ceil($T(-7))   == -7
            @eval @test ceil($T(-3/2)) == -1
            @eval @test ceil($T(-9/2)) == -4
            @eval @test floor($T(-7))   == -7
            @eval @test floor($T(-3/2)) == -2
            @eval @test floor($T(-9/2)) == -5
            @eval @test trunc($T(-7))   == -7
            @eval @test trunc($T(-3/2)) == -1
            @eval @test trunc($T(-9/2)) == -4
            for S in (:Integer, inttypes..., :BigInt)
                @eval @test ceil($S, $T(-7))   == -7
                @eval @test ceil($S, $T(-3/2)) == -1
                @eval @test ceil($S, $T(-9/2)) == -4
                @eval @test floor($S, $T(-7))   == -7
                @eval @test floor($S, $T(-3/2)) == -2
                @eval @test floor($S, $T(-9/2)) == -5
                @eval @test trunc($S, $T(-7))   == -7
                @eval @test trunc($S, $T(-3/2)) == -1
                @eval @test trunc($S, $T(-9/2)) == -4
            end
            for S in uinttypes
                @eval @test ceil($S, $T(-1/2)) == 0
                @eval @test trunc($S, $T(-1/2)) == 0
                @eval @test_throws InexactError ceil($S, $T(-7))
                @eval @test_throws InexactError ceil($S, $T(-3/2))
                @eval @test_throws InexactError ceil($S, $T(-9/2))
                @eval @test_throws InexactError floor($S, $T(-7))
                @eval @test_throws InexactError floor($S, $T(-3/2))
                @eval @test_throws InexactError floor($S, $T(-9/2))
                @eval @test_throws InexactError trunc($S, $T(-7))
                @eval @test_throws InexactError trunc($S, $T(-3/2))
                @eval @test_throws InexactError trunc($S, $T(-9/2))
            end
        end
    end
end

@testset "Hashing" begin
    for T in (halfinttypes..., halfuinttypes..., :BigHalfInt)
        @eval @test @inferred(hash($T(1))) === hash(1)
        @eval @test @inferred(hash($T(5/2))) === hash(5//2)
    end
    for T in (inttypes..., uinttypes...)
        @eval @test @inferred(hash(half(typemax($T)))) === hash(typemax($T)//2)
        @eval @test @inferred(hash(half(typemin($T)))) === hash(typemin($T)//2)
    end
    @test @inferred(hash(half(-393050634124102232869567034555427371542904833))) ===
        hash(-393050634124102232869567034555427371542904833//2)
end

@testset "widen" begin
    @test widen(HalfInt8) === HalfInt16
    @test widen(HalfInt16) === HalfInt32
    @test widen(HalfInt32) === HalfInt64
    @test widen(HalfInt64) === HalfInt128
    @test widen(HalfInt128) === BigHalfInt
    @test widen(HalfUInt8) === HalfUInt16
    @test widen(HalfUInt16) === HalfUInt32
    @test widen(HalfUInt32) === HalfUInt64
    @test widen(HalfUInt64) === HalfUInt128
    @test widen(HalfUInt128) === BigHalfInt
    @test widen(BigHalfInt) === BigHalfInt
    @test widen(HalfUInt8(5/2)) === HalfUInt16(5/2)
    @test widen(HalfInt64(5/2)) === HalfInt128(5/2)
    @test widen(complex(HalfUInt8(5/2))) === complex(HalfUInt16(5/2))
    @test widen(complex(HalfInt64(5/2))) === complex(HalfInt128(5/2))
end

@testset "Trigonometry" begin
    fs = @static if VERSION ≥ v"1.6.0-DEV.292"
        (:sinpi, :cospi, :sincospi)
    else
        (:sinpi, :cospi)
    end
    for f = fs
        for T = inttypes
            @eval xs = half.(Half{$T}, [0, 1, -2, 4, 5, -5,
                                        typemax($T), typemax($T)-1, typemax($T)-2, typemax($T)-3,
                                        typemin($T), typemin($T)+1, typemin($T)+2, typemin($T)+3])
            @eval @test typeof(@inferred($f(zero(Half{$T})))) === typeof($f(zero(Rational{$T})))
            for x = xs
                @eval @test isequal($f($x), $f(Rational{BigInt}($x)))
            end
        end
        for T = uinttypes
            @eval xs = half.(Half{$T}, [0, 1, 2, 4, 5, 7,
                                        typemax($T), typemax($T)-1, typemax($T)-2, typemax($T)-3])
            @eval @test typeof(@inferred($f(zero(Half{$T})))) === typeof($f(zero(Rational{$T})))
            for x = xs
                @eval @test isequal($f($x), $f(Rational{BigInt}($x)))
            end
        end
        @eval @test typeof(@inferred($f(zero(BigHalfInt)))) === typeof($f(zero(Rational{BigInt})))
        for x = BigHalfInt[0, 1/2, 1, 2, 5/2, 7/2]
            @eval @test isequal($f($x), $f(Rational{BigInt}($x)))
        end
    end
end

@testset "$f" for (f,eq) = ((:sinc,:isequal), (:cosc,:isapprox))
    for T = (inttypes..., :BigInt)
        @eval xs = half.(Half{$T}, -20:20)
        @eval @test typeof(@inferred($f(zero(Half{$T})))) === float($T)
        for x = xs
            @eval @test $eq($f($x), $f(float($x)))
        end
    end
    for T = uinttypes
        @eval xs = half.(Half{$T}, 0:20)
        @eval @test typeof(@inferred($f(zero(Half{$T})))) === float($T)
        for x = xs
            @eval @test $eq($f($x), $f(float($x)))
        end
    end
end

@testset "Parsing" begin
    @testset "Half{<:Signed}" begin
        for T in halfinttypes
            @eval @test tryparse($T, "4") === $T(4)
            @eval @test tryparse($T, "+1/2\n") === $T(1/2)
            @eval @test tryparse($T, " 5 /2") === $T(5/2)
            @eval @test tryparse($T, " -5 / 2") === $T(-5/2)
            @eval @test tryparse($T, " +-3/2") === nothing
            @eval @test tryparse($T, " 5/3") === nothing
            @eval @test tryparse($T, "e/2") === nothing
            @eval @test @inferred(parse($T, "4")) === $T(4)
            @eval @test parse($T, "+1/2\n") === $T(1/2)
            @eval @test parse($T, " 5 /2") === $T(5/2)
            @eval @test parse($T, " -5 / 2") === $T(-5/2)
            @eval @test_throws ArgumentError parse($T, " +-3/2")
            @eval @test_throws ArgumentError parse($T, " 5/3")
            @eval @test_throws ArgumentError parse($T, "e/2")
        end
    end

    @testset "Half{<:Unsigned}" begin
        for T in halfuinttypes
            @eval @test tryparse($T, "4") === $T(4)
            @eval @test tryparse($T, " 1/2\n") === $T(1/2)
            @eval @test tryparse($T, " 5 /2") === $T(5/2)
            @eval @test tryparse($T, " +5 / 2") === nothing
            @eval @test tryparse($T, " -5 / 2") === nothing
            @eval @test tryparse($T, " +-3/2") === nothing
            @eval @test tryparse($T, " 5/3") === nothing
            @eval @test tryparse($T, "e/2") === nothing
            @eval @test @inferred(parse($T, "4")) === $T(4)
            @eval @test parse($T, " 1/2\n") === $T(1/2)
            @eval @test parse($T, " 5 /2") === $T(5/2)
            @eval @test_throws ArgumentError parse($T, " +5 / 2")
            @eval @test_throws ArgumentError parse($T, " -5 / 2")
            @eval @test_throws ArgumentError parse($T, " +-3/2")
            @eval @test_throws ArgumentError parse($T, " 5/3")
            @eval @test_throws ArgumentError parse($T, "e/2")
        end
    end

    @testset "BigHalfInt" begin
        @test tryparse(BigHalfInt, "123456789123456789123456789123456789123456789") ==ₜ
            BigHalfInt(123456789123456789123456789123456789123456789)
        @test tryparse(BigHalfInt, "123456789123456789123456789123456789123456789/2") ==ₜ
            BigHalfInt(123456789123456789123456789123456789123456789//2)
        @eval @test tryparse(BigHalfInt, "4") ==ₜ BigHalfInt(4)
        @eval @test tryparse(BigHalfInt, "+1/2\n") ==ₜ BigHalfInt(1/2)
        @eval @test tryparse(BigHalfInt, " -5 / 2") ==ₜ BigHalfInt(-5/2)
        @eval @test tryparse(BigHalfInt, " +-3/2") === nothing
        @eval @test tryparse(BigHalfInt, " 5/3") === nothing
        @eval @test tryparse(BigHalfInt, "e/2") === nothing
        @test parse(BigHalfInt, "123456789123456789123456789123456789123456789") ==ₜ 
            BigHalfInt(123456789123456789123456789123456789123456789)
        @test parse(BigHalfInt, "123456789123456789123456789123456789123456789/2") ==ₜ 
            BigHalfInt(123456789123456789123456789123456789123456789//2)
        @eval @test parse(BigHalfInt, "4") ==ₜ BigHalfInt(4)
        @eval @test parse(BigHalfInt, "+1/2\n") ==ₜ BigHalfInt(1/2)
        @eval @test parse(BigHalfInt, " -5 / 2") ==ₜ BigHalfInt(-5/2)
        @eval @test_throws ArgumentError parse(BigHalfInt, " +-3/2")
        @eval @test_throws ArgumentError parse(BigHalfInt, " 5/3")
        @eval @test_throws ArgumentError parse(BigHalfInt, "e/2")
    end
end

@testset "string" begin
    for T in (halfinttypes..., :BigHalfInt)
        @eval @test string($T(3/2)) === "3/2"
        @eval @test string($T(5)) === "5"
        @eval @test string($T(-3/2)) === "-3/2"
        @eval @test string($T(-5)) === "-5"
    end
    for T in halfuinttypes
        @eval @test string($T(3/2)) === "3/2"
        @eval @test string($T(5)) === "5"
    end
end

@testset "Missing" begin
    @test twice(missing) === missing
    for T = (halfinttypes..., halfuinttypes..., :BigHalfInt)
        for S = (inttypes..., uinttypes..., :BigInt)
            @eval @test twice(Union{$S,Missing}, $T(5/2)) ==ₜ $S(5)
            @eval @test twice(Union{$S,Missing}, Complex{$T}(5/2)) ==ₜ $S(5)
            @eval @test twice(Union{Complex{$S},Missing}, $T(5/2)) ==ₜ Complex{$S}(5)
            @eval @test twice(Union{Complex{$S},Missing}, Complex{$T}(5/2 + 3/2*im)) ==ₜ Complex{$S}(5 + 3im)
        end
    end
    for T = (inttypes..., uinttypes..., :BigInt)
        @eval @test twice(Union{$T,Missing}, missing) === missing
        @eval @test twice(Union{Complex{$T},Missing}, missing) === missing
        @eval @test_throws MissingException twice($T, missing)
        @eval @test_throws MissingException twice(Complex{$T}, missing)
    end

    @test half(missing) === missing
    for T = (inttypes..., uinttypes..., :BigInt)
        for S = (halfinttypes..., halfuinttypes..., :BigHalfInt)
            @eval @test half(Union{$S,Missing}, $T(5)) ==ₜ $S(5/2)
            @eval @test half(Union{$S,Missing}, Complex{$T}(5)) ==ₜ $S(5/2)
            @eval @test half(Union{Complex{$S},Missing}, $T(5)) ==ₜ Complex{$S}(5/2)
            @eval @test half(Union{Complex{$S},Missing}, Complex{$T}(5 + 3*im)) ==ₜ Complex{$S}(5/2 + 3/2*im)
        end
    end
    for T = (halfinttypes..., halfuinttypes..., :BigHalfInt)
        @eval @test half(Union{$T,Missing}, missing) === missing
        @eval @test half(Union{Complex{$T},Missing}, missing) === missing
        @eval @test_throws MissingException half($T, missing)
        @eval @test_throws MissingException half(Complex{$T}, missing)
    end

    @test onehalf(missing) === onehalf(Missing) === missing

    @test ishalfinteger(missing) === missing
end

include("ranges.jl")
include("checked.jl")
include("customtypes.jl")

# HalfIntegers.jl

*HalfIntegers.jl* provides data types for half-integer numbers. Here, any number ``\frac{n}{2}`` where ``n\in\mathbb{Z}`` is considered a half-integer -- contrary to the common definition, ``n`` does not have to be odd, i.e., the integers are a subset of the half-integers.

The package defines the abstract `HalfInteger` type and the concrete implementation `Half{T}` for half-integers ``\frac{n}{2}`` where ``n`` is of type `T`.
Functions for convenient use are defined as well.

## Installation

HalfIntegers.jl is compatible with Julia ≥ 1.0.
It can be installed by typing
```
] add HalfIntegers
```
in the Julia REPL or via
```julia
using Pkg; Pkg.add("HalfIntegers")
```

## Contents

```@contents
Pages = ["manual.md", "api.md"]
```

## Index

```@index
```

```@meta
CollapsedDocStrings = true
```

# API documentation

```@index
Modules=[HalfIntegers]
```

## Types

```@autodocs
Modules=[HalfIntegers]
Order=[:type]
```

## Functions

```@autodocs
Modules=[HalfIntegers]
Order=[:function]
```

# Manual

## Half-integer types

```@meta
DocTestSetup = quote using HalfIntegers end
```
```@setup halfintegers
using HalfIntegers
```

!!! note
    In this package, any number ``\frac{n}{2}`` where ``n\in\mathbb{Z}`` is considered a half-integer -- contrary to the common definition, ``n`` does not have to be odd, i.e., the integers are a subset of the half-integers.

The abstract type `HalfInteger <: Real` is provided as a supertype for all half-integer types.
Concrete half-integer types are provided in the form of the parametric type `Half{T} <: HalfInteger` where `T` can be any `Integer` type.
The type `Half{T}` can represent any number `n/2` where `n` is of type `T`.

```@repl halfintegers
Half{Int}(5//2)
Half{Int8}(3)
ans isa HalfInteger
typemin(Half{Int8}), typemax(Half{Int8})
```

For convenient use, aliases for `Half{T}` exist for all standard integer types `T` defined in Julia (except for `Bool`).
For example, `HalfInt` can be used instead of `Half{Int}`:

```@repl halfintegers
HalfInt(3.5)
typeof(ans) # Half{Int32} or Half{Int64} depending on on system word size
```

The following aliases are defined:

| `T`       | Alias for `Half{T}`                |
| :-------- | :--------------------------------- |
| `Int`     | `HalfInt`                          |
| `Int8`    | `HalfInt8`                         |
| `Int16`   | `HalfInt16`                        |
| `Int32`   | `HalfInt32`                        |
| `Int64`   | `HalfInt64`                        |
| `Int128`  | `HalfInt128`                       |
| `BigInt`  | `BigHalfInt` (*not* `HalfBigInt`!) |
| `UInt`    | `HalfUInt`                         |
| `UInt8`   | `HalfUInt8`                        |
| `UInt16`  | `HalfUInt16`                       |
| `UInt32`  | `HalfUInt32`                       |
| `UInt64`  | `HalfUInt64`                       |
| `UInt128` | `HalfUInt128`                      |

## Construction of `HalfInteger`s

`HalfInteger`s can be created from any other number type using constructors or `convert`:

```@repl halfintegers
HalfUInt(5.5)
convert(BigHalfInt, 3//2)
convert(Complex{HalfInt}, 2.5 + 3.5im)
```

Alternatively, one can use the `half` function, which halves its argument and returns an appropriate `HalfInteger` or `Complex{<:HalfInteger}` type:

```@repl halfintegers
half(3)
half(4.0)
half(3 - 4im)
```

Note that the argument must be an integer value (or a complex value with integer real and imaginary parts), but does not need to be of an `Integer` or `Complex{<:Integer}` type.
An optional argument can be used to specify the return type, which must be `<:HalfInteger` or `<:Complex{<:HalfInteger}`:

```@repl halfintegers
half(BigHalfInt, -11)
half(Complex{HalfInt}, 4+1im)
```

Calling the `Half` constructor without type parameter is disallowed to avoid confusion with the `half` function.

## Conversion

`HalfInteger`s can be converted to any other number type in the usual ways. When the value is not representable in the new type, an error is thrown:
```@repl halfintegers
Float32(HalfInt(3/2))
convert(Rational{Int}, HalfInt(-5))
float(HalfInt(2))
complex(HalfInt(-1/2))
convert(Int, HalfInt(7/2))
```

!!! note
    The fastest way of converting a `HalfInteger` to an `Integer` type is the `floor` function, since it reduces to a single bit-shift:
    ```@repl halfintegers
    julia> floor(Integer, HalfInt(5)) # returns an Int
    5
    ```
    Thus, `convert(Integer, x)` can be replaced by `floor(Integer, x)` when it is known that `x` is equal to an integer. This can be useful in performance-critical applications.

## Arithmetic operations

The provided half-integer types support all common arithmetic operations.
For operations between different types, the values are promoted to an appropriate type:

```@repl halfintegers
HalfInt(1/2) + HalfInt(5)
HalfInt(1/2) + 5
HalfInt(1/2) + 5.0
complex(HalfInt(1/2)) + 5//1
```

Since the product of two half-integers is not a half-integer (unless one of them is actually an integer), multiplication of two `HalfInteger`s results in a floating-point number.
Multiplication of a `HalfInteger` and an `Integer` yields another `HalfInteger`:

```@repl halfintegers
HalfInt(1/2) * HalfInt(7/2)
HalfInt(1/2) * HalfInt(5)
HalfInt(1/2) * 5
```

Dividing two half-integers result in a floating-point number as well, but rational and Euclidean division are defined as well:

```@repl halfintegers
HalfInt(7/2) / HalfInt(3/2)
HalfInt(7/2) // HalfInt(3/2)
HalfInt(7/2) ÷ HalfInt(3/2)
```

!!! note
    The `HalfInteger` type aims to support every operation that is implemented for `Rational`s in `Base`.
    Some operations are only available in newer Julia versions.
    For example, `gcd` for rational numbers is only defined in Julia 1.4 or newer, and is therefore only extended to `HalfInteger`s in those Julia versions.

## Auxiliary functions

### `twice`

The `twice` function can be regarded as the inverse of the `half` function: it doubles its argument.
However, in contrast to `half`, which always returns a `HalfInteger` or `Complex{<:HalfInteger}`, `twice` only returns an `Integer` when the argument is a `HalfInteger` or an `Integer`.
Alternatively, the return type of `twice` can be specified with an optional first argument:

```@repl halfintegers
twice(HalfInt32(5/2)) # returns an Int32
twice(3.5)            # returns a Float64
twice(Integer, 3.5)   # returns an Int
```

Furthermore, while `half` only accepts integer values (or complex values with integer components), the argument of `twice` may have any numeric value:

```@repl halfintegers
twice(3//8)
half(ans)
```

### `onehalf`

Analogous to `zero` and `one`, the function `onehalf` returns the value 1/2 in the specified type (the argument may be a value of the desired type or the type itself):

```@repl halfintegers
onehalf(HalfInt)
onehalf(big"2.0")
onehalf(7//3)
```

### `ishalfinteger`

The function `ishalfinteger` can be used to check whether a number is equal to some half-integer:

```@repl halfintegers
ishalfinteger(0.5)
ishalfinteger(4)
ishalfinteger(1//3)
```

## Wraparound behavior

Since the implementation of the `HalfInteger` type is based on the underlying integers (e.g., standard `Int` arithmetic in the case of the `HalfInt` type), `HalfInteger`s may be subject to [integer overflow](https://docs.julialang.org/en/v1/manual/integers-and-floating-point-numbers/#Overflow-behavior-1):

```jldoctest
julia> typemax(HalfInt64)
9223372036854775807/2

julia> ans + onehalf(HalfInt64)
-4611686018427387904
```

The behavior in the above example is due to `9223372036854775807 + 1 == -9223372036854775808`.

Overflows can also occur when converting an `Integer` to a `HalfInteger` type (which may happen implicitly due to promotion):

```jldoctest
julia> typemax(Int64)
9223372036854775807

julia> HalfInt64(ans)  # 2 * 9223372036854775807 == -2
-1
```

If you prefer checked arithmetic, you can use functions like `Base.checked_add`:

```jldoctest
julia> typemax(HalfInt64)
9223372036854775807/2

julia> Base.checked_add(ans, onehalf(HalfInt64))
ERROR: OverflowError: 9223372036854775807 + 1 overflowed for type Int64
```

A `HalfIntegers.checked_twice` function exists as well.
Alternatively, you can use the [SaferIntegers](https://github.com/JeffreySarnoff/SaferIntegers.jl) package:

```jldoctest
julia> using SaferIntegers

julia> const SafeHalfInt64 = Half{SafeInt64}
Half{SafeInt64}

julia> typemax(SafeHalfInt64)
9223372036854775807/2

julia> ans + onehalf(SafeHalfInt64)
ERROR: OverflowError: 9223372036854775807 + 1 overflowed for type Int64
```

!!! compat
    Using `Base.checked_add` etc. with `HalfInteger`s requires HalfIntegers ≥ 1.4.
    The SaferIntegers package can be used with every HalfIntegers version.
    However, due to a [bug](https://github.com/JuliaLang/julia/issues/32203), the `Half{SafeInt8}`, `Half{SafeInt16}`, `Half{SafeUInt8}` and `Half{SafeUInt16}` types require Julia ≥ 1.1 to work correctly.

## Custom `HalfInteger` types

To implement a custom type `MyHalfInt <: HalfInteger`, at least the following methods must be defined:

| Required method | Brief description |
| :-------------- | :---------------- |
| `half(::Type{MyHalfInt}, x)` | Return `x/2` as a value of type `MyHalfInt` |
| `twice(x::MyHalfInt)`        | Return `2x` as a value of some `Integer` type |

Thus, a simple implementation of a custom `HalfInteger` type may look like this:

```@example halfintegers
struct MyHalfInt <: HalfInteger
    val::HalfInt
end

MyHalfInt(x::MyHalfInt) = x  # to avoid method ambiguity

HalfIntegers.half(::Type{MyHalfInt}, x) = MyHalfInt(half(HalfInt, x))

HalfIntegers.twice(x::MyHalfInt) = twice(x.val)
nothing # hide
```

The `MyHalfInt` type supports all arithmetic operations defined for `HalfInteger`s. However, some operations will return values of a `Half{T}` type, which may not be desirable:

```@repl halfintegers
MyHalfInt(3/2) + MyHalfInt(2)
typeof(ans)
```

The following sections describe how to customize this behavior.

### Customizing arithmetic operators and functions

The operators/functions that return a `Half{T}` type are `+`, `-`, `mod` and `rem` (and other functions that make use of those, like `round`).
If we want those operations to return `MyHalfInt`s, we can define the following methods (note that both one- and two-argument versions of `+` and `-` are defined):

```@example halfintegers
Base.:+(x::MyHalfInt) = x
Base.:+(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(x.val + y.val)

Base.:-(x::MyHalfInt) = MyHalfInt(-x.val)
Base.:-(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(x.val - y.val)

Base.mod(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(mod(x.val, y.val))
Base.rem(x::MyHalfInt, y::MyHalfInt) = MyHalfInt(rem(x.val, y.val))
nothing # hide
```

Now, these arithmetic operations will return a `MyHalfInt` for `MyHalfInt` arguments.
Certain operations will still yield other types:
* `*` and `/` return floating-point numbers,
* `div`, `fld`, `cld` etc. return values of some `Integer` type.
To change this behavior, we would need to define methods for these functions as well.
For example, if we want our `MyHalfInt` type to return a `Rational` for multiplication and division, we could define the following methods:

```@example halfintegers
Base.:*(x::MyHalfInt, y::MyHalfInt) = twice(x)*twice(y)//4
Base.:/(x::MyHalfInt, y::MyHalfInt) = twice(x)//twice(y)
nothing # hide
```

### Promotion rules

In order to make mixed-type operations work with our `MyHalfInt` type, promotion rules need to be defined.
As a simple example, we can define our `MyHalfInt` type to promote like `HalfInt` as follows:

```@example halfintegers
Base.promote_rule(::Type{MyHalfInt}, T::Type{<:Real}) = promote_type(HalfInt, T)
nothing # hide
```

For more information on how to define promotion rules, cf. the
[Julia documentation](https://docs.julialang.org/en/v1/manual/conversion-and-promotion/#Promotion-1).

### Ranges of custom `HalfInteger` types

Ranges of custom `HalfInteger` types should work if either custom arithmetics or promotion rules are defined.
However, intersecting these ranges may again yield ranges of `Half{T}` values:

```@repl halfintegers
a = MyHalfInt(3/2):MyHalfInt(3/2):MyHalfInt(15/2)
b = MyHalfInt(2):MyHalfInt(1):MyHalfInt(9)
intersect(a, b)
typeof(ans)
```

In order to change this behavior, custom methods for `Base.intersect` need to be defined as well.
